//*******************************************************************
//			    	IRIS-MAINPj^vO J[h֐
//*******************************************************************
#include "IrisMon.h"



#ifdef TEST_CARD_BY_MAINP


//--------------------- O[o ϐ  -------------------------------


CardIntrWork  cardIntrWork;




//----------------------------------------------------------------------
//     					R}hݒ
//----------------------------------------------------------------------

void SetCardOp(const CardCtrlParam *paramp)
{
	int  i;

	WaitCardDma(paramp->dmaNo);										// J[h]I҂

	*(vu8 *)REG_CARD_MASTER_CNT = CARDMST_SEL_ROM					// }X^[Cl[u
								| CARDMST_ENABLE | CARDMST_IF_ENABLE;

	for (i=0; i<2; i++) {											// R}hݒ
		u32	opTmp = paramp->op[1 - i];
		vu8 *opDestBasep = (vu8 *)(REG_CARD_CMD + i*4);

		opDestBasep[0] = opTmp >>24;
		opDestBasep[1] = opTmp >>16;
		opDestBasep[2] = opTmp >>8;
		opDestBasep[3] = opTmp >>0;
	}
}


//----------------------------------------------------------------------
//     					J[h҂  DMA~
//----------------------------------------------------------------------

void WaitCardDma(u32 dmaNo)
{
	WaitCard();

	if (dmaNo <= 3)		StopDma(dmaNo);
}


//----------------------------------------------------------------------
//     					J[hy[Wǂݍ݁iGAME[h^j
//----------------------------------------------------------------------

void ReadCard4Game(void *romp, void *ramp, s32 size, u32 cntParam)
{
	CardCtrlParam param;
	s32  restSize = size;
	s32  blockSize = MROM_PAGE_SIZE;

	param.cardCnt = cntParam									// Rg[ݒ 
					| CARD_READ_MODE | CARD_1_PAGE
					| CARD_START | CARD_RESET_HI;
	param.dmaNo = 3;											// DMAԍw

	while (restSize > 0) {										// ubNǂݍ
		ReadCardAsync4Game(romp, ramp, blockSize, &param);

		(u8 *)romp += blockSize;
		(u8 *)ramp += blockSize;
		restSize   -= blockSize;
	}

	WaitCardDma(param.dmaNo);
}


//----------------------------------------------------------------------
//     					J[hǂݍ݁iDMA񓯊j
//----------------------------------------------------------------------

void ReadCardAsync(void *romp, void *ramp, s32 size, CardCtrlParam *paramp)
{
	SetCardOp(paramp);											// R}hݒ

	if (paramp->dmaNo <= 3) {
		DmaReadCard(paramp->dmaNo, ramp);						// DMAݒiőݒ DMA0-2: 64KB / DMA3: 256KBj
		*(vu32 *)REG_CARDCNT = paramp->cardCnt;					// Rg[ݒ & DMAX^[g
	} else {
		void *ramEndp;
		u32 cardCntTmp;

		*(vu32 *)REG_CARDCNT = paramp->cardCnt;					// Rg[ݒ 

		ramEndp = (u8 *)ramp + size;							// i[IAhXZo

		do {													// CPUǂݍ
			cardCntTmp = *(vu32 *)REG_CARDCNT;

			if (cardCntTmp & CARD_DATA_READY) {
				u32 dataTmp = *(vu32 *)REG_CARD_DATA;

				if (ramp < ramEndp)	
					*((vu32 *)ramp) = dataTmp;					// wTCY܂Ŋi[i㑱f[^͓ǂݎ̂āj
				((vu32 *)ramp)++;
			}
		} while (cardCntTmp & CARD_START);
	}
}

//----------------------------------------------------------------------
//     					J[h]ubNTCY l
//----------------------------------------------------------------------

s32 GetBlockSizeFromCardCnt(CardCnt *paramp)
{
	s32  blockSize = 0;
	s32  pages = paramp->pages;

	if (pages == ST_CARD_STATUS)		blockSize = 4;
	else if (pages >= ST_CARD_1_PAGE)	blockSize = 512 <<(pages - 1);

	return  blockSize;
}


//----------------------------------------------------------------------
//     					J[hIDǂݍ݁ij
//----------------------------------------------------------------------

u32 ReadCardID(CardCtrlParam *paramp)
{
	paramp->dmaNo = -1;											// DMAsgpw

	SetCardOp(paramp);											// R}hݒ

	*(vu32 *)REG_CARDCNT = paramp->cardCnt						// Rg[ݒ 
						 | CARD_READ_MODE | CARD_STATUS
						 | CARD_START | CARD_RESET_HI;
	WaitCardData();

	return  *(vu32 *)REG_CARD_DATA;
}

//----------------------------------------------------------------------
//     					J[hIDǂݍ݁iNORMAL[hj
//----------------------------------------------------------------------

u32 ReadCardID4Normal(void)
{
	CardCtrlParam param;

	param.cardCnt = GetCardCnt4Normal();						// Rg[ݒiXNuݒNAj
	param.op[0] = 0;											// R}hݒ
	param.op[1] = MROMOP_N_READ_ID;

	return  ReadCardID(&param);
}

//----------------------------------------------------------------------
//     					J[hIDǂݍ݁iNORMAL[hj
//----------------------------------------------------------------------

u32 ReadCardID4Game(void)
{
	CardCtrlParam param;

	param.cardCnt = GetCardCnt4Game();							// Rg[ݒiXNuݒNAj
	param.op[0] = 0;											// R}hݒ
	param.op[1] = MROMOP_G_READ_ID;

	return  ReadCardID(&param);
}


//----------------------------------------------------------------------
//     					J[hf[^ǂݍ݁iGAME[h^񓯊j
//----------------------------------------------------------------------

void ReadCardAsync4Game(void *romp, void *ramp, s32 size, CardCtrlParam *paramp)
{
	paramp->op[0] = (u32 )romp <<24;							// R}hݒ
	paramp->op[1] = MROMOP_G_READ_PAGE | (u32 )romp >>8;

	ReadCardAsync(romp, ramp, size, paramp);
}


//----------------------------------------------------------------------
//     					J[h荞 ݒ
//----------------------------------------------------------------------

void SetCardIntr(void *romp, void *ramp, s32 size, CardIntrWork *ciwp)
{
	ciwp->romp = romp;
	ciwp->ramp = ramp;
	ciwp->restSize  = size;
	ciwp->blockSize = GetBlockSizeFromCardCnt((CardCnt *)&ciwp->param.cardCnt);
	ciwp->param.dmaNo = 3;

	WaitCardDma(ciwp->param.dmaNo);

	*(vu32 *)REG_IME = 0;
//	*(vu32 *)INTR_CHECK_BUF &= (-1 ^ CARD_DATA_INTR_FLAG);	// J[h`FbÑNA

	*(vu32 *)REG_IF  = CARD_DATA_INTR_FLAG;
	*(vu32 *)REG_IE |= CARD_DATA_INTR_FLAG;					// J[h荞݋
	*(vu32 *)REG_IME = 1;

	ciwp->AsyncFuncp(ciwp->romp, ciwp->ramp, ciwp->blockSize, &ciwp->param);
}

//----------------------------------------------------------------------
//     					J[h荞 I҂
//----------------------------------------------------------------------

void WaitCardIntr(void)
{
	WaitIntr(0, CARD_DATA_INTR_FLAG);

	{	CardIntrWork *ciwp = &cardIntrWork;

		WaitCardDma(ciwp->param.dmaNo);
	}

	*(vu32 *)REG_IME = 0;
	*(vu32 *)REG_IE &= (-1 ^ CARD_DATA_INTR_FLAG);			// J[h荞݋֎~
	*(vu32 *)REG_IME = 1;
}


//----------------------------------------------------------------------
//     					J[h荞 ݒiGAME[hj
//----------------------------------------------------------------------

void SetCardIntr4Game(void *romp, void *ramp, s32 size)
{
	CardIntrWork *ciwp = &cardIntrWork;

	ciwp->param.cardCnt = GetCardCnt4Game()					// Rg[ݒ 
						| CARD_READ_MODE | CARD_1_PAGE
						| CARD_START | CARD_RESET_HI;

	ciwp->AsyncFuncp = ReadCardAsync4Game;					// f[^ǂݍ݊֐ Zbg

	SetCardIntr(romp, ramp, size, ciwp);
}


//----------------------------------------------------------------------
//     					J[h荞
//----------------------------------------------------------------------

void CardIntr(void)
{
	CardIntrWork *ciwp = &cardIntrWork;
	s32  blockSize = ciwp->blockSize;

	// ubNǂݍ

	(u8 *)ciwp->romp += blockSize;
	(u8 *)ciwp->ramp += blockSize;
	ciwp->restSize   -= blockSize;

	if (ciwp->restSize > 0) {
		cardIntrWork.AsyncFuncp(ciwp->romp, ciwp->ramp, blockSize, &ciwp->param);
	} else {
		*(vu32 *)INTR_CHECK_BUF |= CARD_DATA_INTR_FLAG;	// J[h`FbÑZbg
	}
}


#endif	// TEST_CARD_BY_MAINP


//----------------------------------------------------------------------
//     					J[hANZX
//----------------------------------------------------------------------

#ifndef TS_MON

void AccessCard(u32 dmaNo, s32 *srcp, s32 *destp, s32 size)
{
	int  i;

//    *(vu8 *)REG_EXMEMCNT = CTRDG_ACCESS_MAINP | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC;  // 10-6ANZX

	CpuCopy16_32(srcp, destp, size, 32);							// J[gbW̓]
}

#endif	// TS_MON


