//======================================================================
//          IrisGXC.h
//            IRISkfBXvCXgobt@(f[^TCM)֐
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_GXC_H
#define _IRIS_GXC_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisGXB.h>


//----------------------------------------------------------------------
//          kfBXvCXgbot]
//
//Eobt@Ɋi[ꂽkfBXvCXg
//  CPUɂăWIgR}hFIFO֓]܂B
//E]OɃR}h[h̃pbḧ悪NA܂B
//
//EF
//  startp  fBXvCXgobt@̐擪|C^
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//
//E߂lFȂ
//
//TCM̃fBXvCXgDMA]ł܂B
//----------------------------------------------------------------------

#define GXC_CallList(startp, opp, prmp)						\
{                                                           \
    GXC_ClearListPad(opp);									\
    GXB_CallList(startp,  prmp);							\
}


//----------------------------------------------------------------------
//          kfBXvCXg̃R}h[hEpbḧ̃NA
//
//EkfBXvCXg̃R}h[h̃pbḧNA܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void GXC_ClearListPad(void *opp);


//----------------------------------------------------------------------
//          WIgR}h̃Zbg
//
//EkfBXvCXgɃWIgR}hZbg܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  op      ZbgWIgR}h
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_SetOp(opp, op)									\
{															\
	((u8 *)(opp))[0] = op;									\
}


//----------------------------------------------------------------------
//          obt@|C^␳Z
//
//EkfBXvCXg̃obt@|C^̕␳Zs܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  prms    p[^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_AddBufp(opp, prmp, prms)						\
{															\
	(prmp) += (prms);										\
	if ((++(u32 )(opp) & 0x3) == 0)		(opp) = (prmp)++;	\
}


//----------------------------------------------------------------------
//          r[|[gݒ
//
//EBG0ʏɂr[|[g̍WƉEWݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  startX  XWi8bitj
//  startY  YWi V j
//  endX    EXWi V j
//  endY    EYWi V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Viewport(opp, prmp, startX, startY, endX, endY)	\
{															\
	GXC_SetOp(opp, GXOP_VIEWPORT);							\
															\
	(prmp)[0] = (u32 )(startX) << VIEWPORT_START_X_SHIFT	\
			  | (u32 )(startY) << VIEWPORT_START_Y_SHIFT	\
			  | (u32 )(endX)   << VIEWPORT_END_X_SHIFT		\
			  | (u32 )(endY)   << VIEWPORT_END_Y_SHIFT;		\
	GXC_AddBufp(opp, prmp, GXOP_VIEWPORT_NPARAMS);			\
}


//======================================================================
//          sR}hQ
//======================================================================

//----------------------------------------------------------------------
//          s񃂁[hݒ
//
//EsR}hő삷Jgsw肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  mode    s񃂁[h
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_MtxMode(opp, prmp, mode)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_MODE);							\
															\
	(prmp)[0] = (mode);										\
	GXC_AddBufp(opp, prmp, GXOP_MTX_MODE_NPARAMS);			\
}

//----------------------------------------------------------------------
//          Jgs̃vbV
//
//EJgssX^bN֑ޔ
//  kfBXvCXg𐶐܂B
//EsX^bN|C^͂Pi݂܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PushMtx(opp, prmp)								\
{															\
	GXC_SetOp(opp, GXOP_MTX_PUSH);							\
															\
	GXC_AddBufp(opp, prmp, GXOP_MTX_PUSH_NPARAMS);			\
}

//----------------------------------------------------------------------
//          Jgs̃|bv
//
//EJgssX^bN畜
//  kfBXvCXg𐶐܂B
//EsX^bN|C^͎w肵Έʒuֈړ܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  relPos  Έʒui-30 ` 31j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PopMtx(opp, prmp, relPos)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_POP);							\
															\
	(prmp)[0] = (relPos);									\
	GXC_AddBufp(opp, prmp, GXOP_MTX_POP_NPARAMS);			\
}

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒu֊i[
//  kfBXvCXg𐶐܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_StoreMtx(opp, prmp, index)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_STORE);							\
															\
	(prmp)[0] = (index);									\
	GXC_AddBufp(opp, prmp, GXOP_MTX_STORE_NPARAMS);			\
}

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒuo
//  kfBXvCXg𐶐܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_RestoreMtx(opp, prmp, index)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_RESTORE);						\
															\
	GXC_AddBufp(opp, prmp, GXOP_MTX_RESTORE_NPARAMS);		\
}


//----------------------------------------------------------------------
//          Pʍsւ̏
//
//EJgsPʍsɏ
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Identity(opp, prmp)								\
{															\
	GXC_SetOp(opp, GXOP_MTX_IDENTITY);						\
															\
	GXC_AddBufp(opp, prmp, GXOP_MTX_IDENTITY_NPARAMS);		\
}

//----------------------------------------------------------------------
//          sړs̓Kp
//
//EJgsɕsړsZ
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate(opp, prmp, x, y, z)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_TRANS);							\
															\
    (prmp)[0] = (x);										\
    (prmp)[1] = (y);										\
    (prmp)[2] = (z);										\
	GXC_AddBufp(opp, prmp, GXOP_MTX_TRANS_NPARAMS);			\
}

// ԃ}NiL̃}N͒ڎgpȂŉj

#define _GXC_TranslateBefore(opp, prmp, x, y, z)			\
{															\
    (prmp)[0] = (x);										\
    (prmp)[1] = (y);										\
    (prmp)[2] = (z);										\
	GXC_AddBufp(opp, prmp, GXOP_MTX_TRANS_NPARAMS);			\
}


//----------------------------------------------------------------------
//          Jgsւ̃[h
//
//EJgsɎw肵sݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  srcp    [hs̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LoadMtx(  opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_LOAD_4x3);						\
															\
	(prmp) = _GXB_SetMtx(prmp, srcp);						\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_LoadMtx33(opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_LOAD_4x3);						\
															\
	(prmp) = _GXB_SetMtx33(prmp, srcp);						\
	*(prmp)++ = 0;											\
	*(prmp)++ = 0;											\
	*(prmp)++ = 0;											\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_LoadMtx44(opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_LOAD_4x4);						\
															\
	(prmp) = _GXB_SetMtx44(prmp, srcp);						\
	GXC_AddBufp(opp, prmp, 0);								\
}


//----------------------------------------------------------------------
//          ʍsƃJgs̏Z
//
//EJgsɎw肵sZ
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  srcp    Kps̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_MultMtx(opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);						\
															\
	(prmp) = _GXB_SetMtx(prmp, srcp);						\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_MultMtx33(opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_SetMtx33(prmp, srcp);						\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_MultMtx44(opp, prmp, srcp)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);						\
															\
	(prmp) = _GXB_SetMtx44(prmp, srcp);						\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKpɈʍsZ
//
//EJgs֕sړsƈʍšsZ
//  kfBXvCXg𐶐܂B
//
//EGXC_Translate(){GXC_MultMtx33() WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       X
//  y       Y
//  z       Z
//  srcp    Kp3x3s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate2MultMtx33(opp, prmp, x, y, z, srcp)	\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);						\
															\
	(prmp) = _GXB_SetMtx33(prmp, srcp);						\
    _GXC_TranslateBefore(opp, prmp, x, y, z);				\
}


//----------------------------------------------------------------------
//          ]us̓Kp
//
//EJgsɎw肵s̓]usZ
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  srcp    ]uO̍s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TransposeMtx(opp, prmp, srcp)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);						\
															\
	(prmp) = _GXB_TransposeMtx(prmp, srcp);					\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_TransposeMtx33(opp, prmp, srcp)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_TransposeMtx33(prmp, srcp);				\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_TransposeMtx44(opp, prmp, srcp)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);						\
															\
	(prmp) = _GXB_TransposeMtx44(prmp, srcp);				\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKpɓ]usKp
//
//EJgs֕sړsƓ]ušsZ
//  kfBXvCXg𐶐܂B
//
//EGXC_Translate(){GXC_TransposeMtx33() WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  srcp    ]uO3x3s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate2TransposeMtx33(prmp, x, y, z, srcp)	\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);						\
															\
	(prmp) = _GXB_TransposeMtx33(prmp, srcp);				\
    _GXC_TranslateBefore(opp, prmp, x, y, z);				\
}


//----------------------------------------------------------------------
//          XP[s̓KpiʒuWŝ݁j
//
//EJgsɃXP[sZ
//  kfBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇł
//  ʒuWŝ݂ɓKp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Scale(opp, prmp, x, y, z)						\
{															\
	GXC_SetOp(opp, GXOP_MTX_SCALE);							\
															\
    (prmp)[0] = (x) >>VG_SFT_DF;							\
    (prmp)[1] = (y) >>VG_SFT_DF;							\
    (prmp)[2] = (z) >>VG_SFT_DF;							\
	GXC_AddBufp(opp, prmp, GXOP_MTX_SCALE_NPARAMS);			\
}

//----------------------------------------------------------------------
//          XP[s̓KpiʒuWs񁕕xNgsj
//
//EJgsɃXP[sZ
//  kfBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_ScaleWithVector(opp, prmp, srcp)				\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_ScaleWithVector(prmp, srcp);				\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKp
//          XP[sKpiʒuWs񁕕xNgsj
//
//EJgs֕sړsƃXP[šsZ
//  kfBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EGXC_Translate(){GXC_ScaleWithVector() WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  xT      sړX
//  yT      sړY
//  zT      sړZ
//  xS      XP[X
//  yS      XP[Y
//  zS      XP[Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate2ScaleWithVector(opp, prmp, x, y, z, srcp)	\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);							\
																\
	(prmp) = _GXB_ScaleWithVector(prmp, srcp);					\
    _GXC_TranslateBefore(opp, prmp, x, y, z);					\
}


//----------------------------------------------------------------------
//          厲]s̓Kp
//
//EJgsɊe厲ɉ]sZ
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_RotateX(opp, prmp, theta)			GXC_RotatePriv(opp, prmp, X, SIN_NDIV_DEFAULT, theta)
#define GXC_RotateY(opp, prmp, theta)			GXC_RotatePriv(opp, prmp, Y, SIN_NDIV_DEFAULT, theta)
#define GXC_RotateZ(opp, prmp, theta)			GXC_RotatePriv(opp, prmp, Z, SIN_NDIV_DEFAULT, theta)

#define GXC_RotateX256( opp, prmp, theta)		GXC_RotatePriv(opp, prmp, X, 256,  theta)
#define GXC_RotateY256( opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Y, 256,  theta)
#define GXC_RotateZ256( opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Z, 256,  theta)
#define GXC_RotateX1024(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, X, 1024, theta)
#define GXC_RotateY1024(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Y, 1024, theta)
#define GXC_RotateZ1024(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Z, 1024, theta)
#define GXC_RotateX4096(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, X, 4096, theta)
#define GXC_RotateY4096(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Y, 4096, theta)
#define GXC_RotateZ4096(opp, prmp, theta)		GXC_RotatePriv(opp, prmp, Z, 4096, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_RotatePriv(opp, prmp, axis, ndiv, theta)		\
		GXC_RotateNDiv(opp, prmp, axis, ndiv, theta)
#define GXC_RotateNDiv(opp, prmp, axis, ndiv, theta)		\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_Rotate##axis##ndiv(prmp, theta);			\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKpɎ厲]sKp
//
//EJgs֕sړsƎ厲]šsZ
//  kfBXvCXg𐶐܂B
//
//EGXC_Translate(){GXC_Rotate[X|Y|Z][256|1024|4096]() 
//  WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate2RotateX(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, X, SIN_NDIV_DEFAULT, theta)
#define GXC_Translate2RotateY(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, Y, SIN_NDIV_DEFAULT, theta)
#define GXC_Translate2RotateZ(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, Z, SIN_NDIV_DEFAULT, theta)

#define GXC_Translate2RotateX256(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, X, 256,  theta)
#define GXC_Translate2RotateY256(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, Y, 256,  theta)
#define GXC_Translate2RotateZ256(opp, prmp, x, y, z, theta)		GXC_Translate2RotatePriv(opp, prmp, x, y, z, Z, 256,  theta)
#define GXC_Translate2RotateX1024(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, X, 1024, theta)
#define GXC_Translate2RotateY1024(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, Y, 1024, theta)
#define GXC_Translate2RotateZ1024(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, Z, 1024, theta)
#define GXC_Translate2RotateX4096(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, X, 4096, theta)
#define GXC_Translate2RotateY4096(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, Y, 4096, theta)
#define GXC_Translate2RotateZ4096(opp, prmp, x, y, z, theta)	GXC_Translate2RotatePriv(opp, prmp, x, y, z, Z, 4096, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_Translate2RotatePriv(opp, prmp, x, y, z, axis, ndiv, theta)	\
		GXC_Translate2RotateNDiv(opp, prmp, x, y, z, axis, ndiv, theta)
#define GXC_Translate2RotateNDiv(opp, prmp, x, y, z, axis, ndiv, theta)	\
{																		\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);									\
																		\
	(prmp) = _GXB_Rotate##axis##ndiv(prmp, theta);						\
    _GXC_TranslateBefore(opp, prmp, x, y, z);							\
}


//----------------------------------------------------------------------
//          厲]siOp֐ɂ]pwj̓Kp
//
//EJgsɊe厲ɉ]sZ
//  kfBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_RotateXSinCos(opp, prmp, sinA, cosA)			\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_RotateXSinCos(prmp, sinA, cosA);			\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_RotateYSinCos(opp, prmp, sinA, cosA)			\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_RotateYSinCos(prmp, sinA, cosA);			\
	GXC_AddBufp(opp, prmp, 0);								\
}
#define GXC_RotateZSinCos(opp, prmp, sinA, cosA)			\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_RotateZSinCos(prmp, sinA, cosA);			\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKp
//          厲]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƎ厲]šsZ
//  kfBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EGXC_Translate(){GXC_Rotate[X|Y|Z]SinCos() 
//  WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Translate2RotateXSinCos(opp, prmp, x, y, z, sinA, cosA)		GXC_Translate2RotateSinCosPriv(opp, prmp, x, y, z, X, sinA, cosA)
#define GXC_Translate2RotateYSinCos(opp, prmp, x, y, z, sinA, cosA)		GXC_Translate2RotateSinCosPriv(opp, prmp, x, y, z, Y, sinA, cosA)
#define GXC_Translate2RotateZSinCos(opp, prmp, x, y, z, sinA, cosA)		GXC_Translate2RotateSinCosPriv(opp, prmp, x, y, z, Z, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_Translate2RotateSinCosPriv(opp, prmp, x, y, z, axis, sinA, cosA)	\
		GXC_Translate2RotateSinCosNDiv(opp, prmp, x, y, z, axis, sinA, cosA)
#define GXC_Translate2RotateSinCosNDiv(opp, prmp, x, y, z, axis, sinA, cosA)	\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);											\
																				\
	(prmp) = _GXB_RotateYSinCos(prmp, sinA, cosA);								\
    _GXC_TranslateBefore(opp, prmp, x, y, z);									\
}


//----------------------------------------------------------------------
//          Cӎ]s̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ
//  kfBXvCXg𐶐܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_RotateAxis(    opp, prmp, axisp, theta)			GXC_RotateAxisPriv(    SIN_NDIV_DEFAULT, opp, prmp, axisp, theta)
#define GXC_RotateAxisFast(opp, prmp, axisp, theta)			GXC_RotateAxisPrivFast(SIN_NDIV_DEFAULT, opp, prmp, axisp, theta)

#define GXC_RotateAxis256(     opp, prmp, axisp, theta)		GXC_RotateAxisPriv(    256,  opp, prmp, axisp, theta)
#define GXC_RotateAxis256Fast( opp, prmp, axisp, theta)		GXC_RotateAxisPrivFast(256,  opp, prmp, axisp, theta)
#define GXC_RotateAxis1024(    opp, prmp, axisp, theta)		GXC_RotateAxisPriv(    1024, opp, prmp, axisp, theta)
#define GXC_RotateAxis1024Fast(opp, prmp, axisp, theta)		GXC_RotateAxisPrivFast(1024, opp, prmp, axisp, theta)
#define GXC_RotateAxis4096(    opp, prmp, axisp, theta)		GXC_RotateAxisPriv(    4096, opp, prmp, axisp, theta)
#define GXC_RotateAxis4096Fast(opp, prmp, axisp, theta)		GXC_RotateAxisPrivFast(4096, opp, prmp, axisp, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_RotateAxisPriv(    ndiv, opp, prmp, axisp, theta)	\
		GXC_RotateAxisNDiv(    ndiv, opp, prmp, axisp, theta)
#define GXC_RotateAxisNDiv(    ndiv, opp, prmp, axisp, theta)	\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);							\
																\
	(prmp) = _GXB_RotateAxis##ndiv(prmp, axisp, theta);			\
	GXC_AddBufp(opp, prmp, 0);									\
}
#define GXC_RotateAxisPrivFast(ndiv, opp, prmp, axisp, theta)	\
		GXC_RotateAxisNDivFast(ndiv, opp, prmp, axisp, theta)
#define GXC_RotateAxisNDivFast(ndiv, opp, prmp, axisp, theta)	\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);							\
																\
	(prmp) = _GXB_RotateAxis##ndiv##Fast(prmp, axisp, theta);	\
	GXC_AddBufp(opp, prmp, 0);									\
}

//----------------------------------------------------------------------
//          sړsKpɔCӎ]sKp
//
//EJgs֕sړsƔCӎ]šsZ
//  kfBXvCXg𐶐܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGXC_Translate(){GXC_RotateAxis[256|1024|4096][Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Translate2RotateAxis(    opp, prmp, x, y, z, axisp, theta)		GXC_Translate2RotateAxisPriv(    opp, prmp, x, y, z, SIN_NDIV_DEFAULT, axisp, theta)
#define GXC_Translate2RotateAxisFast(opp, prmp, x, y, z, axisp, theta)		GXC_Translate2RotateAxisPrivFast(opp, prmp, x, y, z, SIN_NDIV_DEFAULT, axisp, theta)

#define GXC_Translate2RotateAxis256(    opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPriv(    opp, prmp, x, y, z, 256,  axisp, theta)
#define GXC_Translate2RotateAxis256Fast(opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPrivFast(opp, prmp, x, y, z, 256,  axisp, theta)
#define GXC_Translate2RotateAxis1024(    opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPriv(    opp, prmp, x, y, z, 1024, axisp, theta)
#define GXC_Translate2RotateAxis1024Fast(opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPrivFast(opp, prmp, x, y, z, 1024, axisp, theta)
#define GXC_Translate2RotateAxis4096(    opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPriv(    opp, prmp, x, y, z, 4096, axisp, theta)
#define GXC_Translate2RotateAxis4096Fast(opp, prmp, x, y, z, axisp, theta)	GXC_Translate2RotateAxisPrivFast(opp, prmp, x, y, z, 4096, axisp, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_Translate2RotateAxisPriv(    opp, prmp, x, y, z, ndiv, axisp, theta)	\
		GXC_Translate2RotateAxisNDiv(    opp, prmp, x, y, z, ndiv, axisp, theta)
#define GXC_Translate2RotateAxisNDiv(    opp, prmp, x, y, z, ndiv, axisp, theta)	\
{																					\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);												\
																					\
	(prmp) = _GXB_RotateAxis##ndiv(prmp, axisp, theta);								\
    _GXC_TranslateBefore(opp, prmp, x, y, z);										\
}
#define GXC_Translate2RotateAxisPrivFast(opp, prmp, x, y, z, ndiv, axisp, theta)	\
		GXC_Translate2RotateAxisNDivFast(opp, prmp, x, y, z, ndiv, axisp, theta)
#define GXC_Translate2RotateAxisNDivFast(opp, prmp, x, y, z, ndiv, axisp, theta)	\
{																					\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);												\
																					\
	(prmp) = _GXB_RotateAxis##ndiv##Fast(prmp, axisp, theta);						\
    _GXC_TranslateBefore(opp, prmp, x, y, z);										\
}


//----------------------------------------------------------------------
//          Cӎ]siOp֐ɂ]pwj̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ
//  kfBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_RotateAxisSinCos(opp, prmp, axisp, sinA, cosA)				\
{																		\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);									\
																		\
	(prmp) = _GXB_RotateAxisSinCos(prmp, axisp, sinA, cosA);			\
	GXC_AddBufp(opp, prmp, 0);											\
}

#define GXC_RotateAxisSinCosFast(opp, prmp, axisp, sinA, cosA)			\
{																		\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);									\
																		\
	(prmp) = _GXB_RotateAxisSinCosFast(prmp, axisp, sinA, cosA);		\
	GXC_AddBufp(opp, prmp, 0);											\
}

//----------------------------------------------------------------------
//          sړsKp
//          Cӎ]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƔCӎ]šsZ
//  kfBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGXC_Translate(){GXC_RotateAxisSinCos[Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Translate2RotateAxisSinCos(    opp, prmp, x, y, z, axisp, sinA, cosA)		GXC_Translate2RotateAxisSinCosPriv(    opp, prmp, x, y, z, axisp, sinA, cosA)
#define GXC_Translate2RotateAxisSinCosFast(opp, prmp, x, y, z, axisp, sinA, cosA)		GXC_Translate2RotateAxisSinCosPrivFast(opp, prmp, x, y, z, axisp, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_Translate2RotateAxisSinCosPriv(    opp, prmp, x, y, z, axisp, sinA, cosA)	\
		GXC_Translate2RotateAxisSinCosNDiv(    opp, prmp, x, y, z, axisp, sinA, cosA)
#define GXC_Translate2RotateAxisSinCosNDiv(    opp, prmp, x, y, z, axisp, sinA, cosA)	\
{																						\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);													\
																						\
	(prmp) = _GXB_RotateAxisSinCos(prmp, axisp, sinA, cosA);							\
    _GXC_TranslateBefore(opp, prmp, x, y, z);											\
}
#define GXC_Translate2RotateAxisSinCosPrivFast(opp, prmp, x, y, z, axisp, sinA, cosA)	\
		GXC_Translate2RotateAxisSinCosNDivFast(opp, prmp, x, y, z, axisp, sinA, cosA)
#define GXC_Translate2RotateAxisSinCosNDivFast(opp, prmp, x, y, z, axisp, sinA, cosA)	\
{																						\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);													\
																						\
	(prmp) = _GXB_RotateAxisSinCosFast(prmp, axisp, sinA, cosA);						\
    _GXC_TranslateBefore(opp, prmp, x, y, z);											\
}


//----------------------------------------------------------------------
//          yɃACg]s̓Kp
//
//EJgsɔCӎZ̐ƈv]ssZ
//  kfBXvCXg𐶐܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  vLookInvp  Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_AlignZ(opp, prmp, vLookInvp)					\
{															\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);						\
															\
	(prmp) = _GXB_AlignZ(prmp, vLookInvp);					\
	GXC_AddBufp(opp, prmp, 0);								\
}

//----------------------------------------------------------------------
//          sړsKp
//          yɃACg]sKp
//
//EJgs֕sړsƔCӎZ̐ƈv]ss
//  Ƃ̌sZAkfBXvCXg𐶐܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//EGXC_Translate(){GXC_AlignZ() WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x           sړX
//  y           sړY
//  z           sړZ
//  vLookInvp   Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Translate2AlignZ(opp, prmp, x, y, z, vLookInvp)		\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);							\
																\
	(prmp) = _GXB_AlignZ(prmp, vLookInvp);						\
    _GXC_TranslateBefore(opp, prmp, x, y, z);					\
}


//----------------------------------------------------------------------
//          NH[^jIϊ]s̓Kp
//
//EJgsփNH[^jIϊ]sKp
//  kfBXvCXg𐶐܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//ʏł͏Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_QuatMtx(opp, prmp, quatp)							\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);							\
																\
	(prmp) = _GXB_QuatMtx(prmp, quatp);							\
	GXC_AddBufp(opp, prmp, 0);									\
}
#define GXC_QuatMtxFast(opp, prmp, quatp)						\
{																\
	GXC_SetOp(opp, GXOP_MTX_MULT_3x3);							\
																\
	(prmp) = _GXB_QuatMtxFast(prmp, quatp);						\
	GXC_AddBufp(opp, prmp, 0);									\
}

//----------------------------------------------------------------------
//          sړsKp
//          NH[^jIϊ]sKp
//
//EJgs֕sړsƃNH[^jIϊ]s
//  ̌sZAkfBXvCXg𐶐܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//EGXC_Translate(){GXC_QuatMtx[Fast]() WIgGWׂ̕点܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//ʏł͏Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Translate2QuatMtx(    opp, prmp, x, y, z, quatp)	GXC_Translate2QuatMtxPriv(    opp, prmp, x, y, z, quatp)
#define GXC_Translate2QuatMtxFast(opp, prmp, x, y, z, quatp)	GXC_Translate2QuatMtxPrivFast(opp, prmp, x, y, z, quatp)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_Translate2QuatMtxPriv(    opp, prmp, x, y, z, quatp)	\
		GXC_Translate2QuatMtxNDiv(    opp, prmp, x, y, z, quatp)
#define GXC_Translate2QuatMtxPrivFast(opp, prmp, x, y, z, quatp)	\
		GXC_Translate2QuatMtxNDivFast(opp, prmp, x, y, z, quatp)
#define GXC_Translate2QuatMtxNDiv(    opp, prmp, x, y, z, quatp)	\
{																	\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);								\
																	\
	(prmp) = _GXB_QuatMtx(prmp, quatp);								\
    _GXC_TranslateBefore(opp, prmp, x, y, z);						\
}
#define GXC_Translate2QuatMtxNDivFast(opp, prmp, x, y, z, quatp)	\
{																	\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);								\
																	\
	(prmp) = _GXB_QuatMtxFast(prmp, quatp);							\
    _GXC_TranslateBefore(opp, prmp, x, y, z);						\
}


//----------------------------------------------------------------------
//          EΏ̂̓ˉes̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z
//  kfBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  fovy    c̎pxm256b1024b4096iKn
//  aspect  ̎m肷ciEł /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Perspective(opp, prmp, fovy, aspect, near, far, scaleW)			GXC_PerspectivePriv(SIN_NDIV_DEFAULT, opp, prmp, fovy, aspect, near, far, scaleW)

#define GXC_Perspective256(opp, prmp, fovy, aspect, near, far, scaleW)		GXC_PerspectivePriv(256,  opp, prmp, fovy, aspect, near, far, scaleW)
#define GXC_Perspective1024(opp, prmp, fovy, aspect, near, far, scaleW)		GXC_PerspectivePriv(1024, opp, prmp, fovy, aspect, near, far, scaleW)
#define GXC_Perspective4096(opp, prmp, fovy, aspect, near, far, scaleW)		GXC_PerspectivePriv(4096, opp, prmp, fovy, aspect, near, far, scaleW)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXC_PerspectivePriv(ndiv, opp, prmp, fovy, aspect, near, far, scaleW)	\
		GXC_PerspectiveNDiv(ndiv, opp, prmp, fovy, aspect, near, far, scaleW)
#define GXC_PerspectiveNDiv(ndiv, opp, prmp, fovy, aspect, near, far, scaleW)	\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);											\
																				\
	(prmp) = _GXB_Perspective##ndiv(prmp, fovy, aspect, near, far, scaleW);		\
	GXC_AddBufp(opp, prmp, 0);													\
}

//----------------------------------------------------------------------
//          EΏ̂̓ˉesiOp֐ɂ鎋pwj̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z
//  kfBXvCXg𐶐܂B
//Epx̓TCƃRTCɂĎw肵܂B
//
//E֐ŏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  sinA    c̎px̃TC
//  cosA    c̎px̃RTCiʊ֐̌ĂяôߍŌɓnj
//  aspect  ̎m肷ciEł /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_PerspectiveSinCos(opp, prmp, sinA, aspect, near, far, scaleW, cosA)		\
{																					\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);												\
																					\
	(prmp) = _GXB_PerspectiveSinCos(prmp, sinA, aspect, near, far, scaleW, cosA);	\
	GXC_AddBufp(opp, prmp, 0);														\
}

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//E@̍s쐬AJgs֏Z
//  kfBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iɐj
//  f       _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Frustum(opp, prmp, t, b, l, r, n, f, scaleW)						\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);											\
																				\
	(prmp) = _GXB_Frustum(prmp, t, b, l, r, n, f, scaleW);						\
	GXC_AddBufp(opp, prmp, 0);													\
}

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//Eˉe̕s̐ς̍s쐬AJgs֏Z
//  kfBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iǂłj
//  f       _farNbvʂ܂ł̋ iǂłj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_Ortho(opp, prmp, t, b, l, r, n, f, scaleW)							\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x4);											\
																				\
	(prmp) = _GXB_Ortho(prmp, t, b, l, r, n, f, scaleW);						\
	GXC_AddBufp(opp, prmp, 0);													\
}

//----------------------------------------------------------------------
//          Es̓Kp
//
//EEs쐬AJgs֏Z
//  kfBXvCXg𐶐܂B
//
//E֐ŃxNg̐K̂߂ɕZƏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  eye     _
//  at      _
//  vUp     xNg
//  vDst    0iNULL|C^jȊOnƁAtxNgԂ܂
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXC_LookAt(opp, prmp, eye, at, vUp, vDst)								\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);											\
																				\
	(prmp) = _GXB_LookAt(prmp, eye, at, vUp, vDst);								\
	GXC_AddBufp(opp, prmp, 0);													\
}
#define GXC_LookAtFast(opp, prmp, eye, at, vUp, vDst)							\
{																				\
	GXC_SetOp(opp, GXOP_MTX_MULT_4x3);											\
																				\
	(prmp) = _GXB_LookAtFast(prmp, eye, at, vUp, vDst);							\
	GXC_AddBufp(opp, prmp, 0);													\
}


//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂̍\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  box     eXg{bNXiXYZWHD161616161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_BoxTest1(opp, prmp, box)						\
{															\
	GXC_SetOp(opp, GXOP_BOX_TEST);							\
															\
	*(TestBox *)&(prmp)[0] = (box);							\
	GXC_AddBufp(opp, prmp, GXOP_BOX_TEST_NPARAMS);			\
}

//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂Ɋep[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       eXg{bNXXWi16bitj
//  y       eXg{bNXYWi V  j
//  z       eXg{bNXZWi V  j
//  w       eXg{bNX       i V  j
//  h       eXg{bNX     i V  j
//  d       eXg{bNXs   i V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_BoxTest6(opp, prmp, x, y, z, w, h, d)			\
{															\
	GXC_SetOp(opp, GXOP_BOX_TEST);							\
															\
	(prmp)[0] = XY1616(x, y);								\
	(prmp)[1] = ZW1616(z, w);								\
	(prmp)[2] = HD1616(h, d);								\
	GXC_AddBufp(opp, prmp, GXOP_BOX_TEST_NPARAMS);			\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̍\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PositionTest1(opp, prmp, pos)					\
{															\
	GXC_SetOp(opp, GXOP_POS_TEST);							\
															\
	*(Pos16 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_POS_TEST_NPARAMS);			\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PositionTest3(opp, prmp, x, y, z)				\
{															\
	GXC_SetOp(opp, GXOP_POS_TEST);							\
															\
	(prmp)[0] = XY1616(x, y);								\
	(prmp)[1] = (z);										\
	GXC_AddBufp(opp, prmp, GXOP_POS_TEST_NPARAMS);			\
}

//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VectorTest1(opp, prmp, vector)					\
{															\
	GXC_SetOp(opp, GXOP_VEC_TEST);							\
															\
	*(Vec10 *)&(prmp)[0] = (vector);						\
	GXC_AddBufp(opp, prmp, GXOP_VEC_TEST_NPARAMS);			\
}

//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VectorTest3(opp, prmp, x, y, z)					\
{															\
	GXC_SetOp(opp, GXOP_VEC_TEST);							\
															\
	(prmp)[0] = XYZ101010(x, y, z);							\
	GXC_AddBufp(opp, prmp, GXOP_VEC_TEST_NPARAMS);			\
}


//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgxNg\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp         fBXvCXgobt@̃R}ḧ̃|C^
//  prmp        fBXvCXgobt@̃p[^̈̃|C^
//  lightVector CgxNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightVector1(opp, prmp, lightVector)			\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_VECTOR);						\
															\
	*(LightVector *)&(prmp)[0] = (lightVector);				\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_VECTOR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgJ[\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp         fBXvCXgobt@̃R}ḧ̃|C^
//  prmp        fBXvCXgobt@̃p[^̈̃|C^
//  lightColor  CgJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightColor1(opp, prmp, lightColor)				\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_COLOR);						\
															\
	*(LightColor *)&(prmp)[0] = (lightColor);				\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_COLOR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNgݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  no      Cgԍ
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightVector2(opp, prmp, no, vector)				\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_VECTOR);						\
															\
	(prmp)[0] = ((no)<<LIGHT_ID_SHIFT | *(u32 *)&(vector));	\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_VECTOR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  no      Cgԍ
//  color   J[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightColor2(opp, prmp, no, color)				\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_COLOR);						\
															\
	(prmp)[0] = ((no)<<LIGHT_ID_SHIFT | *(u16 *)&(color));	\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_COLOR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNg̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  no      Cgԍ
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightVector4(opp, prmp, no, x, y, z)			\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_VECTOR);						\
															\
	(prmp)[0] = LIGHT_VECTOR(no, x, y, z);					\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_VECTOR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  no      Cgԍ
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_LightColor4(opp, prmp, no, r, g, b)				\
{															\
	GXC_SetOp(opp, GXOP_LIGHT_COLOR);						\
															\
	(prmp)[0] = LIGHT_COLOR(no, r, g, b);					\
	GXC_AddBufp(opp, prmp, GXOP_LIGHT_COLOR_NPARAMS);		\
}


//----------------------------------------------------------------------
//          ʔˋPxe[u̐ݒ
//
//E8bit128vfȂ鋾ʔˋPxe[uݒ肷
//  kfBXvCXg𐶐܂B
//ESvf܂Ƃ߂ē]Kv܂B
//Ẽe[u邱ƂɂāA1V[ɕ
//  ʔˌʂ|S\邱Ƃł܂BB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  srcp    ʔˋPxe[ũ|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_ShininessTable(opp, prmp, srcp)					\
{															\
	GXC_SetOp(opp, GXOP_SHININESS);							\
															\
	(prmp) = _GXB_ShininessTable(prmp, srcp);				\
	GXC_AddBufp(opp, prmp, 0);								\
}


//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//ES}eAJ[Ɗ֘AtO܂Ƃ߂64bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  colors  S}eAJ[f[^iRGB555 | _J[XVtOAʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_MaterialColor1(opp, prmp, colors)				\
{	GXC_DiffuseAmbient1(  opp, prmp, ((u32 *)&(colors))[0]);\
	GXC_SpecularEmission1(opp, prmp, ((u32 *)&(colors))[1]);\
}

//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[ƂɊ֘AtOݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_MaterialColor4(opp, prmp, dif, amb, spe, emi)	\
{	GXC_DiffuseAmbient2(  opp, prmp, dif, amb);				\
	GXC_SpecularEmission2(opp, prmp, spe, emi);				\
}

//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[̊evfƊ֘AtOݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  setCol  _J[XVtO
//  tbl     ʔˋPxe[uLtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//  sr      XyLJ[  Ԑi V j
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_MaterialColor14(opp, prmp, setCol, tbl, dr, dg, db, ar, ag, ab, sr, sg, sb, er, eg, eb)	\
{	GXC_DiffuseAmbient7(opp, prmp, setCol, dr, dg, db, ar, ag, ab);	\
	GXC_SpecularEmission7(opp, prmp, tbl, sr, sg, sb, er, eg, eb);	\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  colors  fBt[YArGgJ[iRGB555 | _J[XVtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_DiffuseAmbient1(opp, prmp, colors)				\
{															\
	GXC_SetOp(opp, GXOP_DIF_AMB);							\
															\
	(prmp)[0] = (colors);									\
	GXC_AddBufp(opp, prmp, GXOP_DIF_AMB_NPARAMS);			\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  colors  XyLG~bVJ[iRGB555 | ʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_SpecularEmission1(opp, prmp, colors)			\
{															\
	GXC_SetOp(opp, GXOP_SPE_EMI);							\
															\
	(prmp)[0] = (colors);									\
	GXC_AddBufp(opp, prmp, GXOP_SPE_EMI_NPARAMS);			\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_DiffuseAmbient2(opp, prmp, dif, amb)			\
{															\
	GXC_SetOp(opp, GXOP_DIF_AMB);							\
															\
	(prmp)[0] = (*(u16 *)&(dif) | (*(u16 *)&(amb))<<16);	\
	GXC_AddBufp(opp, prmp, GXOP_DIF_AMB_NPARAMS);			\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_SpecularEmission2(opp, prmp, spe, emi)			\
{															\
	GXC_SetOp(opp, GXOP_SPE_EMI);							\
															\
	(prmp)[0] = (*(u16 *)&(spe) | (*(u16 *)&(emi))<<16);	\
	GXC_AddBufp(opp, prmp, GXOP_SPE_EMI_NPARAMS);			\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[̊evf
//  _J[XVtOݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  setCol  _J[XVtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_DiffuseAmbient7(opp, prmp, setCol, dr, dg, db, ar, ag, ab)	\
{															\
	GXC_SetOp(opp, GXOP_DIF_AMB);							\
															\
	(prmp)[0] = ((setCol) | RGB555(dr, dg, db)				\
						  | RGB555(ar, ag, ab)<<16);		\
	GXC_AddBufp(opp, prmp, GXOP_DIF_AMB_NPARAMS);			\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[̊evf
//  ʔˋPxe[uLtOݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  tbl     ʔˋPxe[uLtO
//  sr      XyLJ[  Ԑi5bitj
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_SpecularEmission7(opp, prmp, tbl, sr, sg, sb, er, eg, eb)	\
{															\
	GXC_SetOp(opp, GXOP_SPE_EMI);							\
															\
	(prmp)[0] = ((tbl) | RGB555(sr, sg, sb)					\
					   | RGB555(er, eg, eb)<<16);			\
	GXC_AddBufp(opp, prmp, GXOP_SPE_EMI_NPARAMS);			\
}


//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|S܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  attr    |S
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PolygonAttr1(opp, prmp, attr)					\
{															\
	GXC_SetOp(opp, GXOP_POLYGON_ATTR);						\
															\
	(prmp)[0] = (attr);										\
	GXC_AddBufp(opp, prmp, GXOP_POLYGON_ATTR_NPARAMS);		\
}

//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|SIDƃAt@lƑ̑ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  id      ID        i6bitj
//  alpha   At@li5bitj
//  attr    ̃|S
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_PolygonAttr3(opp, prmp, id, alpha, attr)		\
{															\
	GXC_SetOp(opp, GXOP_POLYGON_ATTR);						\
															\
	(prmp)[0] = (id)   <<POLYATTR_ID_SHIFT					\
			  | (alpha)<<POLYATTR_ALPHA_SHIFT				\
			  | (attr);										\
	GXC_AddBufp(opp, prmp, GXOP_POLYGON_ATTR_NPARAMS);		\
}


//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgj
//
//EeNX`B[W̃p[^܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//EeNX`C[Wx[Xl̓VtglnĉB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  param   eNX`C[Wp[^i32bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexImageParam1(opp, prmp, param)				\
{															\
	GXC_SetOp(opp, GXOP_TEXIMAGE_PARAM);					\
															\
	(prmp)[0] = (param);									\
	GXC_AddBufp(opp, prmp, GXOP_TEXIMAGE_PARAM_NPARAMS);	\
}

//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgLj
//
//EeNX`B[W̃p[^ݒ肷
//  kfBXvCXg𐶐܂B
//EeNX`C[Wx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  basep   eNX`C[W̃x[X|C^
//  param   eNX`C[Wp[^i16bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexImageParam2(opp, prmp, basep, param)			\
{															\
	GXC_SetOp(opp, GXOP_TEXIMAGE_PARAM);					\
															\
	(prmp)[0] = Addr2TexImageBase(basep) | (param);			\
	GXC_AddBufp(opp, prmp, GXOP_TEXIMAGE_PARAM_NPARAMS);	\
}

//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgj
//
//EeNX`pbgx[X̃p[^܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//EeNX`pbgx[Xl̓VtglnĉB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  basep   eNX`pbg̃x[X|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexPlttBase1(opp, prmp, basep)					\
{															\
	GXC_SetOp(opp, GXOP_TEXPLTT_BASE);						\
															\
	(prmp)[0] = (u32 )(basep);								\
	GXC_AddBufp(opp, prmp, GXOP_TEXPLTT_BASE_NPARAMS);		\
}

//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgLj
//
//EeNX`pbgx[X̃p[^ݒ肷
//  kfBXvCXg𐶐܂B
//EeNX`pbgx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  basep   eNX`pbg̃x[X|C^
//  mode    eNX`[h
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexPlttBase2(opp, prmp, basep, mode)			\
{															\
	GXC_SetOp(opp, GXOP_TEXPLTT_BASE);						\
															\
	(prmp)[0] = Addr2TexPlttBase(basep, mode);				\
	GXC_AddBufp(opp, prmp, GXOP_TEXPLTT_BASE_NPARAMS);		\
}


//----------------------------------------------------------------------
//          v~eBu̒_XgJn
//
//Ev~eBu̒_Xg̊Jn錾
//  kfBXvCXg𐶐܂B
//
//EF
//  opp         fBXvCXgobt@̃R}ḧ̃|C^
//  prmp        fBXvCXgobt@̃p[^̈̃|C^
//  primType    v~eBu^Cv
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Begin(opp, prmp, primType)						\
{															\
	GXC_SetOp(opp, GXOP_BEGIN);								\
															\
	(prmp)[0] = (primType);									\
	GXC_AddBufp(opp, prmp, GXOP_BEGIN_NPARAMS);				\
}

//----------------------------------------------------------------------
//          v~eBu̒_XgI
//
//Ev~eBu̒_Xg̏I錾
//  kfBXvCXg𐶐܂B
//
//EF
//  opp         fBXvCXgobt@̃R}ḧ̃|C^
//  prmp        fBXvCXgobt@̃p[^̈̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_End(opp, prmp)									\
{															\
	GXC_SetOp(opp, GXOP_END);								\
															\
	GXC_AddBufp(opp, prmp, GXOP_END_NPARAMS);				\
}

//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[𒼐ڐݒ肷AkfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  color   J[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Color1(opp, prmp, color)						\
{															\
	GXC_SetOp(opp, GXOP_COLOR);								\
															\
	(prmp)[0] = *(u16 *)&(color);							\
	GXC_AddBufp(opp, prmp, GXOP_COLOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[̊evf𒼐ڐݒ肷AkfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Color3(opp, prmp, r, g, b)						\
{															\
	GXC_SetOp(opp, GXOP_COLOR);								\
															\
	(prmp)[0] = RGB555(r, g, b);							\
	GXC_AddBufp(opp, prmp, GXOP_COLOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNg\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  normal  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Normal1(opp, prmp, normal)						\
{															\
	GXC_SetOp(opp, GXOP_NORMAL);							\
															\
	*(Vec10 *)&(prmp)[0] = (normal);						\
	GXC_AddBufp(opp, prmp, GXOP_NORMAL_NPARAMS);			\
}

//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNgtH[}bg̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Normal3(opp, prmp, x, y, z)						\
{															\
	GXC_SetOp(opp, GXOP_NORMAL);							\
															\
	(prmp)[0] = XYZ101010(x, y, z);							\
	GXC_AddBufp(opp, prmp, GXOP_NORMAL_NPARAMS);			\
}

//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`WփeNX`W\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  coord   eNX`WiST1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexCoord1(opp, prmp, coord)						\
{															\
	GXC_SetOp(opp, GXOP_TEXCOORD);							\
															\
	*(TexCoord *)&(prmp)[0] = (coord);						\
	GXC_AddBufp(opp, prmp, GXOP_TEXCOORD_NPARAMS);			\
}

//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`W֊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  s       eNX`WSi16bitj
//  t                     Ti V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_TexCoord2(opp, prmp, s,t)						\
{															\
	GXC_SetOp(opp, GXOP_TEXCOORD);							\
															\
	(prmp)[0] = ST1616(s, t);								\
	GXC_AddBufp(opp, prmp, GXOP_TEXCOORD_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Vertex1(opp, prmp, pos)							\
{															\
	GXC_SetOp(opp, GXOP_VTX_16);							\
															\
	*(Pos16 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_16_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_Vertex3(opp, prmp, x, y, z)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_16);							\
															\
	(prmp)[0] = XY1616(x, y);								\
	(prmp)[1] = (z);										\
	GXC_AddBufp(opp, prmp, GXOP_VTX_16_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg\̂ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexShort1(opp, prmp, pos)					\
{															\
	GXC_SetOp(opp, GXOP_VTX_10);							\
															\
	*(Pos10 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_10_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexShort3(opp, prmp, x, y, z)				\
{															\
	GXC_SetOp(opp, GXOP_VTX_10);							\
															\
	(prmp)[0] = XYZ101010(x, y, z);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_10_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYW܂Ƃ߂32bitf[^ݒiZW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiXY1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexXY1(opp, prmp, pos)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_XY);							\
															\
	*(Pos2D16 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_XY_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYWݒiZW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexXY2(opp, prmp, x, y)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_XY);							\
															\
	(prmp)[0] = XY1616(x, y);								\
	GXC_AddBufp(opp, prmp, GXOP_VTX_XY_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZW܂Ƃ߂32bitf[^ݒiYW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiXZ1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexXZ1(opp, prmp, pos)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_XZ);							\
															\
	*(Pos2D16 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_XZ_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZWݒiYW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexXZ2(opp, prmp, x, z)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_XZ);							\
															\
	(prmp)[0] = XY1616(x, z);								\
	GXC_AddBufp(opp, prmp, GXOP_VTX_XZ_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZW܂Ƃ߂32bitf[^ݒiXW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  pos     ʒuWiYZ1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexYZ1(opp, prmp, pos)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_YZ);							\
															\
	*(Pos2D16 *)&(prmp)[0] = (pos);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_YZ_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZWݒiXW͍Ō̐ݒlgpj
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  y       ʒuWYi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexYZ2(opp, prmp, y, z)						\
{															\
	GXC_SetOp(opp, GXOP_VTX_YZ);							\
															\
	(prmp)[0] = XY1616(y, z);								\
	GXC_AddBufp(opp, prmp, GXOP_VTX_YZ_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l܂Ƃ߂32bitf[^ݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  diff    ʒuWiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexDiff1(opp, prmp, diff)					\
{															\
	GXC_SetOp(opp, GXOP_VTX_DIFF);							\
															\
	*(Pos10 *)&(prmp)[0] = (diff);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_DIFF_NPARAMS);			\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l̊evfݒ肷
//  kfBXvCXg𐶐܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_VertexDiff3(opp, prmp, x, y, z)					\
{															\
	GXC_SetOp(opp, GXOP_VTX_DIFF);							\
															\
	(prmp)[0] = XYZ101010(x, y, z);							\
	GXC_AddBufp(opp, prmp, GXOP_VTX_DIFF_NPARAMS);			\
}


//----------------------------------------------------------------------
//          _OGWQƃf[^Q̃Xbv
//
//ẼR}h𔭍sVuNԊJnɁA
//  |SXgRAMA_RAMA_O֘AWX^A
//  _OGWQƂf[^؂ւ
//  kfBXvCXg𐶐܂B
//E񂾃OtBbNXf[^`֔f̂
//  ̃R}h𔭍s̃t[ɂȂ܂
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXC_SwapBuffers(opp, prmp, flags)					\
{															\
	GXC_SetOp(opp, GXOP_SWAP_BUFFERS);						\
															\
	(prmp)[0] = (flags);									\
	GXC_AddBufp(opp, prmp, GXOP_SWAP_BUFFERS_NPARAMS);		\
}


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_GXC_H
