//======================================================================
//          IrisMTX.h
//            s񃉃Cu
//
//          MTX֐64bit̏Z𑽗p܂̂ŁAł邾
//          GX֐gpAׂy悤ɂĉB
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_MTX_H
#define _IRIS_MTX_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisTypes.h>
#include <IrisSinTable.h>


//======================================================================
//          ėps
//======================================================================

//----------------------------------------------------------------------
//          Pʍs̐
//
//Edstpws֒Pʍs𐶐܂B
//
//EF
//  dstp    si[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_Identity(Mtx *dstp);
void MTX33_Identity(Mtx33 *dstp);
void MTX44_Identity(Mtx44 *dstp);

//----------------------------------------------------------------------
//          s̃Rs[
//
//EsrcpwsdstpwsփRs[܂B
//
//EF
//  srcp    ]s̃|C^
//  dstp    ]sobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

// 4x3swsփRs[

void MTX_Copy(      const Mtx *srcp, Mtx   *dstp);
void MTX_Copy2Mtx33(const Mtx *srcp, Mtx33 *dstp);
void MTX_Copy2Mtx44(const Mtx *srcp, Mtx44 *dstp);

// 3x3swsփRs[

void MTX33_Copy(      const Mtx33 *srcp, Mtx33 *dstp);
void MTX33_Copy2Mtx(  const Mtx33 *srcp, Mtx   *dstp);
void MTX33_Copy2Mtx44(const Mtx33 *srcp, Mtx44 *dstp);

// 4x4swsփRs[

void MTX44_Copy(      const Mtx44 *srcp, Mtx44 *dstp);
void MTX44_Copy2Mtx(  const Mtx44 *srcp, Mtx   *dstp);
void MTX44_Copy2Mtx33(const Mtx44 *srcp, Mtx33 *dstp);

//----------------------------------------------------------------------
//          s̘A
//
//Esrc0psrc1pws̓]sdstp֐܂B
//
//EF
//  src0p   ]s̃|C^
//  src1p   ]s̃|C^
//  dstp    Asobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_Concat(Mtx *src0p, Mtx *src1p, Mtx *dstp);
void MTX33_Concat(Mtx33 *src0p, Mtx33 *src1p, Mtx33 *dstp);
void MTX44_Concat(Mtx44 *src0p, Mtx44 *src1p, Mtx44 *dstp);

//----------------------------------------------------------------------
//          ]us̐
//
//Esrcpws̓]usdstpws֐܂B
//
//EF
//  srcp    ]uOs̃|C^
//  dstp    sobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_Transpose( Mtx *srcp,  Mtx *dstp);
void MTX33_Transpose( Mtx33 *srcp,  Mtx33 *dstp);
void MTX44_Transpose( Mtx44 *srcp,  Mtx44 *dstp);


//======================================================================
//         fs
//======================================================================

//----------------------------------------------------------------------
//          sړs̐
//
//Esړsdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_Translate(Mtx *dstp, s32 x, s32 y, s32 z);
void MTX44_Translate(Mtx44 *dstp, s32 x, s32 y, s32 z);

//----------------------------------------------------------------------
//          sړsOKp
//
//EsrcpwsɕsړsOKps
//  dstpws֐܂B
//
//EF
//  srcp    Kps̃|C^
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_TranslateBefore(Mtx *srcp, Mtx *dstp, s32 x, s32 y, s32 z);
void MTX44_TranslateBefore(Mtx44 *srcp, Mtx44 *dstp, s32 x, s32 y, s32 z);

//----------------------------------------------------------------------
//          sړsKp
//
//EsrcpwsɕsړsKps
//  dstpws֐܂B
//
//EF
//  srcp    Kps̃|C^
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_TranslateAfter(Mtx *srcp, Mtx *dstp, s32 x, s32 y, s32 z);
void MTX44_TranslateAfter(Mtx44 *srcp, Mtx44 *dstp, s32 x, s32 y, s32 z);

//----------------------------------------------------------------------
//          XP[s̐
//
//EXP[sdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_Scale(Mtx *dstp, s32 xS, s32 yS, s32 zS);
void MTX33_Scale(Mtx33 *dstp, s32 xS, s32 yS, s32 zS);
void MTX44_Scale(Mtx44 *dstp, s32 xS, s32 yS, s32 zS);

//----------------------------------------------------------------------
//          XP[sOKp
//
//EsrcpwsɃXP[sOKps
//  dstpws֐܂B
//
//EF
//  srcp    Kps̃|C^
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_ScaleBefore(Mtx *srcp, Mtx *dstp, s32 xS, s32 yS, s32 zS);
void MTX33_ScaleBefore(Mtx33 *srcp, Mtx33 *dstp, s32 xS, s32 yS, s32 zS);
void MTX44_ScaleBefore(Mtx44 *srcp, Mtx44 *dstp, s32 xS, s32 yS, s32 zS);

//----------------------------------------------------------------------
//          XP[sKp
//
//EsrcpwsɃXP[sKps
//  dstpws֐܂B
//
//EF
//  srcp    Kps̃|C^
//  dstp    sobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_ScaleAfter(Mtx *srcp, Mtx *dstp, s32 xS, s32 yS, s32 zS);
void MTX33_ScaleAfter(Mtx33 *srcp, Mtx33 *dstp, s32 xS, s32 yS, s32 zS);
void MTX44_ScaleAfter(Mtx44 *srcp, Mtx44 *dstp, s32 xS, s32 yS, s32 zS);

//----------------------------------------------------------------------
//
//          厲]s̐
//
//E厲]sdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//----------------------------------------------------------------------

#define MTX_RotateX(dstp, theta)				MTXxx_RotatePriv(_,   X, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX_RotateY(dstp, theta)				MTXxx_RotatePriv(_,   Y, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX_RotateZ(dstp, theta)				MTXxx_RotatePriv(_,   Z, SIN_NDIV_DEFAULT, dstp, theta)

#define MTX33_RotateX(dstp, theta)				MTXxx_RotatePriv(33_, X, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX33_RotateY(dstp, theta)				MTXxx_RotatePriv(33_, Y, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX33_RotateZ(dstp, theta)				MTXxx_RotatePriv(33_, Z, SIN_NDIV_DEFAULT, dstp, theta)

#define MTX44_RotateX(dstp, theta)				MTXxx_RotatePriv(44_, X, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX44_RotateY(dstp, theta)				MTXxx_RotatePriv(44_, Y, SIN_NDIV_DEFAULT, dstp, theta)
#define MTX44_RotateZ(dstp, theta)				MTXxx_RotatePriv(44_, Z, SIN_NDIV_DEFAULT, dstp, theta)

void MTX_RotateX256(Mtx *dstp, u32 theta);
void MTX_RotateY256(Mtx *dstp, u32 theta);
void MTX_RotateZ256(Mtx *dstp, u32 theta);
void MTX_RotateX1024(Mtx *dstp, u32 theta);
void MTX_RotateY1024(Mtx *dstp, u32 theta);
void MTX_RotateZ1024(Mtx *dstp, u32 theta);
void MTX_RotateX4096(Mtx *dstp, u32 theta);
void MTX_RotateY4096(Mtx *dstp, u32 theta);
void MTX_RotateZ4096(Mtx *dstp, u32 theta);

void MTX33_RotateX256(Mtx33 *dstp, u32 theta);
void MTX33_RotateY256(Mtx33 *dstp, u32 theta);
void MTX33_RotateZ256(Mtx33 *dstp, u32 theta);
void MTX33_RotateX1024(Mtx33 *dstp, u32 theta);
void MTX33_RotateY1024(Mtx33 *dstp, u32 theta);
void MTX33_RotateZ1024(Mtx33 *dstp, u32 theta);
void MTX33_RotateX4096(Mtx33 *dstp, u32 theta);
void MTX33_RotateY4096(Mtx33 *dstp, u32 theta);
void MTX33_RotateZ4096(Mtx33 *dstp, u32 theta);

void MTX44_RotateX256(Mtx44 *dstp, u32 theta);
void MTX44_RotateY256(Mtx44 *dstp, u32 theta);
void MTX44_RotateZ256(Mtx44 *dstp, u32 theta);
void MTX44_RotateX1024(Mtx44 *dstp, u32 theta);
void MTX44_RotateY1024(Mtx44 *dstp, u32 theta);
void MTX44_RotateZ1024(Mtx44 *dstp, u32 theta);
void MTX44_RotateX4096(Mtx44 *dstp, u32 theta);
void MTX44_RotateY4096(Mtx44 *dstp, u32 theta);
void MTX44_RotateZ4096(Mtx44 *dstp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define MTXxx_RotatePriv(xx_, axis, ndiv, dstp, theta)	MTXxx_RotateNDiv(xx_, axis, ndiv, dstp, theta)
#define MTXxx_RotateNDiv(xx_, axis, ndiv, dstp, theta)	MTX##xx_##Rotate##axis##ndiv(     dstp, theta)

//----------------------------------------------------------------------
//          厲]siOp֐ɂ]pwj̐
//
//E厲]sdstpws֐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EF
//  dstp    sobt@̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_RotateXSinCos(Mtx *dstp, s32 sinA, s32 cosA);
void MTX_RotateYSinCos(Mtx *dstp, s32 sinA, s32 cosA);
void MTX_RotateZSinCos(Mtx *dstp, s32 sinA, s32 cosA);

void MTX33_RotateXSinCos(Mtx33 *dstp, s32 sinA, s32 cosA);
void MTX33_RotateYSinCos(Mtx33 *dstp, s32 sinA, s32 cosA);
void MTX33_RotateZSinCos(Mtx33 *dstp, s32 sinA, s32 cosA);

void MTX44_RotateXSinCos(Mtx44 *dstp, s32 sinA, s32 cosA);
void MTX44_RotateYSinCos(Mtx44 *dstp, s32 sinA, s32 cosA);
void MTX44_RotateZSinCos(Mtx44 *dstp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          Cӎ]s̐
//
//ECӎ]sdstpws֐܂B
//
//Eʏł͕ZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  dstp    sobt@̃|C^
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define MTX_RotateAxis(    dstp, axisp, heta)		MTXxx_RotateAxisPriv(    _,   SIN_NDIV_DEFAULT, dstp, axisp, theta)
#define MTX_RotateAxisFast(dstp, axisp, theta)		MTXxx_RotateAxisPrivFast(_,   SIN_NDIV_DEFAULT, dstp, axisp, theta)

#define MTX33_RotateAxis(    dstp, axisp, heta)		MTXxx_RotateAxisPriv(    33_, SIN_NDIV_DEFAULT, dstp, axisp, theta)
#define MTX33_RotateAxisFast(dstp, axisp, theta)	MTXxx_RotateAxisPrivFast(33_, SIN_NDIV_DEFAULT, dstp, axisp, theta)

#define MTX44_RotateAxis(    dstp, axisp, heta)		MTXxx_RotateAxisPriv(    44_, SIN_NDIV_DEFAULT, dstp, axisp, theta)
#define MTX44_RotateAxisFast(dstp, axisp, theta)	MTXxx_RotateAxisPrivFast(44_, SIN_NDIV_DEFAULT, dstp, axisp, theta)

void MTX_RotateAxis256(Mtx *dstp, const Vec *axisp, u32 theta);
void MTX_RotateAxis256Fast(Mtx *dstp, const Vec *axisp, u32 theta);
void MTX_RotateAxis1024(Mtx *dstp, const Vec *axisp, u32 theta);
void MTX_RotateAxis1024Fast(Mtx *dstp, const Vec *axisp, u32 theta);
void MTX_RotateAxis4096(Mtx *dstp, const Vec *axisp, u32 theta);
void MTX_RotateAxis4096Fast(Mtx *dstp, const Vec *axisp, u32 theta);

void MTX33_RotateAxis256(Mtx33 *dstp, const Vec *axisp, u32 theta);
void MTX33_RotateAxis256Fast(Mtx33 *dstp, const Vec *axisp, u32 theta);
void MTX33_RotateAxis1024(Mtx33 *dstp, const Vec *axisp, u32 theta);
void MTX33_RotateAxis1024Fast(Mtx33 *dstp, const Vec *axisp, u32 theta);
void MTX33_RotateAxis4096(Mtx33 *dstp, const Vec *axisp, u32 theta);
void MTX33_RotateAxis4096Fast(Mtx33 *dstp, const Vec *axisp, u32 theta);

void MTX44_RotateAxis256(Mtx44 *dstp, const Vec *axisp, u32 theta);
void MTX44_RotateAxis256Fast(Mtx44 *dstp, const Vec *axisp, u32 theta);
void MTX44_RotateAxis1024(Mtx44 *dstp, const Vec *axisp, u32 theta);
void MTX44_RotateAxis1024Fast(Mtx44 *dstp, const Vec *axisp, u32 theta);
void MTX44_RotateAxis4096(Mtx44 *dstp, const Vec *axisp, u32 theta);
void MTX44_RotateAxis4096Fast(Mtx44 *dstp, const Vec *axisp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define MTXxx_RotateAxisPriv(    xx_, ndiv, dstp, axisp, theta)	MTXxx_RotateAxisNDiv(    xx_, ndiv, dstp, axisp, theta)
#define MTXxx_RotateAxisPrivFast(xx_, ndiv, dstp, axisp, theta)	MTXxx_RotateAxisNDivFast(xx_, ndiv, dstp, axisp, theta)
#define MTXxx_RotateAxisNDiv(    xx_, ndiv, dstp, axisp, theta)	MTX##xx_##RotateAxis##ndiv(         dstp, axisp, theta)
#define MTXxx_RotateAxisNDivFast(xx_, ndiv, dstp, axisp, theta)	MTX##xx_##RotateAxis##ndiv##Fast(   dstp, axisp, theta)

//----------------------------------------------------------------------
//          Cӎ]siOp֐ɂ]pwj̐
//
//ECӎ]sdstpws֐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͕ZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  dstp    sobt@̃|C^
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX_RotateAxisSinCos(Mtx *dstp, const Vec *axisp, s32 sinA, s32 cosA);
void MTX_RotateAxisSinCosFast(Mtx *dstp, const Vec *axisp, s32 sinA, s32 cosA);

void MTX33_RotateAxisSinCos(Mtx33 *dstp, const Vec *axisp, s32 sinA, s32 cosA);
void MTX33_RotateAxisSinCosFast(Mtx33 *dstp, const Vec *axisp, s32 sinA, s32 cosA);

void MTX44_RotateAxisSinCos(Mtx44 *dstp, const Vec *axisp, s32 sinA, s32 cosA);
void MTX44_RotateAxisSinCosFast(Mtx44 *dstp, const Vec *axisp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          yɃACg]s̐
//
//ECӎZ̐ƈv]ss
//  dstpws֐܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//
//EF
//  dstp       sobt@̃|C^
//  vLookInvp  Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX_AlignZ(Mtx *dstp, const Vec *vLookInvp);
void MTX33_AlignZ(Mtx33 *dstp, const Vec *vLookInvp);
void MTX44_AlignZ(Mtx44 *dstp, const Vec *vLookInvp);


//----------------------------------------------------------------------
//          NH[^jIϊ]s̐
//
//ENH[^jIϊ]sdstpws֐܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//
//EF
//  dstp    si[obt@̃|C^
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//ʏł͏Zgp邽߁AfBXvCXgDMA]
//  񂵂ĎsƃXg[\܂B
//----------------------------------------------------------------------

void MTX_QuatMtx(Mtx *dstp, const Quat *quatp);
void MTX_QuatMtxFast(Mtx *dstp, const Quat *quatp);

void MTX33_QuatMtx(Mtx33 *dstp, const Quat *quatp);
void MTX33_QuatMtxFast(Mtx33 *dstp, const Quat *quatp);

void MTX44_QuatMtx(Mtx44 *dstp, const Quat *quatp);
void MTX44_QuatMtxFast(Mtx44 *dstp, const Quat *quatp);


//======================================================================
//          r[s
//======================================================================

//----------------------------------------------------------------------
//          Es̐
//
//EEsdstpws֐܂B
//
//E֐ŃxNg̐K̂߂ɕZƏZgp܂B
//
//EF
//  dstp    sobt@̃|C^
//  eye     _
//  at      _
//  vUp     xNg
//  vDst    0iNULL|C^jȊOnƁAtxNgԂ܂
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX_LookAt(    Mtx *dstp, const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);
void MTX_LookAtFast(Mtx *dstp, const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);


//======================================================================
//          ˉes
//======================================================================

//----------------------------------------------------------------------
//          EΏ̂̓ˉes̐
//
//EEΏ̂̓@̍sdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  fovy    c̎pxm256b1024b4096iKn
//  aspect  ̎m肷ci /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define MTX44_Perspective(dstp, fovy, aspect, near, far, scaleW)		MTX44_PerspectivePriv(SIN_NDIV_DEFAULT, dstp, fovy, aspect, near, far, scaleW)

void MTX44_Perspective256(Mtx44 *dstp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
void MTX44_Perspective1024(Mtx44 *dstp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
void MTX44_Perspective4096(Mtx44 *dstp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define MTX44_PerspectivePriv(ndiv, dstp, fovy, aspect, near, far, scaleW)	MTX44_PerspectiveNDiv(ndiv, dstp, fovy, aspect, near, far, scaleW)
#define MTX44_PerspectiveNDiv(ndiv, dstp, fovy, aspect, near, far, scaleW)	MTX44_Perspective##ndiv(    dstp, fovy, aspect, near, far, scaleW)

//----------------------------------------------------------------------
//          EΏ̂̓ˉesiOp֐ɂ鎋pwj̐
//
//EEΏ̂̓@̍sdstpws֐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EF
//  dstp    sobt@̃|C^
//  sinA    c̎px̃TC
//  cosA    c̎px̃RTCiʊ֐̌ĂяôߍŌɓnj
//  aspect  ̎m肷ci /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX44_PerspectiveSinCos(Mtx44 *dstp, s32 sinA, s32 aspect, s32 near, s32 far, s32 scaleW, s32 cosA);

//----------------------------------------------------------------------
//          ˉes̐
//
//E@̍sdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iɐj
//  f       _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX44_Frustum(Mtx44 *dstp, s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);

//----------------------------------------------------------------------
//          ˉes̐
//
//Eˉe̕s̐ς̍sdstpws֐܂B
//
//EF
//  dstp    sobt@̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iǂłj
//  f       _farNbvʂ܂ł̋ iǂłj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void MTX44_Ortho(  Mtx44 *dstp, s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);


//======================================================================
//          sExNgZ
//======================================================================

//----------------------------------------------------------------------
//          3DxNgƍs̏Z
//
//Esrcpw3DxNgmultwsōWϊʂ
//  dstpw3DxNg֊i[܂B
//
//EF
//  mult    Zs
//  srcp    ZÕxNg
//  dstp    Z̃xNg
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_MultVec(  const Mtx   *mult, Vec *srcp, Vec *dstp);
void MTX33_MultVec(const Mtx33 *mult, Vec *srcp, Vec *dstp);
void MTX44_MultVec(const Mtx44 *mult, Vec *srcp, Vec *dstp);

//----------------------------------------------------------------------
//          3DxNgƍs̏Z
//
//EsrcBasepw3DxNgQmultwsōWϊʂ
//  dstBasepw3DxNgQ֊i[܂B
//
//EF
//  mult      Zs
//  srcBasep  ZÕxNg
//  dstBasep  Z̃xNg
//  count     
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_MultVecArray(  const Mtx   *mult, Vec *srcBasep, Vec *dstBasep, u32 count);
void MTX33_MultVecArray(const Mtx33 *mult, Vec *srcBasep, Vec *dstBasep, u32 count);
void MTX44_MultVecArray(const Mtx44 *mult, Vec *srcBasep, Vec *dstBasep, u32 count);


//----------------------------------------------------------------------
//          3DxNgƍs̃XP[]Ƃ̏Z
//
//Esrcpw3DxNgmultws̃XP[]ōWϊʂ
//  dstpw3DxNg֊i[܂B
//
//EF
//  mult    Zs̃XP[]
//  srcp    ZÕxNg
//  dstp    Z̃xNg
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_MultVecSR(  const Mtx   *mult, Vec *srcp, Vec *dstp);
void MTX44_MultVecSR(const Mtx44 *mult, Vec *srcp, Vec *dstp);

//----------------------------------------------------------------------
//          3DxNgƍs̃XP[]Ƃ̏Z
//
//EsrcBasepw3DxNgQmultws̃XP[]ōWϊʂ
//  dstBasepw3DxNgQ֊i[܂B
//
//EF
//  mult      Zs̃XP[]
//  srcBasep  ZÕxNg
//  dstBasep  Z̃xNg
//  count     
//
//E߂lFȂ
//----------------------------------------------------------------------

void MTX_MultVecArraySR(  const Mtx   *mult, Vec *srcBasep, Vec *dstBasep, u32 count);
void MTX44_MultVecArraySR(const Mtx44 *mult, Vec *srcBasep, Vec *dstBasep, u32 count);



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_MTX_H
