;=======================================================================
;          IrisMemoryMapArm.s
;            IRIS }bv萔iARMASMpj
;
;          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
;=======================================================================
    IF :DEF: _IRIS_MEMORY_MAP_H
    ELSE
_IRIS_MEMORY_MAP_H  *  1


    INCLUDE     IrisTargetArm.s
    INCLUDE     IrisDefineArm.s


;-----------------------------------------------------------------------
;                       E}bv
;-----------------------------------------------------------------------

SHARED_WORK             *   0x027ff000          ; botԋL[N̈
SHARED_WORK_END         *   0x02800000

    IF :DEF: NDEBUG
SUBP_PRV                *   0x02380000          ; TuvZbTL̈i[Xo[Wj
    ELSE
    IF :DEF: MMEM_4M
SUBP_PRV                *   0x02300000          ;                       ifobOo[WCSl{́j
    ELSE
SUBP_PRV                *   0x02600000          ;                       ifobOo[WCWl{́j
    ENDIF
    ENDIF
SUBP_PRV_END            *   SHARED_WORK


    IF :DEF: IRIS_TEG :LOR: :DEF: IRIS_TS
ITCM                    *   0x01ff8000          ; ߂sbl
ITCM_END                *   (ITCM + 0x8000)
DTCM                    *   SUBP_PRV            ; f[^sblisdf{[hȍ~j
    ELSE
DTCM                    *   0x8000              ;             iubh{[hpj
    ENDIF
DTCM_END                *   (DTCM + 0x4000)

INTR_VECTOR_BUF         *   (DTCM_END - 0x4)    ; 荞ݕAhX
INTR_CHECK_BUF          *   (DTCM_END - 0x8)    ; 荞݃`FbN

SEND_FIFO_LOCK_BUF      *   (DTCM_END - 0x10)   ; botԑMehenEbNobt@
TIMER3_LOCK_BUF         *   (DTCM_END - 0x12)   ; ^C}[REbNobt@
TIMER2_LOCK_BUF         *   (DTCM_END - 0x14)   ; ^C}[Q
TIMER1_LOCK_BUF         *   (DTCM_END - 0x16)   ; ^C}[P
TIMER0_LOCK_BUF         *   (DTCM_END - 0x18)   ; ^C}[O
DMA3_LOCK_BUF           *   (DTCM_END - 0x1a)   ; cl`REbNobt@
DMA2_LOCK_BUF           *   (DTCM_END - 0x1c)   ; cl`Q
DMA1_LOCK_BUF           *   (DTCM_END - 0x1e)   ; cl`P
DMA0_LOCK_BUF           *   (DTCM_END - 0x20)   ; cl`O


MAIN_MEM                *   0x02000000          ; C
MAIN_MEM_END            *   (MAIN_MEM + 0x400000)
MAIN_MEM_EX_END         *   (MAIN_MEM + 0x800000) ;ig̍ŏIAhXj

MAIN_MEM_CMD_AREA       *   (MAIN_MEM_EX_END - 0x2)  ; CR}hsGAigp֎~GAj

SHARED_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x40) ; L\[XEbNobt@
SHARED_LOCK_BUF_END     *   (MAIN_MEM_EX_END - 0x10)

INIT_LOCK_BUF           *   (MAIN_MEM_EX_END - 0x10) ; bNobt@
CARTRIDGE_LOCK_BUF      *   (MAIN_MEM_EX_END - 0x18) ; J[gbWEbNobt@
CARD_LOCK_BUF           *   (MAIN_MEM_EX_END - 0x20) ; J[hEbNobt@
WRAM_BLOCK1_LOCK_BUF    *   (MAIN_MEM_EX_END - 0x28) ; bot[Nq`lEubNPEbNobt@
WRAM_BLOCK0_LOCK_BUF    *   (MAIN_MEM_EX_END - 0x30) ;                         ubNOEbNobt@
VRAM_D_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x38) ; uq`l|cEbNobt@
VRAM_C_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x40) ;           bEbNobt@

FROM_SUBP_IF_BUF        *   (MAIN_MEM_EX_END - 0x50) ; TuCvZbT荞ݗvtOiQa~Wj
WM_FROM_SUBP_IF_BUF     *   (MAIN_MEM_EX_END - 0x50) ;     CX}l[W\
TO_SUBP_IF_BUF          *   (MAIN_MEM_EX_END - 0x60) ; CTuvZbT荞ݗvtOiQa~Wj
WM_TO_SUBP_IF_BUF       *   (MAIN_MEM_EX_END - 0x60) ;     CX}l[W\

ROM_HEADER_BUF          *   (MAIN_MEM_EX_END - 0x200); qnlo^GAf[^Eobt@

DMA_CLEAR_DATA_BUF      *   (MAIN_MEM_EX_END - 0x210); cl`NAf[^Eobt@ibΉAp~\j


CPU_WRAM                *   0x037f8000          ; bot[Nq`l
CPU_WRAM_END            *   (CPU_WRAM + 0x8000)
CPU_WRAM_BLOCK0         *   0x037f8000          ;                        ubNO
CPU_WRAM_BLOCK0_END     *   (CPU_WRAM_BLOCK0 + 0x4000)
CPU_WRAM_BLOCK1         *   0x037fc000          ;                        ubNP
CPU_WRAM_BLOCK1_END     *   (CPU_WRAM_BLOCK1 + 0x4000)


REG_BASE                *   0x04000000          ; WX^Q
PLTT                    *   0x05000000          ; pbgq`l
PLTT_END                *   (PLTT +      0x400)
BG_PLTT                 *   (PLTT +        0x0) ;   afpbgq`l
BG_PLTT_END             *   (PLTT +      0x200)
OBJ_PLTT                *   (PLTT +      0x200) ; naipbgq`l
OBJ_PLTT_END            *   (PLTT +      0x400)
VRAM                    *   0x06000000          ; uq`l
BG_VRAM                 *   (VRAM +        0x0) ; afLN^/XN[q`l
BG_VRAM_END             *   (VRAM +    0x80000)
OBJ_VRAM                *   (VRAM +   0x400000) ; naiLN^q`l
OBJ_VRAM_END            *   (VRAM +   0x440000)
LCDC_VRAM               *   (VRAM +   0x800000) ; kbcb|uq`l
LCDC_VRAM_A             *   (VRAM +   0x800000)
LCDC_VRAM_B             *   (VRAM +   0x820000)
LCDC_VRAM_C             *   (VRAM +   0x840000)
LCDC_VRAM_D             *   (VRAM +   0x860000)
LCDC_VRAM_E             *   (VRAM +   0x880000)
LCDC_VRAM_F             *   (VRAM +   0x890000)
LCDC_VRAM_G             *   (VRAM +   0x894000)
LCDC_VRAM_END           *   (VRAM +   0x898000)
OAM                     *   0x07000000          ; n`l
OAM_END                 *   (OAM +       0x400)

CARTRIDGE               *   0x08000000          ; J[gbW
CTRDG_AD16_BANK0        *   0x08000000          ; J[gbW `cPUoX oNO
CTRDG_AD16_BANK0_END    *   0x0a000000
CTRDG_AD16_BANK1        *   0x0a000000          ;                           oNP
CTRDG_AD16_BANK1_END    *   0x0c000000
CTRDG_AD16_BANK2        *   0x0c000000          ;                           oNQ
CTRDG_AD16_BANK2_END    *   0x0e000000
CTRDG_DT8               *   0x0e000000          ; J[gbW Wf[^oX
CTRDG_DT8_END           *   0x10000000

BIOS                    *   0xffff0000          ; ahnr
BIOS_END                *   (BIOS + 0x8000)


;-----------------------------------------------------------------------
;                       ETCY
;-----------------------------------------------------------------------

SHARED_WORK_SIZE        *   (SHARED_WORK_END - SHARED_WORK) ; botԋL[N̈iSjaȏAQׂ̂TCYj
SUBP_PRV_SIZE           *   (SUBP_PRV_END - SUBP_PRV)       ; TuvZbTL̈iRQjaȏAQׂ̂TCYj

SHARED_LOCK_BUF_SIZE    *   (SHARED_LOCK_BUF_END - SHARED_LOCK_BUF) ; L\[XEbNobt@


ITCM_SIZE               *   0x8000              ;   ߂sbl
DTCM_SIZE               *   0x4000              ; f[^sbl
ICACHE_SIZE             *   0x2000              ;   ߃LbV
DCACHE_SIZE             *   0x1000              ; f[^LbV

CACHE_LINE_SIZE         *   32                  ; LbVC

MAIN_MEM_SIZE           *   0x400000            ; C
MAIN_MEM_EX_SIZE        *   0x800000            ; igj

CPU_WRAM_SIZE           *   0x8000              ; bot[Nq`l v
CPU_WRAM_BLOCK0_SIZE    *   0x4000              ;                        ubNO
CPU_WRAM_BLOCK1_SIZE    *   0x4000              ;                        ubNP

MROM_PAGE_SIZE          *   512                 ; }XNqnlEy[W

PLTT_SIZE               *   (2*256*2)           ; pbgq`l
BG_PLTT_SIZE            *   (2*256)             ;   afpbgq`l
OBJ_PLTT_SIZE           *   (2*256)             ; naipbgq`l
BG_VRAM_SIZE            *   0x80000             ;     af|uq`l
OBJ_VRAM_SIZE           *   0x40000             ;   nai|uq`l
LCDC_VRAM_SIZE          *   0x98000             ; kbcb|uq`l
VRAM_A_SIZE             *   0x20000             ; uq`l|`
VRAM_B_SIZE             *   0x20000             ;           a
VRAM_C_SIZE             *   0x20000             ;           b
VRAM_D_SIZE             *   0x20000             ;           c
VRAM_E_SIZE             *   0x10000             ;           d
VRAM_F_SIZE             *   0x4000              ;           e
VRAM_G_SIZE             *   0x4000              ;           f
OAM_SIZE                *   (8*128)             ; n`l

CARTRIDGE_SIZE          *   0x02000000          ; J[gbW
CTRDG_AD16_BANK_SIZE    *   0x02000000          ; J[gbW `cPUoX oN
CTRDG_AD16_BANK0_SIZE   *   0x02000000          ;                           oNO
CTRDG_AD16_BANK1_SIZE   *   0x02000000          ;                           oNP
CTRDG_AD16_BANK2_SIZE   *   0x02000000          ;                           oNQ
CTRDG_DT8_SIZE          *   0x02000000          ; J[gbW Wf[^oX

BIOS_SIZE               *   0x8000              ; ahnr


;-----------------------------------------------------------------------
;                       WX^EAhX
;-----------------------------------------------------------------------

REG_IME             *   (REG_BASE + 0x208)  ; 荞݃}X^Cl[u
REG_IE              *   (REG_BASE + 0x210)  ; 荞݋
REG_IF              *   (REG_BASE + 0x214)  ; 荞ݗv


REG_SUBPINTF        *   (REG_BASE + 0x180)  ; TuvZbTC^tF[X
REG_SUBP_FIFO_CNT   *   (REG_BASE + 0x184)  ; botԂehenRg[
REG_SEND_FIFO       *   (REG_BASE + 0x188)      ; Mehen
REG_RECV_FIFO       *   (REG_BASE + 0x100000)   ; Mehen

REG_EXMEMCNT        *   (REG_BASE + 0x204)  ; ORg[

REG_POWCNT          *   (REG_BASE + 0x304)  ; p[Rg[


REG_DIVCNT          *   (REG_BASE + 0x280)  ; Z Rg[
REG_DIV_NUMER       *   (REG_BASE + 0x290)  ; 폜
REG_DIV_DENOM       *   (REG_BASE + 0x298)  ; 
REG_DIV_RESULT      *   (REG_BASE + 0x2a0)  ; 
REG_DIVREM_RESULT   *   (REG_BASE + 0x2a8)  ; ]

REG_SQRTCNT         *   (REG_BASE + 0x2b0)  ; Z Rg[
REG_SQRT_RESULT     *   (REG_BASE + 0x2b4)  ; 
REG_SQRT_PARAM      *   (REG_BASE + 0x2b8)  ; p[^


REG_DISPCNT         *   (REG_BASE + 0x0)    ; \Rg[
REG_DISPCNT_L       *   (REG_BASE + 0x0)
REG_DISPCNT_H       *   (REG_BASE + 0x2)
REG_DISP2DCNT       *   (REG_BASE + 0x0)    ; Qc\Rg[
REG_DISP3DCNT       *   (REG_BASE + 0x60)   ; Rc\Rg[

REG_DISPSTAT        *   (REG_BASE + 0x4)    ; \Xe[^X
REG_VCOUNT          *   (REG_BASE + 0x6)    ; uJE^
REG_GXSTAT          *   (REG_BASE + 0x600)  ; WIgGWXe[^X


REG_VRAMCNT         *   (REG_BASE + 0x240)  ; uq`lRg[
REG_WRAMCNT         *   (REG_BASE + 0x247)  ; [Nq`lRg[
REG_WVRAMCNT        *   (REG_BASE + 0x244)  ; uq`l d`f { [Nq`l Rg[
REG_VRAM_A_CNT      *   (REG_BASE + 0x240)  ; uq`l `
REG_VRAM_B_CNT      *   (REG_BASE + 0x241)  ; uq`l a
REG_VRAM_C_CNT      *   (REG_BASE + 0x242)  ; uq`l b
REG_VRAM_D_CNT      *   (REG_BASE + 0x243)  ; uq`l c
REG_VRAM_E_CNT      *   (REG_BASE + 0x244)  ; uq`l d
REG_VRAM_F_CNT      *   (REG_BASE + 0x245)  ; uq`l e
REG_VRAM_G_CNT      *   (REG_BASE + 0x246)  ; uq`l f
REG_VRAM_H_CNT      *   (REG_BASE + 0x248)  ; uq`l g
REG_VRAM_I_CNT      *   (REG_BASE + 0x249)  ; uq`l h
REG_VRAM_AB_CNT     *   (REG_BASE + 0x240)  ; uq`l `a
REG_VRAM_CD_CNT     *   (REG_BASE + 0x242)  ; uq`l bc
REG_VRAM_EF_CNT     *   (REG_BASE + 0x244)  ; uq`l de
REG_VRAM_G_W_CNT    *   (REG_BASE + 0x246)  ; uq`l f     { [Nq`l
REG_VRAM_ABCD_CNT   *   (REG_BASE + 0x240)  ; uq`l ``c
REG_VRAM_EFG_W_CNT  *   (REG_BASE + 0x244)  ; uq`l d`f { [Nq`l
REG_VRAM_HI_CNT     *   (REG_BASE + 0x248)  ; uq`l gh



REG_MASTER_BRIGHT   *   (REG_BASE + 0x6c)   ; }X^[Px Rg[
REG_DISPCAPCNT      *   (REG_BASE + 0x64)   ; \Lv` Rg[
REG_DISP_MMEM_FIFO  *   (REG_BASE + 0x68)   ; C\ehen


REG_MOSAIC          *   (REG_BASE + 0x4c)   ; UCN TCY

REG_BLDCNT          *   (REG_BASE + 0x50)   ; uh[h Rg[
REG_BLDALPHA        *   (REG_BASE + 0x52)   ;    p[^
REG_BLDY            *   (REG_BASE + 0x54)   ; PxύX p[^

REG_WINCNT          *   (REG_BASE + 0x40)   ; EChE  Rg[
REG_WIN0H           *   (REG_BASE + 0x40)   ; EChEÖ
REG_WIN1H           *   (REG_BASE + 0x42)   ; EChEP̈
REG_WIN0V           *   (REG_BASE + 0x44)   ; EChEÖ
REG_WIN1V           *   (REG_BASE + 0x46)   ; EChEP̈
REG_WININ           *   (REG_BASE + 0x48)   ; EChERg[
REG_WIN0            *   (REG_BASE + 0x48)   ; EChEORg[
REG_WIN1            *   (REG_BASE + 0x49)   ; EChEPRg[
REG_WIN01           *   (REG_BASE + 0x48)   ; EChEOEPRg[
REG_WINOUT          *   (REG_BASE + 0x4a)   ; EChEORg[
REG_OBJWIN          *   (REG_BASE + 0x4b)   ; naiEChERg[
REG_WINOUTOBJ       *   (REG_BASE + 0x4a)   ; EChEOEnaiEChERg[


REG_BGCNT           *   (REG_BASE + 0x8)    ; afRg[
REG_BG0CNT          *   (REG_BASE + 0x8)    ; afORg[
REG_BG1CNT          *   (REG_BASE + 0xa)    ; afPRg[
REG_BG2CNT          *   (REG_BASE + 0xc)    ; afQRg[
REG_BG3CNT          *   (REG_BASE + 0xe)    ; afRRg[
REG_BGOFS           *   (REG_BASE + 0x10)   ; afItZbg
REG_BG0HOFS         *   (REG_BASE + 0x10)   ; afOgItZbg
REG_BG0VOFS         *   (REG_BASE + 0x12)   ; afOuItZbg
REG_BG1HOFS         *   (REG_BASE + 0x14)   ; afPgItZbg
REG_BG1VOFS         *   (REG_BASE + 0x16)   ; afPuItZbg
REG_BG2HOFS         *   (REG_BASE + 0x18)   ; afQgItZbg
REG_BG2VOFS         *   (REG_BASE + 0x1a)   ; afQuItZbg
REG_BG3HOFS         *   (REG_BASE + 0x1c)   ; afRgItZbg
REG_BG3VOFS         *   (REG_BASE + 0x1e)   ; afRuItZbg
REG_BG2AFFINE       *   (REG_BASE + 0x20)   ; afQAtBϊp[^Q
REG_BG2PA           *   (REG_BASE + 0x20)   ; afQCwW
REG_BG2PB           *   (REG_BASE + 0x22)   ; afQ  wW
REG_BG2PC           *   (REG_BASE + 0x24)   ; afQCxW
REG_BG2PD           *   (REG_BASE + 0x26)   ; afQ  xW
REG_BG2X            *   (REG_BASE + 0x28)   ; afQX^[gwW
REG_BG2Y            *   (REG_BASE + 0x2c)   ; afQX^[gxW
REG_BG3AFFINE       *   (REG_BASE + 0x30)   ; afRAtBϊp[^Q
REG_BG3PA           *   (REG_BASE + 0x30)   ; afRCwW
REG_BG3PB           *   (REG_BASE + 0x32)   ; afR  wW
REG_BG3PC           *   (REG_BASE + 0x34)   ; afRCxW
REG_BG3PD           *   (REG_BASE + 0x36)   ; afR  xW
REG_BG3X            *   (REG_BASE + 0x38)   ; afRX^[gwW
REG_BG3Y            *   (REG_BASE + 0x3c)   ; afRX^[gxW



REG_GXFIFO          *   (REG_BASE + 0x400)  ; WIgehen

REG_LISTRAM_COUNT   *   (REG_BASE + 0x604)  ; |SXgq`lJE^
REG_VTXRAM_COUNT    *   (REG_BASE + 0x606)  ; _q`lJE^
REG_RDLINES_COUNT   *   (REG_BASE + 0x320)  ; _Oς݃CJE^


REG_SWAP_BUFFERS    *   (REG_BASE + 0x540)  ; _OGWQƃf[^Q̃Xbv

REG_VIEWPORT        *   (REG_BASE + 0x580)  ; E

REG_MTX_MODE        *   (REG_BASE + 0x440)  ; s񃂁[h

REG_MTX_PUSH        *   (REG_BASE + 0x444)  ; svbV
REG_MTX_POP         *   (REG_BASE + 0x448)  ; s|bv
REG_MTX_STORE       *   (REG_BASE + 0x44c)  ; sXgA
REG_MTX_RESTORE     *   (REG_BASE + 0x450)  ; s񃊃XgA

REG_MTX_IDENTITY    *   (REG_BASE + 0x454)  ; Pʍs 
REG_MTX_LOAD_4x4    *   (REG_BASE + 0x458)  ; s񃍁[hiSSj
REG_MTX_LOAD_4x3    *   (REG_BASE + 0x45c)  ;           iSRj
REG_MTX_MULT_4x4    *   (REG_BASE + 0x460)  ; sZ    iSSj
REG_MTX_MULT_4x3    *   (REG_BASE + 0x464)  ;             iSRj
REG_MTX_MULT_3x3    *   (REG_BASE + 0x468)  ;             iRRj
REG_MTX_SCALE       *   (REG_BASE + 0x46c)  ; XP[sZiPRj
REG_MTX_TRANS       *   (REG_BASE + 0x470)  ; ړsZiPRj

REG_CLIPMTX_RESULT  *   (REG_BASE + 0x640)  ; JgNbvWs ǂݍ
REG_VECMTX_RESULT   *   (REG_BASE + 0x680)  ; JgxNgs ǂݍ


REG_LIGHT_VECTOR    *   (REG_BASE + 0x4c8)  ; CgxNg
REG_LIGHT_COLOR     *   (REG_BASE + 0x4cc)  ; CgJ[

REG_MATERIAL_COLOR  *   (REG_BASE + 0x4c0)  ; }eAJ[
REG_DIF_AMB         *   (REG_BASE + 0x4c0)  ; gU  
REG_SPE_EMI         *   (REG_BASE + 0x4c4)  ; ˌ  ˌ
REG_SHININESS       *   (REG_BASE + 0x4d0)  ; ʔˋPx


REG_POLYGON_ATTR    *   (REG_BASE + 0x4a4)  ; |S

REG_TEX_PARAM       *   (REG_BASE + 0x4a8)  ; eNX`p[^
REG_TEXIMAGE_PARAM  *   (REG_BASE + 0x4a8)
REG_TEXPLTT_BASE    *   (REG_BASE + 0x4ac)

REG_BEGIN_VTXS      *   (REG_BASE + 0x500)  ; _Xg X^[g
REG_END_VTXS        *   (REG_BASE + 0x504)  ; _Xg Gh

REG_COLOR           *   (REG_BASE + 0x480)  ; _J[
REG_NORMAL          *   (REG_BASE + 0x484)  ; _@
REG_TEXCOORD        *   (REG_BASE + 0x488)  ; _eNX`W
REG_VTX_16          *   (REG_BASE + 0x48c)  ; _16bitW
REG_VTX_10          *   (REG_BASE + 0x490)  ; _10bitW
REG_VTX_XY          *   (REG_BASE + 0x494)  ; _16bitXYW
REG_VTX_XZ          *   (REG_BASE + 0x498)  ; _16bitXZW
REG_VTX_YZ          *   (REG_BASE + 0x49c)  ; _16bitYZW
REG_VTX_DIFF        *   (REG_BASE + 0x4a0)  ; _16bitWl

REG_BOX_TEST        *   (REG_BASE + 0x5c0)  ; {bNXeXg
REG_POS_TEST        *   (REG_BASE + 0x5c4)  ; ʒueXg
REG_VEC_TEST        *   (REG_BASE + 0x5c8)  ; xNgeXg

REG_POS_RESULT      *   (REG_BASE + 0x620)  ; ʒueXg
REG_VEC_RESULT      *   (REG_BASE + 0x630)  ; xNgeXg


REG_CLEAR_COLOR_ATTR *  (REG_BASE + 0x350)  ; J[obt@ NAl
REG_CLEAR_DEPTH     *   (REG_BASE + 0x354)  ; yobt@ NAl
REG_CLRIMAGE_OFFSET *   (REG_BASE + 0x356)  ; NAC[W ItZbg

REG_EDGE_COLOR      *   (REG_BASE + 0x330)  ; GbWJ[

REG_FOG_COLOR       *   (REG_BASE + 0x358)  ; tHO J[
REG_FOG_OFFSET      *   (REG_BASE + 0x35c)  ; tHO ItZbg
REG_FOG_TABLE       *   (REG_BASE + 0x360)  ; tHOZxe[u

REG_TOON_TABLE      *   (REG_BASE + 0x380)  ; gD[VF[fBOEe[u

REG_ALPHA_TEST_REF  *   (REG_BASE + 0x340)  ; At@eXgQƒl

REG_DISP_1DOT_DEPTH *   (REG_BASE + 0x610)  ; Phbg|S`Jnyl



REG_DMA0            *   (REG_BASE + 0xb0)   ; cl`O
REG_DMA0SAD         *   (REG_BASE + 0xb0)
REG_DMA0DAD         *   (REG_BASE + 0xb4)
REG_DMA0CNT         *   (REG_BASE + 0xb8)
REG_DMA0CNT_L       *   (REG_BASE + 0xb8)
REG_DMA0CNT_H       *   (REG_BASE + 0xba)
REG_DMA1            *   (REG_BASE + 0xbc)   ; cl`P
REG_DMA1SAD         *   (REG_BASE + 0xbc)
REG_DMA1DAD         *   (REG_BASE + 0xc0)
REG_DMA1CNT         *   (REG_BASE + 0xc4)
REG_DMA1CNT_L       *   (REG_BASE + 0xc4)
REG_DMA1CNT_H       *   (REG_BASE + 0xc6)
REG_DMA2            *   (REG_BASE + 0xc8)   ; cl`Q
REG_DMA2SAD         *   (REG_BASE + 0xc8)
REG_DMA2DAD         *   (REG_BASE + 0xcc)
REG_DMA2CNT         *   (REG_BASE + 0xd0)
REG_DMA2CNT_L       *   (REG_BASE + 0xd0)
REG_DMA2CNT_H       *   (REG_BASE + 0xd2)
REG_DMA3            *   (REG_BASE + 0xd4)   ; cl`R
REG_DMA3SAD         *   (REG_BASE + 0xd4)
REG_DMA3DAD         *   (REG_BASE + 0xd8)
REG_DMA3CNT         *   (REG_BASE + 0xdc)
REG_DMA3CNT_L       *   (REG_BASE + 0xdc)
REG_DMA3CNT_H       *   (REG_BASE + 0xde)
    IF :DEF: IRIS_TS
REG_DMA0_CLR_DATA   *   (REG_BASE + 0xe0)   ; cl` NAf[^
REG_DMA1_CLR_DATA   *   (REG_BASE + 0xe4)
REG_DMA2_CLR_DATA   *   (REG_BASE + 0xe8)
REG_DMA3_CLR_DATA   *   (REG_BASE + 0xec)
    ELSE
REG_DMA0_CLR_DATA   *   (DMA_CLEAR_DATA_BUF + 0x0)
REG_DMA1_CLR_DATA   *   (DMA_CLEAR_DATA_BUF + 0x4)
REG_DMA2_CLR_DATA   *   (DMA_CLEAR_DATA_BUF + 0x8)
REG_DMA3_CLR_DATA   *   (DMA_CLEAR_DATA_BUF + 0xc)
    ENDIF


REG_TM0CNT          *   (REG_BASE + 0x100)  ; ^C}[O
REG_TM0CNT_L        *   (REG_BASE + 0x100)
REG_TM0CNT_H        *   (REG_BASE + 0x102)
REG_TM1CNT          *   (REG_BASE + 0x104)  ; ^C}[P
REG_TM1CNT_L        *   (REG_BASE + 0x104)
REG_TM1CNT_H        *   (REG_BASE + 0x106)
REG_TM2CNT          *   (REG_BASE + 0x108)  ; ^C}[Q
REG_TM2CNT_L        *   (REG_BASE + 0x108)
REG_TM2CNT_H        *   (REG_BASE + 0x10a)
REG_TM3CNT          *   (REG_BASE + 0x10c)  ; ^C}[R
REG_TM3CNT_L        *   (REG_BASE + 0x10c)
REG_TM3CNT_H        *   (REG_BASE + 0x10e)


REG_KEYINPUT        *   (REG_BASE + 0x130)  ; L[
REG_KEYCNT          *   (REG_BASE + 0x132)  ; L[Rg[

REG_R0CNT           *   (REG_BASE + 0x134)  ; ėp|[gO
REG_R1CNT           *   (REG_BASE + 0x138)  ;           P


;-----------------------------------------------------------------------
;                       WX^EItZbg
;-----------------------------------------------------------------------

OFFSET_REG_IME              *   0x208       ; 荞݃}X^Cl[u
OFFSET_REG_IE               *   0x210       ; 荞݋
OFFSET_REG_IF               *   0x214       ; 荞ݗv

OFFSET_REG_SUBPINTF         *   0x180       ; TuvZbTC^tF[X
OFFSET_REG_SUBP_FIFO_CNT    *   0x184       ; botԂehenRg[
OFFSET_REG_SEND_FIFO        *   0x188       ;     Mehen
OFFSET_REG_RECV_FIFO        *   0x100000    ;     Mehen

OFFSET_REG_EXMEMCNT         *   0x204       ; ORg[

OFFSET_REG_POWCNT           *   0x304       ; p[Rg[


OFFSET_REG_DIVCNT           *   0x280       ; Z Rg[
OFFSET_REG_DIV_NUMER        *   0x290       ; 폜
OFFSET_REG_DIV_DENOM        *   0x298       ; 
OFFSET_REG_DIV_RESULT       *   0x2a0       ; 
OFFSET_REG_DIVREM_RESULT    *   0x2a8       ; ]

OFFSET_REG_SQRTCNT          *   0x2b0       ; Z Rg[
OFFSET_REG_SQRT_RESULT      *   0x2b4       ; 
OFFSET_REG_SQRT_PARAM       *   0x2b8       ; p[^


OFFSET_REG_DISPCNT          *   0x0         ; \Rg[
OFFSET_REG_DISPCNT_L        *   0x0
OFFSET_REG_DISPCNT_H        *   0x2
OFFSET_REG_DISP2DCNT        *   0x0         ; Qc\Rg[
OFFSET_REG_DISP3DCNT        *   0x60        ; Rc\Rg[

OFFSET_REG_DISPSTAT         *   0x4         ; \Xe[^X
OFFSET_REG_VCOUNT           *   0x6         ; uJE^
OFFSET_REG_GXSTAT           *   0x600       ; WIgGWXe[^X


OFFSET_REG_VRAMCNT          *   0x240       ; uq`lRg[
OFFSET_REG_WRAMCNT          *   0x247       ; [Nq`lRg[
OFFSET_REG_WVRAMCNT         *   0x244       ; uq`l d`f { [Nq`l Rg[
OFFSET_REG_VRAM_A_CNT       *   0x240       ; uq`l `
OFFSET_REG_VRAM_B_CNT       *   0x241       ; uq`l a
OFFSET_REG_VRAM_C_CNT       *   0x242       ; uq`l b
OFFSET_REG_VRAM_D_CNT       *   0x243       ; uq`l c
OFFSET_REG_VRAM_E_CNT       *   0x244       ; uq`l d
OFFSET_REG_VRAM_F_CNT       *   0x245       ; uq`l e
OFFSET_REG_VRAM_G_CNT       *   0x246       ; uq`l f
OFFSET_REG_VRAM_H_CNT       *   0x248       ; uq`l g
OFFSET_REG_VRAM_I_CNT       *   0x249       ; uq`l h
OFFSET_REG_VRAM_AB_CNT      *   0x240       ; uq`l `a
OFFSET_REG_VRAM_CD_CNT      *   0x242       ; uq`l bc
OFFSET_REG_VRAM_EF_CNT      *   0x244       ; uq`l de
OFFSET_REG_VRAM_G_W_CNT     *   0x246       ; uq`l f     { [Nq`l
OFFSET_REG_VRAM_ABCD_CNT    *   0x240       ; uq`l ``c
OFFSET_REG_VRAM_EFG_W_CNT   *   0x244       ; uq`l d`f { [Nq`l
OFFSET_REG_VRAM_HI_CNT      *   0x248       ; uq`l gh


OFFSET_REG_MASTER_BRIGHT    *   0x6c        ; }X^[Px Rg[
OFFSET_REG_DISPCAPCNT       *   0x64        ; \Lv` Rg[
OFFSET_REG_DISP_MMEM_FIFO   *   0x68        ; C\ehen
OFFSET_REG_TVOUTCNT         *   0x70        ; ero̓Rg[


OFFSET_REG_MOSAIC           *   0x4c        ; UCN TCY

OFFSET_REG_BLDCNT           *   0x50        ; uh[h Rg[
OFFSET_REG_BLDALPHA         *   0x52        ;    p[^
OFFSET_REG_BLDY             *   0x54        ; PxύX p[^

OFFSET_REG_WINCNT           *   0x40        ; EChE  Rg[
OFFSET_REG_WIN0H            *   0x40        ; EChEÖ
OFFSET_REG_WIN1H            *   0x42        ; EChEP̈
OFFSET_REG_WIN0V            *   0x44        ; EChEÖ
OFFSET_REG_WIN1V            *   0x46        ; EChEP̈
OFFSET_REG_WININ            *   0x48        ; EChERg[
OFFSET_REG_WIN0             *   0x48        ; EChEORg[
OFFSET_REG_WIN1             *   0x49        ; EChEPRg[
OFFSET_REG_WIN01            *   0x48        ; EChEOEPRg[
OFFSET_REG_WINOUT           *   0x4a        ; EChEORg[
OFFSET_REG_OBJWIN           *   0x4b        ; naiEChERg[
OFFSET_REG_WINOUTOBJ        *   0x4a        ; EChEOEnaiEChERg[


OFFSET_REG_BGCNT            *   0x8         ; afRg[
OFFSET_REG_BG0CNT           *   0x8         ; afORg[
OFFSET_REG_BG1CNT           *   0xa         ; afPRg[
OFFSET_REG_BG2CNT           *   0xc         ; afQRg[
OFFSET_REG_BG3CNT           *   0xe         ; afRRg[
OFFSET_REG_BGOFS            *   0x10        ; afItZbg
OFFSET_REG_BG0HOFS          *   0x10        ; afOgItZbg
OFFSET_REG_BG0VOFS          *   0x12        ; afOuItZbg
OFFSET_REG_BG1HOFS          *   0x14        ; afPgItZbg
OFFSET_REG_BG1VOFS          *   0x16        ; afPuItZbg
OFFSET_REG_BG2HOFS          *   0x18        ; afQgItZbg
OFFSET_REG_BG2VOFS          *   0x1a        ; afQuItZbg
OFFSET_REG_BG3HOFS          *   0x1c        ; afRgItZbg
OFFSET_REG_BG3VOFS          *   0x1e        ; afRuItZbg
OFFSET_REG_BG2AFFINE        *   0x20        ; afQAtBϊp[^Q
OFFSET_REG_BG2PA            *   0x20        ; afQCwW
OFFSET_REG_BG2PB            *   0x22        ; afQ  wW
OFFSET_REG_BG2PC            *   0x24        ; afQCxW
OFFSET_REG_BG2PD            *   0x26        ; afQ  xW
OFFSET_REG_BG2X             *   0x28        ; afQX^[gwW
OFFSET_REG_BG2Y             *   0x2c        ; afQX^[gxW
OFFSET_REG_BG3AFFINE        *   0x30        ; afRAtBϊp[^Q
OFFSET_REG_BG3PA            *   0x30        ; afRCwW
OFFSET_REG_BG3PB            *   0x32        ; afR  wW
OFFSET_REG_BG3PC            *   0x34        ; afRCxW
OFFSET_REG_BG3PD            *   0x36        ; afR  xW
OFFSET_REG_BG3X             *   0x38        ; afRX^[gwW
OFFSET_REG_BG3Y             *   0x3c        ; afRX^[gxW



OFFSET_REG_GXFIFO           *   0x400       ; WIgehen

OFFSET_REG_LISTRAM_COUNT    *   0x604       ; |SXgq`lJE^
OFFSET_REG_VTXRAM_COUNT     *   0x606       ; _q`lJE^
OFFSET_REG_RDLINES_COUNT    *   0x320       ; _Oς݃CJE^


OFFSET_REG_SWAP_BUFFERS     *   0x540       ; _OGWQƃf[^Q̃Xbv

OFFSET_REG_VIEWPORT         *   0x580       ; E

OFFSET_REG_MTX_MODE         *   0x440       ; s񃂁[h

OFFSET_REG_MTX_PUSH         *   0x444       ; svbV
OFFSET_REG_MTX_POP          *   0x448       ; s|bv
OFFSET_REG_MTX_STORE        *   0x44c       ; sXgA
OFFSET_REG_MTX_RESTORE      *   0x450       ; s񃊃XgA

OFFSET_REG_MTX_IDENTITY     *   0x454       ; Pʍs 
OFFSET_REG_MTX_LOAD_4x4     *   0x458       ; s񃍁[hiSSj
OFFSET_REG_MTX_LOAD_4x3     *   0x45c       ;           iSRj
OFFSET_REG_MTX_MULT_4x4     *   0x460       ; sZ    iSSj
OFFSET_REG_MTX_MULT_4x3     *   0x464       ;             iSRj
OFFSET_REG_MTX_MULT_3x3     *   0x468       ;             iRRj
OFFSET_REG_MTX_SCALE        *   0x46c       ; XP[sZiPRj
OFFSET_REG_MTX_TRANS        *   0x470       ; ړsZiPRj

OFFSET_REG_CLIPMTX_RESULT   *   0x640       ; JgNbvWs ǂݍ
OFFSET_REG_VECMTX_RESULT    *   0x680       ; JgxNgs ǂݍ


OFFSET_REG_LIGHT_VECTOR     *   0x4c8       ; CgxNg
OFFSET_REG_LIGHT_COLOR      *   0x4cc       ; CgJ[

OFFSET_REG_MATERIAL_COLOR   *   0x4c0       ; }eAJ[
OFFSET_REG_DIF_AMB          *   0x4c0       ; gU  
OFFSET_REG_SPE_EMI          *   0x4c4       ; ˌ  ˌ
OFFSET_REG_SHININESS        *   0x4d0       ; ʔˋPx


OFFSET_REG_POLYGON_ATTR     *   0x4a4       ; |S

OFFSET_REG_TEX_PARAM        *   0x4a8       ; eNX`p[^
OFFSET_REG_TEXIMAGE_PARAM   *   0x4a8
OFFSET_REG_TEXPLTT_BASE     *   0x4ac

OFFSET_REG_BEGIN_VTXS       *   0x500       ; _Xg X^[g
OFFSET_REG_END_VTXS         *   0x504       ; _Xg Gh

OFFSET_REG_COLOR            *   0x480       ; _J[
OFFSET_REG_NORMAL           *   0x484       ; _@
OFFSET_REG_TEXCOORD         *   0x488       ; _eNX`W
OFFSET_REG_VTX_16           *   0x48c       ; _16bitW
OFFSET_REG_VTX_10           *   0x490       ; _10bitW
OFFSET_REG_VTX_XY           *   0x494       ; _16bitXYW
OFFSET_REG_VTX_XZ           *   0x498       ; _16bitXZW
OFFSET_REG_VTX_YZ           *   0x49c       ; _16bitYZW
OFFSET_REG_VTX_DIFF         *   0x4a0       ; _16bitWl

OFFSET_REG_BOX_TEST         *   0x5c0       ; {bNXeXg
OFFSET_REG_POS_TEST         *   0x5c4       ; ʒueXg
OFFSET_REG_VEC_TEST         *   0x5c8       ; xNgeXg

OFFSET_REG_POS_RESULT       *   0x620       ; ʒueXg
OFFSET_REG_VEC_RESULT       *   0x630       ; xNgeXg


OFFSET_REG_CLEAR_COLOR_ATTR *   0x350       ; J[obt@ NAl
OFFSET_REG_CLEAR_DEPTH      *   0x354       ; yobt@ NAl
OFFSET_REG_CLRIMAGE_OFFSET  *   0x356       ; NAC[W ItZbg

OFFSET_REG_EDGE_COLOR       *   0x330       ; GbWJ[

OFFSET_REG_FOG_COLOR        *   0x358       ; tHO J[
OFFSET_REG_FOG_OFFSET       *   0x35c       ; tHO ItZbg
OFFSET_REG_FOG_TABLE        *   0x360       ; tHOZxe[u

OFFSET_REG_TOON_TABLE       *   0x380       ; gD[VF[fBOEe[u

OFFSET_REG_ALPHA_TEST_REF   *   0x340       ; At@eXgQƒl

OFFSET_REG_DISP_1DOT_DEPTH  *   0x610       ; Phbg|S`Jnyl



OFFSET_REG_DMA0             *   0xb0        ; cl`O
OFFSET_REG_DMA0SAD          *   0xb0
OFFSET_REG_DMA0DAD          *   0xb4
OFFSET_REG_DMA0CNT          *   0xb8
OFFSET_REG_DMA0CNT_L        *   0xb8
OFFSET_REG_DMA0CNT_H        *   0xba
OFFSET_REG_DMA1             *   0xbc        ; cl`P
OFFSET_REG_DMA1SAD          *   0xbc
OFFSET_REG_DMA1DAD          *   0xc0
OFFSET_REG_DMA1CNT          *   0xc4
OFFSET_REG_DMA1CNT_L        *   0xc4
OFFSET_REG_DMA1CNT_H        *   0xc6
OFFSET_REG_DMA2             *   0xc8        ; cl`Q
OFFSET_REG_DMA2SAD          *   0xc8
OFFSET_REG_DMA2DAD          *   0xcc
OFFSET_REG_DMA2CNT          *   0xd0
OFFSET_REG_DMA2CNT_L        *   0xd0
OFFSET_REG_DMA2CNT_H        *   0xd2
OFFSET_REG_DMA3             *   0xd4        ; cl`R
OFFSET_REG_DMA3SAD          *   0xd4
OFFSET_REG_DMA3DAD          *   0xd8
OFFSET_REG_DMA3CNT          *   0xdc
OFFSET_REG_DMA3CNT_L        *   0xdc
OFFSET_REG_DMA3CNT_H        *   0xde
    IF :DEF: IRIS_TS
OFFSET_REG_DMA0_CLR_DATA    *   0xe0        ; cl` NAf[^
OFFSET_REG_DMA1_CLR_DATA    *   0xe4
OFFSET_REG_DMA2_CLR_DATA    *   0xe8
OFFSET_REG_DMA3_CLR_DATA    *   0xec
    ENDIF


OFFSET_REG_TM0CNT           *   0x100       ; ^C}[O
OFFSET_REG_TM0CNT_L         *   0x100
OFFSET_REG_TM0CNT_H         *   0x102
OFFSET_REG_TM1CNT           *   0x104       ; ^C}[P
OFFSET_REG_TM1CNT_L         *   0x104
OFFSET_REG_TM1CNT_H         *   0x106
OFFSET_REG_TM2CNT           *   0x108       ; ^C}[Q
OFFSET_REG_TM2CNT_L         *   0x108
OFFSET_REG_TM2CNT_H         *   0x10a
OFFSET_REG_TM3CNT           *   0x10c       ; ^C}[R
OFFSET_REG_TM3CNT_L         *   0x10c
OFFSET_REG_TM3CNT_H         *   0x10e


OFFSET_REG_KEYINPUT         *   0x130       ; L[
OFFSET_REG_KEYCNT           *   0x132       ; L[Rg[

OFFSET_REG_R0CNT            *   0x134       ; ėp|[gO
OFFSET_REG_R1CNT            *   0x138       ;           P



    ENDIF  ; _IRIS_MEMORY_MAP_H

	END

