;=====================================================================
;           IrisOS_Arm.s
;             OSCuiARMASMpj
;
;           Copyright (C) 2003-2004 NINTENDO Co.,Ltd.
;=====================================================================
    IF :DEF: _IRIS_OS_H
    ELSE
_IRIS_OS_H  *  1


    INCLUDE     IrisTargetArm.s
    INCLUDE     IrisDefineArm.s



;=======================================================================
;                       bNϐ
;=======================================================================

; bNhc

OS_UNLOCK_ID             *  0       ; bNϐbNĂȂꍇ̂hc
OS_MAINP_LOCKED_FLAG     *  0x40    ; CvZbTɂ郍bNmFtO
OS_MAINP_LOCK_ID_START   *  0x40    ; CvZbTpbNhc̊蓖ĊJnԍ
OS_MAINP_LOCK_ID_END     *  0x6f    ;                               蓖ďIԍ
OS_MAINP_DBG_LOCK_ID     *  0x70    ;                               fobK\ԍ
OS_MAINP_SYSTEM_LOCK_ID  *  0x7f    ;                               VXe\ԍ
OS_SUBP_LOCKED_FLAG      *  0x80    ;   TuvZbTɂ郍bNmFtO
OS_SUBP_LOCK_ID_START    *  0x80    ;   TuvZbTpbNhc̊蓖ĊJnԍ
OS_SUBP_LOCK_ID_END      *  0xaf    ;                               蓖ďIԍ
OS_SUBP_DBG_LOCK_ID      *  0xb0    ;                               fobK\ԍ
OS_SUBP_SYSTEM_LOCK_ID   *  0xbf    ;                               VXe\ԍ

OS_LOCK_SUCCESS          *  0       ; bN
OS_LOCK_ERROR            *  -1      ; bNG[

OS_UNLOCK_SUCCESS        *  0       ; bN
OS_UNLOCK_ERROR          *  -2      ; bNG[

OS_LOCK_FREE             *  0       ; bN

OS_LOCK_ID_ERROR         *  -3      ; bNhcG[



;-----------------------------------------------------------------------
;           bN֐̏
;-----------------------------------------------------------------------

    EXTERN OS_InitLock

;-----------------------------------------------------------------------
;           bNID̊l
;-----------------------------------------------------------------------

    EXTERN OS_GetLockID


;-----------------------------------------------------------------------
;           XsbNi[h^oCgj
;-----------------------------------------------------------------------

    EXTERN OS_LockWord
    EXTERN OS_LockByte

    EXTERN OS_LockCard
    EXTERN OS_LockCartridge
    EXTERN OS_LockWramBlock0
    EXTERN OS_LockWramBlock1
    EXTERN OS_LockVramC
    EXTERN OS_LockVramD

    EXTERN OS_LockSendFifo


;-----------------------------------------------------------------------
;           bN̉i[h^oCgj
;-----------------------------------------------------------------------

    EXTERN OS_UnLockWord
    EXTERN OS_UnLockByte

    EXTERN OS_UnLockCard
    EXTERN OS_UnLockCartridge
    EXTERN OS_UnLockWramBlock0
    EXTERN OS_UnLockWramBlock1
    EXTERN OS_UnLockVramC
    EXTERN OS_UnLockVramD

    EXTERN OS_UnLockSendFifo


;-----------------------------------------------------------------------
;           bN̎si[h^oCgj
;-----------------------------------------------------------------------

    EXTERN OS_TryLockWord
    EXTERN OS_TryLockByte

    EXTERN OS_TryLockCard
    EXTERN OS_TryLockCartridge
    EXTERN OS_TryLockWramBlock0
    EXTERN OS_TryLockWramBlock1
    EXTERN OS_TryLockVramC
    EXTERN OS_TryLockVramD

    EXTERN OS_TryLockSendFifo


;-----------------------------------------------------------------------
;           bNtO̓ǂݍ݁i[h^oCgj
;-----------------------------------------------------------------------

    EXTERN OS_ReadLockWord
    EXTERN OS_ReadLockByte


;-----------------------------------------------------------------------
;           bNϐ̏LW[ID̓ǂݍ݁i[h^oCgj
;-----------------------------------------------------------------------

    EXTERN OS_ReadOwnerOfLockWord
    EXTERN OS_ReadOwnerOfLockByte



;-----------------------------------------------------------------------
;           z[g
;-----------------------------------------------------------------------

    IF :DEF: IRIS_BB
    ELSE

    EXTERN OS_Halt

    ENDIF  ; IRIS_BB



    IF :DEF: IRIS_BB
    ELSE

;=======================================================================
;           vOXe[^XWX^
;=======================================================================

;-----------------------------------------------------------------------
;           vOXe[^XWX^ Zbgir0=p[^j
;-----------------------------------------------------------------------

    EXTERN OS_SetCpsr

;-----------------------------------------------------------------------
;           JgEvOXe[^XWX^l l
;-----------------------------------------------------------------------

    EXTERN OS_GetCpsr

;-----------------------------------------------------------------------
;           hqp Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableCpsrIRQ
    EXTERN OS_DisableCpsrIRQ

;-----------------------------------------------------------------------
;           ehphqp Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableCpsrFIQ_IRQ
    EXTERN OS_DisableCpsrFIQ_IRQ


;=======================================================================
;           OxN^
;=======================================================================

;-----------------------------------------------------------------------
;           OxN^ʁ^ʃAhXֈړ
;-----------------------------------------------------------------------

    EXTERN OS_UpperExceptionVector
    EXTERN OS_LowerExceptionVector


;=======================================================================
;           veNVjbg
;=======================================================================

;-----------------------------------------------------------------------
;           veNVjbg Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableProtectUnit
    EXTERN OS_DisableProtectUnit


;=======================================================================
;           ߃LbV
;=======================================================================

;-----------------------------------------------------------------------
;           ߃LbV Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableICache
    EXTERN OS_DisableICache


;-----------------------------------------------------------------------
;           ߃LbV 
;-----------------------------------------------------------------------

    EXTERN OS_InvalidateICache

;-----------------------------------------------------------------------
;           ߃LbVC̃AhXɂ閳
;-----------------------------------------------------------------------

    EXTERN OS_InvalidateICacheAddr
    EXTERN OS_InvalidateICacheAddrs

;-----------------------------------------------------------------------
;           ߃LbVC̃AhXɂvtFb`
;-----------------------------------------------------------------------

    EXTERN OS_PrefetchICacheAddr
    EXTERN OS_PrefetchICacheAddrs

;-----------------------------------------------------------------------
;           ߃LbV bN_E
;-----------------------------------------------------------------------

    EXTERN OS_LockdownICache


;=======================================================================
;           f[^LbV
;=======================================================================

;-----------------------------------------------------------------------
;           f[^LbV Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableDCache
    EXTERN OS_DisableDCache

;-----------------------------------------------------------------------
;           f[^LbV 
;-----------------------------------------------------------------------

    EXTERN OS_InvalidateDCache

;-----------------------------------------------------------------------
;           f[^LbVC̃AhXɂ閳
;-----------------------------------------------------------------------

    EXTERN OS_InvalidateDCacheAddr
    EXTERN OS_InvalidateDCacheAddrs

;-----------------------------------------------------------------------
;           f[^LbV N[
;-----------------------------------------------------------------------

    EXTERN OS_CleanDCache

;-----------------------------------------------------------------------
;           f[^LbVC̃AhXɂN[
;-----------------------------------------------------------------------

    EXTERN OS_CleanDCacheAddr
    EXTERN OS_CleanDCacheAddrs

;-----------------------------------------------------------------------
;           f[^LbVC̃CfbNXɂN[
;-----------------------------------------------------------------------

    EXTERN OS_CleanDCacheIndex
    EXTERN OS_CleanDCacheIndices

;-----------------------------------------------------------------------
;           f[^LbV N[
;-----------------------------------------------------------------------

    EXTERN OS_Clean2InvalidateDCache

;-----------------------------------------------------------------------
;           f[^LbVC̃AhXɂN[
;-----------------------------------------------------------------------

    EXTERN OS_Clean2InvalidateDCacheAddr
    EXTERN OS_Clean2InvalidateDCacheAddrs

;-----------------------------------------------------------------------
;           f[^LbVC̃CfbNXɂN[
;-----------------------------------------------------------------------

    EXTERN OS_Clean2InvalidateDCacheIndex
    EXTERN OS_Clean2InvalidateDCacheIndices

;-----------------------------------------------------------------------
;           f[^LbVC̃AhXɂv[h
;-----------------------------------------------------------------------

    EXTERN OS_PreloadDCacheAddr
    EXTERN OS_PreloadDCacheAddrs

;-----------------------------------------------------------------------
;           f[^LbV bN_E
;-----------------------------------------------------------------------

    EXTERN OS_LockdownDCache


;=======================================================================
;           Cgobt@
;=======================================================================

;-----------------------------------------------------------------------
;           Cgobt@ GveB҂
;-----------------------------------------------------------------------

    EXTERN OS_WaitWriteBufferEmpty


;=======================================================================
;           ߂sbl
;=======================================================================

;-----------------------------------------------------------------------
;           ߂sbl Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableITCM
    EXTERN OS_DisableITCM

;-----------------------------------------------------------------------
;           ߂sblp[^ Zbg
;-----------------------------------------------------------------------

    EXTERN OS_SetParamITCM

;-----------------------------------------------------------------------
;           ߂sblp[^ l
;-----------------------------------------------------------------------

    EXTERN OS_GetParamITCM


;=======================================================================
;           f[^sbl
;=======================================================================

;-----------------------------------------------------------------------
;           f[^sbl Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableICache
    EXTERN OS_EnableICache

;-----------------------------------------------------------------------
;           f[^sblp[^ Zbg
;-----------------------------------------------------------------------

    EXTERN OS_SetParamDTCM

;-----------------------------------------------------------------------
;           f[^sblp[^ l
;-----------------------------------------------------------------------

    EXTERN OS_GetParamDTCM


;=======================================================================
;           veNV[W
;=======================================================================

;-----------------------------------------------------------------------
;           veNV[W̖߃LbV Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableICache4PR
    EXTERN OS_DisableICache4PR

;-----------------------------------------------------------------------
;           veNV[W̃f[^LbV Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableDCache4PR
    EXTERN OS_DisableDCache4PR

;-----------------------------------------------------------------------
;           veNV[W̃Cgobt@ Cl[u^fBZ[u
;-----------------------------------------------------------------------

    EXTERN OS_EnableWriteBuffer4PR
    EXTERN OS_DisableWriteBuffer4PR

;-----------------------------------------------------------------------
;           veNV[W̖߃LbV Cl[utOl
;-----------------------------------------------------------------------

    EXTERN OS_GetICacheEnableFlags4PR

;-----------------------------------------------------------------------
;           veNV[W̃f[^LbV Cl[utOl
;-----------------------------------------------------------------------

    EXTERN OS_GetDCacheEnableFlags4PR

;-----------------------------------------------------------------------
;           veNV[W̃Cgobt@ECl[utO l
;-----------------------------------------------------------------------

    EXTERN OS_GetWriteBufferEnableFlags4PR

;-----------------------------------------------------------------------
;           veNV[W̖߃ANZX Zbg
;-----------------------------------------------------------------------

    EXTERN OS_SetIPermissions4PR

;-----------------------------------------------------------------------
;           veNV[W̃f[^ANZX Zbg
;-----------------------------------------------------------------------

    EXTERN OS_SetDPermissions4PR

;-----------------------------------------------------------------------
;           veNV[W̖߃ANZX l
;-----------------------------------------------------------------------

    EXTERN OS_GetIPermissions4PR

;-----------------------------------------------------------------------
;           veNV[W̃f[^ANZX l
;-----------------------------------------------------------------------

    EXTERN OS_GetDPermissions4PR


;-----------------------------------------------------------------------
;           eveNV[W̃p[^ Zbg
;-----------------------------------------------------------------------

    EXTERN OS_SetProtectRegion0
    EXTERN OS_SetProtectRegion1
    EXTERN OS_SetProtectRegion2
    EXTERN OS_SetProtectRegion3
    EXTERN OS_SetProtectRegion4
    EXTERN OS_SetProtectRegion5
    EXTERN OS_SetProtectRegion6
    EXTERN OS_SetProtectRegion7

;-----------------------------------------------------------------------
;           eveNV[W̃p[^ l
;-----------------------------------------------------------------------

    EXTERN OS_GetProtectRegion0
    EXTERN OS_GetProtectRegion1
    EXTERN OS_GetProtectRegion2
    EXTERN OS_GetProtectRegion3
    EXTERN OS_GetProtectRegion4
    EXTERN OS_GetProtectRegion5
    EXTERN OS_GetProtectRegion6
    EXTERN OS_GetProtectRegion7


    ENDIF  ; IRIS_BB


    ENDIF  ; _IRIS_OS_H



	END

