;=======================================================================
;          IrisSubpDefineArm.s
;            IRISTuvZbT W萔iARMASMpj
;
;          Copyright (C) 2002-2004 NINTENDO Co.,Ltd.
;=======================================================================
    IF :DEF: _IRIS_SUBP_DEFINE_H
    ELSE
_IRIS_SUBP_DEFINE_H  *  1


    INCLUDE     IrisSubpTargetArm.s


;-----------------------------------------------------------------------
;                             萔
;-----------------------------------------------------------------------

SYSTEM_CLOCK            *   33513982    ; VXeNbN

MAINP                   *   0           ; CvZbT
SUBP                    *   1           ; TuvZbT


ON                      *   1
OFF                     *   0
ENABLE                  *   1
DISABLE                 *   0
TRUE                    *   1
FALSE                   *   0


;***********************************************************************
;               hqhr|hnoWX^ERg[rbg
;***********************************************************************

;-----------------------------------------------------------------------
;                   vOXe[^XWX^
;-----------------------------------------------------------------------

PSR_CPU_MODE_MASK       *   0x1f        ; bot[h

PSR_USER_MODE           *   0x10        ; [U
PSR_FIQ_MODE            *   0x11        ; ehp
PSR_IRQ_MODE            *   0x12        ; hqp
PSR_SVC_MODE            *   0x13        ; X[poCU
PSR_ABORT_MODE          *   0x17        ; A{[givtFb`^f[^j
PSR_UNDEF_MODE          *   0x1b        ; `
PSR_SYS_MODE            *   0x1f        ; VXe

PSR_THUMB_STATE         *   0x20        ; sgtlaXe[g
PSR_FIQ_DISABLE         *   0x40        ; ehps
PSR_IRQ_DISABLE         *   0x80        ; hqps
PSR_IRQ_FIQ_DISABLE     *   0xc0        ; hqpehps

PSR_V_FLAG              *   0x10000000  ; I[o[t[
PSR_C_FLAG              *   0x20000000  ; L[^{[^g
PSR_Z_FLAG              *   0x40000000  ; [
PSR_N_FLAG              *   0x80000000  ; ^

; \̃op萔

ST_PSR_USER_MODE        *   0x10        ; [U
ST_PSR_FIQ_MODE         *   0x11        ; ehp
ST_PSR_IRQ_MODE         *   0x12        ; hqp
ST_PSR_SVC_MODE         *   0x13        ; X[poCU
ST_PSR_ABORT_MODE       *   0x17        ; A{[givtFb`^f[^j
ST_PSR_UNDEF_MODE       *   0x1b        ; `
ST_PSR_SYS_MODE         *   0x1f        ; VXe


;-----------------------------------------------------------------------
;                   荞ݗv^tO
;-----------------------------------------------------------------------

V_BLANK_INTR_FLAG       *   0x00000001  ; uuN荞
H_BLANK_INTR_FLAG       *   0x00000002  ; guN荞
V_COUNT_INTR_FLAG       *   0x00000004  ; uJE^v荞
TIMER0_INTR_FLAG        *   0x00000008  ; ^C}[O荞
TIMER1_INTR_FLAG        *   0x00000010  ; ^C}[P荞
TIMER2_INTR_FLAG        *   0x00000020  ; ^C}[Q荞
TIMER3_INTR_FLAG        *   0x00000040  ; ^C}[R荞
SIO_INTR_FLAG           *   0x00000080  ; VAʐM荞
DMA0_INTR_FLAG          *   0x00000100  ; cl`O荞
DMA1_INTR_FLAG          *   0x00000200  ; cl`P荞
DMA2_INTR_FLAG          *   0x00000400  ; cl`Q荞
DMA3_INTR_FLAG          *   0x00000800  ; cl`R荞
KEY_INTR_FLAG           *   0x00001000  ; L[荞
CARTRIDGE_INTR_FLAG     *   0x00002000  ; J[gbW荞

MAINP_INTR_FLAG         *   0x00010000  ; CvZbT荞
MPFIFO_SEND_INTR_FLAG   *   0x00020000  ; CvZbTԑMehenGveB荞
MPFIFO_RECV_INTR_FLAG   *   0x00040000  ; CvZbTԎMehenmbgGveB荞
CARD_DATA_INTR_FLAG     *   0x00080000  ; J[hf[^]I荞
CARD_IREQ_INTR_FLAG     *   0x00100000  ; J[hhqdp荞
PMIC_RTC_INTR_FLAG      *   0x00400000  ; p[}l[Wghb荞  qsb荞
SPI_INTR_FLAG           *   0x00800000  ; roh荞
WIRELESS_INTR_FLAG      *   0x01000000  ; ʐM荞


;-----------------------------------------------------------------------
;                   CvZbT C^tF[X
;-----------------------------------------------------------------------

MAINP_RECV_STATUS_MASK  *   0x000f      ; MXe[^X
MAINP_SEND_STATUS_MASK  *   0x0f00      ; MXe[^X

MAINP_RECV_STATUS_SHIFT *   0
MAINP_SEND_STATUS_SHIFT *   8

MAINP_SEND_IF           *   0x2000      ; 荞ݗvM
MAINP_RECV_IF_ENABLE    *   0x4000      ; 荞ݗvM 

;-----------------------------------------------------------------------
;                   CvZbTʐMehen Rg[
;-----------------------------------------------------------------------

MPFIFO_SEND_EMPTY       *   0x0001      ; Mehen GveB
MPFIFO_SEND_FULL        *   0x0002      ;              t
MPFIFO_SEND_IF_ENABLE   *   0x0004      ;              荞ݗv 
MPFIFO_SEND_CLEAR       *   0x0008      ;              NA
MPFIFO_RECV_EMPTY       *   0x0100      ; Mehen GveB
MPFIFO_RECV_FULL        *   0x0200      ;              t
MPFIFO_RECV_IF_ENABLE   *   0x0400      ;              荞ݗv 
MPFIFO_ENABLE           *   0x8000      ; h^nvZbTehen Cl[u


;-----------------------------------------------------------------------
;                       p[Rg[
;-----------------------------------------------------------------------

POW_SOUND_ON            *   0x0001      ; TEh nm


;-----------------------------------------------------------------------
;                       uq`l Xe[^X
;-----------------------------------------------------------------------

VRAM_MAINP_ALL          *   0x00        ; uq`l|bEc  CvZbT
VRAM_MAINP_D_SUBP_C     *   0x01        ;               c  CvZbT
                                        ;               b  TuvZbT
VRAM_MAINP_C_SUBP_D     *   0x02        ;               b  CvZbT
                                        ;               c  TuvZbT
VRAM_SUBP_ALL           *   0x03        ;           bEc  TuvZbT

;-----------------------------------------------------------------------
;                       [Nq`l Xe[^X
;-----------------------------------------------------------------------

WRAM_MAINP_ALL          *   0x00        ; L[Nq`lubNOEP  CvZbT
WRAM_MAINP_B1_SUBP_B0   *   0x01        ;                     ubNP  CvZbT
                                        ;                     ubNO  TuvZbT
WRAM_MAINP_B0_SUBP_B1   *   0x02        ;                     ubNO  CvZbT
                                        ;                     ubNP  TuvZbT
WRAM_SUBP_ALL           *   0x03        ;                     ubNOEP  TuvZbT


;-----------------------------------------------------------------------
;                       \Xe[^X
;-----------------------------------------------------------------------

DPSTAT_V_SET_LO_MASK     *   0xff00     ; uJE^rlݒ
DPSTAT_V_SET_D8          *   0x0080     ; uJE^rlݒWrbg

DPSTAT_V_SET_LO_SHIFT    *   8

DPSTAT_V_BLANK           *   0x0001     ; uuNԒ
DPSTAT_H_BLANK           *   0x0002     ; guNԒ
DPSTAT_V_COUNT           *   0x0004     ; uJE^v
DPSTAT_V_BLANK_IF_ENABLE *   0x0008     ; uuN荞ݗv 
DPSTAT_H_BLANK_IF_ENABLE *   0x0010     ; guN荞ݗv 
DPSTAT_V_COUNT_IF_ENABLE *   0x0020     ; uJE^v荞ݗv 


;-----------------------------------------------------------------------
;                       TEh}X^ Rg[
;-----------------------------------------------------------------------

SOUND_VOLUME_MASK       *   0x007f      ; }X^o̓x

SOUND_VOLUME_SHIFT      *   0

SOUND_LOUT_MIXER        *   0x0000      ; kŏIio ~LT[
SOUND_LOUT_CH1          *   0x0100      ;                `lP
SOUND_LOUT_CH3          *   0x0200      ;                `lR
SOUND_LOUT_CH1_CH3      *   0x0300      ;                `lP{R
SOUND_ROUT_MIXER        *   0x0000      ; qŏIio ~LT[
SOUND_ROUT_CH1          *   0x0400      ;                `lP
SOUND_ROUT_CH3          *   0x0800      ;                `lR
SOUND_ROUT_CH1_CH3      *   0x0C00      ;                `lP{R
SOUND_CH1_MIXOFF        *   0x1000      ; `lPE~bNX nee
SOUND_CH1_MIX           *   0x0000      ;                        nm
SOUND_CH3_MIXOFF        *   0x2000      ; `lRE~bNX nee
SOUND_CH3_MIX           *   0x0000      ;                        nm
SOUND_ENABLE            *   0x8000      ; Cl[u


;-----------------------------------------------------------------------
;                       TEh`l Rg[
;-----------------------------------------------------------------------

SOUND_CHAN_VOLUME_MASK  *   0x000000ff  ; o̓x
SOUND_SHIFT_MASK        *   0x00000300  ; f[^Vtg
SOUND_PANPOT_MASK       *   0x00ff0000  ; p|bg
SOUND_DUTY_MASK         *   0x07000000  ; f[eB
SOUND_PEPEAT_TYPE_MASK  *   0x18000000  ; s[g@
SOUND_FORMAT_MASK       *   0x60000000  ; tH[}bg

SOUND_CHAN_VOLUME_SHIFT *   0
SOUND_SHIFT_SHIFT       *   8
SOUND_PANPOT_SHIFT      *   16
SOUND_DUTY_SHIFT        *   24
SOUND_PEPEAT_TYPE_SHIFT *   27
SOUND_FORMAT_SHIFT      *   29

SOUND_OUTPUT_HOLD       *   0x00008000  ; fBZ[ȕo͕ێ

SOUND_DUTY_1_8          *   0x00000000  ; f[eB P^W
SOUND_DUTY_2_8          *   0x01000000  ;            Q^W
SOUND_DUTY_3_8          *   0x02000000  ;            R^W
SOUND_DUTY_4_8          *   0x03000000  ;            S^W
SOUND_DUTY_5_8          *   0x04000000  ;            T^W
SOUND_DUTY_6_8          *   0x05000000  ;            U^W
SOUND_DUTY_7_8          *   0x06000000  ;            V^W
SOUND_DUTY_XX           *   0x07000000  ;            ݒ֎~

SOUND_LINEAR            *   0x00000000  ; jAĐ
SOUND_REPEAT            *   0x08000000  ; s[gĐ
SOUND_1SHOT             *   0x10000000  ; PVbgĐ

SOUND_PCM8              *   0x00000000  ; oblW
SOUND_PCM16             *   0x20000000  ; oblPU
SOUND_ADPCM             *   0x40000000  ; `cobl
SOUND_PSG_NOISE         *   0x60000000  ; orfiW`PRj܂ mCYiPS`PTj

SOUND_CHAN_ENABLE       *   0x80000000  ; Cl[u

; \̃op萔

ST_SOUND_PCM8           *   0           ; oblW
ST_SOUND_PCM16          *   1           ; oblPU
ST_SOUND_ADPCM          *   2           ; `cobl
ST_SOUND_PSG_NOISE      *   3           ; orfiW`PRj܂ mCYiPS`PTj

ST_SOUND_DUTY_1_8       *   0           ; f[eB P^W
ST_SOUND_DUTY_2_8       *   1           ;            Q^W
ST_SOUND_DUTY_3_8       *   2           ;            R^W
ST_SOUND_DUTY_4_8       *   3           ;            S^W
ST_SOUND_DUTY_5_8       *   4           ;            T^W
ST_SOUND_DUTY_6_8       *   5           ;            U^W
ST_SOUND_DUTY_7_8       *   6           ;            V^W
ST_SOUND_DUTY_XX        *   7           ;            ݒ֎~


;-----------------------------------------------------------------------
;                       TEhLv` Rg[
;-----------------------------------------------------------------------

SNDCAP_PREMIXING_ON     *   0x01        ; ~LT[O nm
SNDCAP_SRC              *   0x02        ; Lv`I
SNDCAP_MIXER            *   0x00        ; ~LT[o̓f[^Lv`
SNDCAP_CHAN             *   0x02        ; P`lLv`
SNDCAP_REPEAT_OFF       *   0x04        ; s[g nee
SNDCAP_FORMAT           *   0x08        ; Lv`tH[}bg
SNDCAP_PCM16            *   0x00        ;                        PUobl
SNDCAP_PCM8             *   0x08        ;                        Wobl
SNDCAP_ENABLE           *   0x80        ; Cl[u


;-----------------------------------------------------------------------
;                       rohRg[
;-----------------------------------------------------------------------

SPI_SCK_MASK            *   0x0003      ; VtgNbN
    IF :DEF: IRIS_TS
SPI_TARGET_MASK         *   0x0300      ; ʐM^[Qbgw
    ELSE
SPI_TARGET_MASK         *   0x2000
    ENDIF

SPI_SCK_SHIFT           *   0

SPI_SCK_4M              *   0x0000      ; VtgNbN SlgI
SPI_SCK_2M              *   0x0001      ;                Qlg
SPI_SCK_1M              *   0x0002      ;                Plg
SPI_SCK_524K            *   0x0003      ;            TQSjg

SPI_BUSY                *   0x0080      ; rW[
SPI_8BIT_MODE           *   0x0000      ;   Wrbg[h
    IF :DEF: IRIS_TS
SPI_16BIT_MODE          *   0x0400      ; PUrbg[h
SPI_CONTINUOUS_ON       *   0x1000      ; ReBjAX[h nm
SPI_TARGET_PMIC         *   0x0000      ; olhbI
SPI_TARGET_FLASH        *   0x1000      ; tbVI
SPI_TARGET_TOUCHPANEL   *   0x2000      ; ^b`plI
    ELSE
SPI_CONTINUOUS_ON       *   0x1000      ; ReBjAX[h nm
SPI_TARGET_PMIC         *   0x0000      ; olhbI
SPI_TARGET_FLASH        *   0x2000      ; tbVI
    ENDIF
SPI_IF_ENABLE           *   0x4000      ; 荞ݗv 
SPI_ENABLE              *   0x8000      ; roh

; \̃op萔

ST_SPI_SCK_4M           *   0           ; VtgNbN SlgI
ST_SPI_SCK_2M           *   1           ;                Qlg
ST_SPI_SCK_1M           *   2           ;                Plg
ST_SPI_SCK_524K         *   3           ;            TQSjg

    IF :DEF: IRIS_TS
ST_SPI_TARGET_PMIC      *   0           ; olhbI
ST_SPI_TARGET_FLASH     *   1           ; tbVI
    ELSE
ST_SPI_TARGET_PMIC      *   0           ; olhbI
ST_SPI_TARGET_FLASH     *   1           ; tbVI
    ENDIF


;-----------------------------------------------------------------------
;                       ėpo̓Rg[
;-----------------------------------------------------------------------

R_SIO_MODE_MASTER_MASK  *   0xc000      ; rhn[hE}X^

R_SIO_MODE_MASTER_SHIFT *   14

R_SIO_MASTER_MODE       *   0x0000      ; rhn}X^E[h
R_DIRECT_MODE           *   0x8000      ; ėpo͒ʐM[h

R_SC                    *   0x0001      ; f[^
R_SD                    *   0x0002
R_SI                    *   0x0004
R_SO                    *   0x0008
R_SC_I_O                *   0x0010      ; h/nI
R_SD_I_O                *   0x0020
R_SI_I_O                *   0x0040
R_SO_I_O                *   0x0080
R_SC_IN                 *   0x0000      ; ͐ݒ
R_SD_IN                 *   0x0000
R_SI_IN                 *   0x0000
R_SO_IN                 *   0x0000
R_SC_OUT                *   0x0010      ; o͐ݒ
R_SD_OUT                *   0x0020
R_SI_OUT                *   0x0040
R_SO_OUT                *   0x0080
R_IF_ENABLE             *   0x0100      ; 荞ݗv 

; \̃op萔

ST_R_SIO_MASTER_MODE    *   0           ; rhn}X^E[h
ST_R_DIRECT_MODE        *   2           ; ėpo͒ʐM[h

ST_R_IN                 *   0           ; ͑I
ST_R_OUT                *   1           ; o͑I


;-----------------------------------------------------------------------
;                       cl`Rg[
;-----------------------------------------------------------------------

DMA_TIMMING_MASK        *   0x30000000  ; Jn^C~O
DMA_COUNT_MASK          *   0x0000ffff  ; ]

DMA_TIMMING_SHIFT       *   30
DMA_COUNT_SHIFT         *   0

DMA_ENABLE              *   0x80000000  ; cl`
DMA_IF_ENABLE           *   0x40000000  ; 荞ݗv 
DMA_TIMMING_IMM         *   0x00000000  ; ɋN
DMA_TIMMING_V_BLANK     *   0x10000000  ; uuNN
DMA_TIMMING_CARD        *   0x20000000  ; J[h
DMA_TIMMING_WIRELESS    *   0x30000000  ; ʐM
DMA_TIMMING_CARTRIDGE   *   0x30000000  ; J[gbW
DMA_16BIT_BUS           *   0x00000000  ; oXTCYPUaI
DMA_32BIT_BUS           *   0x04000000  ; oXTCYRQaI
DMA_CONTINUOUS_ON       *   0x02000000  ; ReBjAX[h nm
DMA_SRC_INC             *   0x00000000  ; ] CNg I
DMA_SRC_DEC             *   0x00800000  ; ] fNg   I
DMA_SRC_FIX             *   0x01000000  ; ] Œ I
DMA_DEST_INC            *   0x00000000  ; ] CNg I
DMA_DEST_DEC            *   0x00200000  ; ] fNg   I
DMA_DEST_FIX            *   0x00400000  ; ] Œ I
DMA_DEST_RELOAD         *   0x00600000  ; ] CNg/[h I

; \̃op萔

ST_DMA_TIMMING_IMM        *   0         ; ɋN
ST_DMA_TIMMING_V_BLANK    *   1         ; uuNN
ST_DMA_TIMMING_CARD       *   2         ; J[h
ST_DMA_TIMMING_CARTRIDGE  *   3         ; J[gbW
ST_DMA_16BIT_BUS          *   0         ; oXTCYPUI
ST_DMA_32BIT_BUS          *   1         ; oXTCYRQI
ST_DMA_INC                *   0         ; AhXECNg I
ST_DMA_DEC                *   1         ; AhXEfNg   I
ST_DMA_FIX                *   2         ; AhXŒ I
ST_DMA_RELOAD             *   3         ; AhXECNg/[h I


;-----------------------------------------------------------------------
;                       ^C}[ Rg[
;-----------------------------------------------------------------------

TMR_PRESCALER_MASK      *   0x00030000  ; vXP[ NbN

TMR_PRESCALER_SHIFT     *   16

TMR_PRESCALER_1CK       *   0x00000000  ; vXP[ P
TMR_PRESCALER_64CK      *   0x00010000  ;            US
TMR_PRESCALER_256CK     *   0x00020000  ;          QTU
TMR_PRESCALER_1024CK    *   0x00030000  ;        POQS
TMR_CONNECT             *   0x00040000  ; ʃ^C}[ڑ
TMR_IF_ENABLE           *   0x00400000  ; 荞ݗv 
TMR_ENABLE              *   0x00800000  ; ^C}[N

; \̃op萔

ST_TMR_PRESCALER_1CK    *   0           ; vXP[ P
ST_TMR_PRESCALER_64CK   *   1           ;            US
ST_TMR_PRESCALER_256CK  *   2           ;          QTU
ST_TMR_PRESCALER_1024CK *   3           ;        POQS


;-----------------------------------------------------------------------
;                           L[
;-----------------------------------------------------------------------

BUTTON_MASK             *   0x030f      ; {^
PLUS_KEY_MASK           *   0x00f0      ; \L[
ALL_KEY_MASK            *   0x03ff      ; SẴL[

A_BUTTON                *   0x0001      ; `{^
B_BUTTON                *   0x0002      ; a{^
SELECT_BUTTON           *   0x0004      ; ZNg{^
START_BUTTON            *   0x0008      ; X^[g{^
R_KEY                   *   0x0010      ; E{^
L_KEY                   *   0x0020      ; {^
U_KEY                   *   0x0040      ; {^
D_KEY                   *   0x0080      ; {^
R_BUTTON                *   0x0100      ; q{^
L_BUTTON                *   0x0200      ; k{^
KEY_IF_ENABLE           *   0x4000      ; 荞ݗv 
KEY_OR_INTR             *   0x0000      ;   ʏL[荞
KEY_AND_INTR            *   0x8000      ; `mcL[荞

; \̃op萔

ST_KEY_OR_INTR          *   0            ;   ʏL[荞
ST_KEY_AND_INTR         *   1            ; `mcL[荞


;-----------------------------------------------------------------------
;                       O Rg[
;-----------------------------------------------------------------------

CTRDG_DT8_10CYC         *   0x0000      ; J[gbW Wf[^oX  POTCN
CTRDG_DT8_8CYC          *   0x0001      ;                                    WTCN
CTRDG_DT8_6CYC          *   0x0002      ;                                    UTCN
CTRDG_DT8_18CYC         *   0x0003      ;                                  PWTCN
CTRDG_AD16_1ST_10CYC    *   0x0000      ; J[gbW `cPUoX P POTCN
CTRDG_AD16_1ST_8CYC     *   0x0004      ;                                    WTCN
CTRDG_AD16_1ST_6CYC     *   0x0008      ;                                    UTCN
CTRDG_AD16_1ST_18CYC    *   0x000c      ;                                  PWTCN
CTRDG_AD16_2ND_6CYC     *   0x0000      ;                           Q   UTCN
CTRDG_AD16_2ND_4CYC     *   0x0010      ;                                    STCN

CTRDG_PHI_OUT_NONE      *   0x0000      ; Ӓ[qo̓NbN kŒ
CTRDG_PHI_OUT_4MCK      *   0x0020      ;                    Slg
CTRDG_PHI_OUT_8MCK      *   0x0040      ;                    Wlg
CTRDG_PHI_OUT_16MCK     *   0x0060      ;                  PUlg

CTRDG_ACCESS            *   0x0080      ; J[gbWANZX
CTRDG_ACCESS_MAINP      *   0x0000      ;           CvZbT
CTRDG_ACCESS_SUBP       *   0x0080      ;           TuvZbT

CARD_ACCESS             *   0x0800      ; J[hANZX
CARD_ACCESS_MAINP       *   0x0000      ;           CvZbT
CARD_ACCESS_SUBP        *   0x0800      ;           TuvZbT

MMEM_CE2_OUT            *   0x2000      ;             bdQMmF

MMEM_INTF               *   0x4000      ; CC^tF[Xisdfł͏ɃZbgē[hɂj
MMEM_INTF_ASYNC         *   0x0000      ;                           񓯊[h
MMEM_INTF_SYNC          *   0x4000      ;                             [h

MMEM_PRIORITY           *   0x8000      ; CD挠
MMEM_PRIORITY_MAINP     *   0x0000      ;           CvZbT
MMEM_PRIORITY_SUBP      *   0x8000      ;           TuvZbT

; \̃op萔

ST_CTRDG_DT8_10CYC      *   0           ; J[gbW Wf[^oX  POTCN
ST_CTRDG_DT8_8CYC       *   1           ;                                    WTCN
ST_CTRDG_DT8_6CYC       *   2           ;                                    UTCN
ST_CTRDG_DT8_18CYC      *   3           ;                                  PWTCN
ST_CTRDG_AD16_1ST_10CYC *   0           ; J[gbW `cPUoX P POTCN
ST_CTRDG_AD16_1ST_8CYC  *   1           ;                                    WTCN
ST_CTRDG_AD16_1ST_6CYC  *   2           ;                                    UTCN
ST_CTRDG_AD16_1ST_18CYC *   3           ;                                  PWTCN
ST_CTRDG_AD16_2ND_6CYC  *   0           ;                           Q   UTCN
ST_CTRDG_AD16_2ND_4CYC  *   1           ;                                    STCN

ST_CTRDG_PHI_OUT_NONE   *   0           ; Ӓ[qo̓NbN kŒ
ST_CTRDG_PHI_OUT_4MCK   *   1           ;                    Slg
ST_CTRDG_PHI_OUT_8MCK   *   2           ;                    Wlg
ST_CTRDG_PHI_OUT_16MCK  *   3           ;                  PUlg



    ENDIF  ; _IRIS_SUBP_DEFINE_H

	END

