//====================================================================
//          IrisSubpOS.h
//            OSCu
//
//          Copyright (C) 2003-2004 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_SUBP_OS_H
#define _IRIS_SUBP_OS_H


#ifdef __cplusplus
extern "C" {
#endif


#include <stdlib.h>
#include <IrisSubpTarget.h>
#include <IrisSubpTypes.h>



//======================================================================
//                      bNϐ
//
//EJ[h^J[gbW^botԋL[Nq`l^uq`l|b^c
//  Ȃǂ̂botԂł̋LX[XAbotԑMehen ̐L\[X
//  ̔r䂽߂ɂ̊֐gpB
//======================================================================

// bNhc

#define OS_UNLOCK_ID            0       // bNϐbNĂȂꍇ̂hc
#define OS_MAINP_LOCKED_FLAG    0x40    // CvZbTɂ郍bNmFtO
#define OS_MAINP_LOCK_ID_START  0x40    // CvZbTpbNhc̊蓖ĊJnԍ
#define OS_MAINP_LOCK_ID_END    0x6f    //                               蓖ďIԍ
#define OS_MAINP_DBG_LOCK_ID    0x70    //                               fobK\ԍ
#define OS_MAINP_SYSTEM_LOCK_ID 0x7f    //                               VXe\ԍ
#define OS_SUBP_LOCKED_FLAG     0x80    //   TuvZbTɂ郍bNmFtO
#define OS_SUBP_LOCK_ID_START   0x80    //   TuvZbTpbNhc̊蓖ĊJnԍ
#define OS_SUBP_LOCK_ID_END     0xaf    //                               蓖ďIԍ
#define OS_SUBP_DBG_LOCK_ID     0xb0    //                               fobK\ԍ
#define OS_SUBP_SYSTEM_LOCK_ID  0xbf    //                               VXe\ԍ

#define OS_LOCK_SUCCESS         0       // bN
#define OS_LOCK_ERROR           -1      // bNG[

#define OS_UNLOCK_SUCCESS       0       // bN
#define OS_UNLOCK_ERROR         -2      // bNG[

#define OS_LOCK_FREE            0       // bN

#define OS_LOCK_ID_ERROR        -3      // bNhcG[


// bNϐ\

typedef struct {
    u32 lockFlag;               // bNtOisW[IDi[j
    u16 ownerID;                // 擾W[ID
    u16 extension;              // g
} LockWord;
typedef  vl LockWord    vLockWord;

typedef struct {
    u8  lockFlag;               // bNtOisW[IDi[j
    u8  ownerID;                // 擾W[ID
} LockByte;
typedef  vl LockByte    vLockByte;


//----------------------------------------------------------------------
//          VXebNϐ̏
//
//EVXebNϐ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//
//NSYNC_MAINP`łĂAJ[gbWr̈
//  fobKgp邽߃NA܂B
//----------------------------------------------------------------------

void OS_InitLock(void);

//----------------------------------------------------------------------
//          bNID̊l
//
//EbNϐ֐ݒ肷IDl܂B
//
//EF              Ȃ
//
//E߂lF
//  0x80 ` 0xaf        bNID
//  OS_LOCK_ID_ERROR    bNIDls
//
//ID48ނ܂ł蓖Ă邱Ƃł܂B
//  W[ɂĕ̃bNϐ𐧌䂷ꍇ
//  ł邾1IDgp悤ɂĉB
//----------------------------------------------------------------------

s32 OS_GetLockID(void);


//----------------------------------------------------------------------
//          XsbNi[h^oCgj
//
//EvZbTԂ⃂W[ԂŋL\[Xr䂷邽߂
//  bNϐ̃XsbNs܂B
//EbN܂Ŏs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//  OS_LOCK_SUCCESS     bN
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_LockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_LockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_LockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_LockCard(u32 lockID);            // J[h
s32 OS_LockCartridge(u32 lockID);       // J[gbW
s32 OS_LockWramBlock0(u32 lockID);      // bot[Nq`lEubNO
s32 OS_LockWramBlock1(u32 lockID);      // bot[Nq`lEubNP
s32 OS_LockVramC(u32 lockID);           // uq`l|b
s32 OS_LockVramD(u32 lockID);           // uq`l|c

s32 OS_LockSendFifo(u32 lockID);        // botԑMehen
s32 OS_LockDma0(u32 lockID);            // cl`O
s32 OS_LockDma1(u32 lockID);            // cl`P
s32 OS_LockDma2(u32 lockID);            // cl`Q
s32 OS_LockDma3(u32 lockID);            // cl`R
s32 OS_LockTimer0(u32 lockID);          // ^C}[O
s32 OS_LockTimer1(u32 lockID);          // ^C}[P
s32 OS_LockTimer2(u32 lockID);          // ^C}[Q
s32 OS_LockTimer3(u32 lockID);          // ^C}[R


//----------------------------------------------------------------------
//          bN̉i[h^oCgj
//
//EbN܂B
//EbNĂȂW[sꍇɂ͉ꂸA
//  OS_UNLOCK_ERROR Ԃ܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//                    bNiOɊi[ĂIDj
//  OS_UNLOCK_ERROR     bNG[
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_UnLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_UnLockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_UnLockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_UnLockCard(u32 lockID);          // J[h
s32 OS_UnLockCartridge(u32 lockID);     // J[gbW
s32 OS_UnLockWramBlock0(u32 lockID);    // bot[Nq`lEubNO
s32 OS_UnLockWramBlock1(u32 lockID);    // bot[Nq`lEubNP
s32 OS_UnLockVramC(u32 lockID);         // uq`l|b
s32 OS_UnLockVramD(u32 lockID);         // uq`l|c

s32 OS_UnLockSendFifo(u32 lockID);      // botԑMehen
s32 OS_UnLockDma0(u32 lockID);          // cl`O
s32 OS_UnLockDma1(u32 lockID);          // cl`P
s32 OS_UnLockDma2(u32 lockID);          // cl`Q
s32 OS_UnLockDma3(u32 lockID);          // cl`R
s32 OS_UnLockTimer0(u32 lockID);        // ^C}[O
s32 OS_UnLockTimer1(u32 lockID);        // ^C}[P
s32 OS_UnLockTimer2(u32 lockID);        // ^C}[Q
s32 OS_UnLockTimer3(u32 lockID);        // ^C}[R


//----------------------------------------------------------------------
//          bN̎si[h^oCgj
//
//EP񂾂XsbNs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//                    bNiOɊi[ĂIDj
//  OS_LOCK_SUCCESS     bN
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_TryLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_TryLockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_TryLockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_TryLockCard(u32 lockID);         // J[h
s32 OS_TryLockCartridge(u32 lockID);    // J[gbW
s32 OS_TryLockWramBlock0(u32 lockID);   // bot[Nq`lEubNO
s32 OS_TryLockWramBlock1(u32 lockID);   // bot[Nq`lEubNP
s32 OS_TryLockVramC(u32 lockID);        // uq`l|b
s32 OS_TryLockVramD(u32 lockID);        // uq`l|c

s32 OS_TryLockSendFifo(u32 lockID);     // botԑMehen
s32 OS_TryLockDma0(u32 lockID);         // cl`O
s32 OS_TryLockDma1(u32 lockID);         // cl`P
s32 OS_TryLockDma2(u32 lockID);         // cl`Q
s32 OS_TryLockDma3(u32 lockID);         // cl`R
s32 OS_TryLockTimer0(u32 lockID);       // ^C}[O
s32 OS_TryLockTimer1(u32 lockID);       // ^C}[P
s32 OS_TryLockTimer2(u32 lockID);       // ^C}[Q
s32 OS_TryLockTimer3(u32 lockID);       // ^C}[R


//----------------------------------------------------------------------
//          bNtO̓ǂݍ݁i[h^oCgj
//
//EbNtOǂݍ݂܂B
//EbNϐĂ邩ǂmF邱Ƃł܂B
//
//EF
//  lockp           bNϐ̃|C^
//
//E߂lF
//  0             bNiOɊi[ĂIDj
//  OS_LOCK_FREE    bN
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_ReadLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_ReadLockWord(volatile LockWord *lockp);
s32 OS_ReadLockByte(volatile LockByte *lockp);


// J[h
#ifdef IRIS_TS
#define OS_ReadLockCard()           OS_ReadLockWord((LockWord *)(CARD_LOCK_BUF))
#else
#define OS_ReadLockCard()           OS_ReadLockCartridge()      // J[gbWőp
#endif

// J[gbW
#define OS_ReadLockCartridge()      OS_ReadLockWord((LockWord *)(CARTRIDGE_LOCK_BUF))

// bot[Nq`lEubNO
#define OS_ReadLockWramBlock0()     OS_ReadLockWord((LockWord *)(WRAM_BLOCK0_LOCK_BUF))

// bot[Nq`lEubNP
#define OS_ReadLockWramBlock1()     OS_ReadLockWord((LockWord *)(WRAM_BLOCK1_LOCK_BUF))

// uq`l|b
#define OS_ReadLockVramC()          OS_ReadLockWord((LockWord *)(VRAM_C_LOCK_BUF))

// uq`l|c
#define OS_ReadLockVramD()          OS_ReadLockWord((LockWord *)(VRAM_D_LOCK_BUF))


// botԑMehen
#define OS_ReadLockSendFifo()       OS_ReadLockByte((LockByte *)(SEND_FIFO_LOCK_BUF))

// cl`O
#define OS_ReadLockDma0()           OS_ReadLockByte((LockByte *)(DMA0_LOCK_BUF))

// cl`P
#define OS_ReadLockDma1()           OS_ReadLockByte((LockByte *)(DMA1_LOCK_BUF))

// cl`Q
#define OS_ReadLockDma2()           OS_ReadLockByte((LockByte *)(DMA2_LOCK_BUF))

// cl`R
#define OS_ReadLockDma3()           OS_ReadLockByte((LockByte *)(DMA3_LOCK_BUF))

// ^C}[O
#define OS_ReadLockTimer0()         OS_ReadLockByte((LockByte *)(TIMER0_LOCK_BUF))

// ^C}[P
#define OS_ReadLockTimer1()         OS_ReadLockByte((LockByte *)(TIMER1_LOCK_BUF))

// ^C}[Q
#define OS_ReadLockTimer2()         OS_ReadLockByte((LockByte *)(TIMER2_LOCK_BUF))

// ^C}[R
#define OS_ReadLockTimer3()         OS_ReadLockByte((LockByte *)(TIMER3_LOCK_BUF))


//----------------------------------------------------------------------
//          bNϐ̏LW[ID̓ǂݍ݁i[h^oCgj
//
//EbNϐ̏LW[ID ǂݍ݂܂B
//EW[ID 0 ̏ꍇ͂̎_łǂ̃vZbT
//  LĂ̂mFł܂B
//EL\[X̏ꍇ́uTuvZbTLĂԁv
//  ݂̂荞݂֎~邱ƂɂĈێ邱Ƃł܂B
//  ̑̏Ԃ̓CvZbTωĂ܂\܂B
//ELW[ID  0 łĂbNϐĂƂ͌܂B
//
//EF
//  lockp       bNϐ̃|C^
//
//E߂lF    LW[ID
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_ReadOwnerOfLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_ReadOwnerOfLockWord(volatile LockWord *lockp);
s32 OS_ReadOwnerOfLockByte(volatile LockByte *lockp);


// J[h
#ifdef IRIS_TS
#define OS_ReadOwnerOfLockCard()            OS_ReadOwnerOfLockWord((LockWord *)(CARD_LOCK_BUF))
#else
#define OS_ReadOwnerOfLockCard()            OS_ReadOwnerOfLockCartridge()   // J[gbWőp
#endif

// J[gbW
#define OS_ReadOwnerOfLockCartridge()       OS_ReadOwnerOfLockWord((LockWord *)(CARTRIDGE_LOCK_BUF))

// bot[Nq`lEubNO
#define OS_ReadOwnerOfLockWramBlock0()      OS_ReadOwnerOfLockWord((LockWord *)(WRAM_BLOCK0_LOCK_BUF))

// bot[Nq`lEubNP
#define OS_ReadOwnerOfLockWramBlock1()      OS_ReadOwnerOfLockWord((LockWord *)(WRAM_BLOCK1_LOCK_BUF))

// uq`l|b
#define OS_ReadOwnerOfLockVramC()           OS_ReadOwnerOfLockWord((LockWord *)(VRAM_C_LOCK_BUF))

// uq`l|c
#define OS_ReadOwnerOfLockVramD()           OS_ReadOwnerOfLockWord((LockWord *)(VRAM_D_LOCK_BUF))


// botԑMehen
#define OS_ReadOwnerOfLockSendFifo()        OS_ReadOwnerOfLockByte((LockByte *)(SEND_FIFO_LOCK_BUF))

// cl`O
#define OS_ReadOwnerOfLockDma0()            OS_ReadOwnerOfLockByte((LockByte *)(DMA0_LOCK_BUF))

// cl`P
#define OS_ReadOwnerOfLockDma1()            OS_ReadOwnerOfLockByte((LockByte *)(DMA1_LOCK_BUF))

// cl`Q
#define OS_ReadOwnerOfLockDma2()            OS_ReadOwnerOfLockByte((LockByte *)(DMA2_LOCK_BUF))

// cl`R
#define OS_ReadOwnerOfLockDma3()            OS_ReadOwnerOfLockByte((LockByte *)(DMA3_LOCK_BUF))

// ^C}[O
#define OS_ReadOwnerOfLockTimer0()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER0_LOCK_BUF))

// ^C}[P
#define OS_ReadOwnerOfLockTimer1()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER1_LOCK_BUF))

// ^C}[Q
#define OS_ReadOwnerOfLockTimer2()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER2_LOCK_BUF))

// ^C}[R
#define OS_ReadOwnerOfLockTimer3()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER3_LOCK_BUF))



//======================================================================
//          vOXe[^XWX^
//======================================================================

//----------------------------------------------------------------------
//          JgEvOXe[^XWX^ Zbg
//
//EJgEvOXe[^XWX^ɒlZbg܂B
//
//EF  ZbgJgEvOXe[^XWX^̒l
//
//E߂lFȂ
//----------------------------------------------------------------------

void OS_SetCpsr(u32 param);

//----------------------------------------------------------------------
//          JgEvOXe[^XWX^l l
//
//EJgEvOXe[^XWX^̒ll܂B
//
//EF  Ȃ
//
//E߂lFJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_GetCpsr(void);

//----------------------------------------------------------------------
//          hqp Cl[u^fBZ[u
//
//EJgEvOXe[^XWX^̂hqp
//  Cl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFύXÕJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_EnableCpsrIRQ(void);
u32 OS_DisableCpsrIRQ(void);

//----------------------------------------------------------------------
//          ehphqp Cl[u^fBZ[u
//
//EJgEvOXe[^XWX^̂ehphqp
//  Cl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFύXÕJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_EnableCpsrFIQ_IRQ(void);
u32 OS_DisableCpsrFIQ_IRQ(void);



#ifdef __cplusplus
}
#endif

#endif  // _IRIS_SUBP_OS_H

