;=======================================================================
;          IrisCardDefineArm.s
;            IRIS J[h萔iARMASMpj
;
;          Copyright (C) 2003,2004 NINTENDO Co.,Ltd.
;=======================================================================
    IF :DEF: _IRIS_CARD_DEFINE_H
    ELSE
_IRIS_CARD_DEFINE_H  *  1


;-----------------------------------------------------------------------
;                       E}bv
;-----------------------------------------------------------------------

REG_CARDMST_SPI_CNT  *  (REG_BASE + 0x1a0)  ; J[h}X^[rohRg[

REG_CARD_MASTER_CNT  *  (REG_BASE + 0x1a1)  ; J[h}X^[Rg[

REG_CARD_SPI_CNT     *  (REG_BASE + 0x1a0)  ; J[hrohRg[
REG_CARD_SPI_DATA    *  (REG_BASE + 0x1a2)  ;             f[^

REG_CARDCNT          *  (REG_BASE + 0x1a4)  ; J[hRg[
REG_CARD_CMD         *  (REG_BASE + 0x1a8)  ;       R}hݒ
REG_CARD_DATA        *  (REG_BASE + 0x100010) ;     f[^

REG_CARD_PN_INIT     *  (REG_BASE + 0x1b0)  ; J[homf[^l
REG_CARD_PNA_INIT_L  *  (REG_BASE + 0x1b0)
REG_CARD_PNB_INIT_L  *  (REG_BASE + 0x1b4)
REG_CARD_PNA_INIT_H  *  (REG_BASE + 0x1b8)
REG_CARD_PNB_INIT_H  *  (REG_BASE + 0x1ba)


;-----------------------------------------------------------------------
;                       J[h }X^[Rg[
;-----------------------------------------------------------------------

CARDM_SEL_DEVICE            *   0x20        ; foCXI
CARDM_SEL_ROM               *   0x00        ; }XNqnl^RcI
CARDM_SEL_SPI               *   0x20        ; rohI

CARDM_IF_ENABLE             *   0x40        ; 荞ݗv 
CARDM_ENABLE                *   0x80        ; J[hCl[u


;-----------------------------------------------------------------------
;                       J[hroh Rg[
;-----------------------------------------------------------------------

CARD_SPI_SCK_MASK           *   0x03        ; VtgNbN

CARD_SPI_SCK_SHIFT          *   0

CARD_SPI_SCK_4M             *   0x00        ; VtgNbN SlgI
CARD_SPI_SCK_2M             *   0x01        ;                QlgI
CARD_SPI_SCK_1M             *   0x02        ;                PlgI
CARD_SPI_SCK_524K           *   0x03        ;            TQSjgI

CARD_SPI_INV_CS             *   0x40        ; ʐMIɁ^br_Eێ
CARD_SPI_BUSY               *   0x80        ; rW[


;-----------------------------------------------------------------------
;                       J[h Rg[
;-----------------------------------------------------------------------

CARD_LATENCY1_CYCLES_MASK   *   0x00001fff  ; CeVP̃TCN
CARD_LATENCY2_CYCLES_MASK   *   0x003f0000  ; CeVQ̃TCN
CARD_PAGE_COUNT_MASK        *   0x07000000  ; y[W

CARD_LATENCY1_CYCLES_SHIFT  0
CARD_LATENCY2_CYCLES_SHIFT  16
CARD_PAGE_COUNT_SHIFT       24

CARD_DATA_SCRAMBLE_ON       *   0x00002000  ; f[^XNu nm
CARD_SCRAMBLE_UNIT_ON       *   0x00004000  ; XNuH nm
CARD_INIT_SCRAMBLE_PN       *   0x00008000  ; XNuomf[^

CARD_CMD_SCRAMBLE_ON        *   0x00400000  ; R}hXNu nm
CARD_DATA_READY             *   0x00800000  ; f[^ fB

CARD_0_PAGE                 *   0x00000000  ;   Oy[W
CARD_1_PAGE                 *   0x01000000  ;   Py[W
CARD_2_PAGES                *   0x02000000  ;   Qy[W
CARD_4_PAGES                *   0x03000000  ;   Sy[W
CARD_8_PAGES                *   0x04000000  ;   Wy[W
CARD_16_PAGES               *   0x05000000  ; PUy[W
CARD_32_PAGES               *   0x06000000  ; RQy[W
CARD_STATUS                 *   0x07000000  ; Xe[^X[h

CARD_CLOCK_TYPE             *   0x08000000  ; NbN ^Cv
CARD_CLOCK_150NS            *   0x00000000  ; NbNTCN PTO
CARD_CLOCK_240NS            *   0x08000000  ;                  QSO
CARD_CLOCK_IN_LATENCY       *   0x10000000  ; CeVԂɃNbN
CARD_RESET_LO               *   0x00000000  ; ZbgMx k
CARD_RESET_HI               *   0x20000000  ;                    g
CARD_ACCESS_MODE            *   0x40000000  ; ANZX [h
CARD_READ_MODE              *   0x00000000  ; [h[h
CARD_WRITE_MODE             *   0x40000000  ; Cg[h
CARD_START                  *   0x80000000  ; X^[g

; \̃op萔

ST_CARD_0_PAGE              *   0           ;   Oy[W
ST_CARD_1_PAGE              *   1           ;   Py[W
ST_CARD_2_PAGES             *   2           ;   Qy[W
ST_CARD_4_PAGES             *   3           ;   Sy[W
ST_CARD_8_PAGES             *   4           ;   Wy[W
ST_CARD_16_PAGES            *   5           ; PUy[W
ST_CARD_32_PAGES            *   6           ; RQy[W
ST_CARD_STATUS              *   7           ; Xe[^X[h

ST_CARD_CLOCK_150NS         *   0           ; NbNTCN PTO
ST_CARD_CLOCK_240NS         *   1           ;                  QSO

ST_CARD_READ_MODE           *   0           ; [h[h
ST_CARD_WRITE_MODE          *   1           ; Cg[h


;-----------------------------------------------------------------------
;                       }XNqnlR}h
;-----------------------------------------------------------------------

; NORMAL[h

MROMOP_N_READ_ID              *   0x90000000  ; hcǂݍ
MROMOP_N_READ_HEADER          *   0x00000000  ; wb_ZOgǂݍ
MROMOP_N_CHANGE_SECURE        *   0x3c000000  ; SECURE[h֑J

MROMOP_N_READ_ID_PAD_L        *   0xffffffff
MROMOP_N_READ_ID_PAD_H        *   0x00ffffff
MROMOP_N_READ_HEADER_PAD_L    *   0xffffffff
MROMOP_N_READ_HEADER_PAD_H    *   0x00ffffff
MROMOP_N_CHANGE_SECURE_PAD_L  *   0xf00000ff
MROMOP_N_CHANGE_SECURE_PAD_H  *   0x00000000

; SECURE[h

MROMOP_S_READ_ID              *   0x10000000  ; hcǂݍ
MROMOP_S_READ_SEGMENT         *   0x20000000  ; ÍZOgǂݍ
MROMOP_S_PNG_ON               *   0x40000000  ; omWFl[^ nm
MROMOP_S_CHANGE_GAME          *   0xa0000000  ; GAME[h֑J

MROMOP_S_READ_ID_PAD_L        *   0x00000000
MROMOP_S_READ_ID_PAD_H        *   0x0ffff000
MROMOP_S_PNG_ON_PAD_L         *   0x00000000
MROMOP_S_PNG_ON_PAD_H         *   0x0ffff000
MROMOP_S_CHANGE_GAME_PAD_L    *   0xffffffff
MROMOP_S_CHANGE_GAME_PAD_H    *   0x0fffffff

; GAME[h

MROMOP_G_READ_PAGE            *   0xb7000000  ; y[Wǂݍ

MROMOP_G_READ_PAGE_PAD_L      *   0x00ffffff
MROMOP_G_READ_PAGE_PAD_H      *   0x00f00000
MROMOP_G_READ_PAGE_MASK_L     *   0x00ffffff
MROMOP_G_READ_PAGE_MASK_H     *   0xfffffffe
MROMOP_G_READ_PAGE_ADDR_MASK  *   0x000ffffe


;-----------------------------------------------------------------------
;                       }XNqnlR}h
;-----------------------------------------------------------------------

; NORMAL[h

MEM3DOP_N_READ_ID             *   0x90000000  ; hcǂݍ
MEM3DOP_N_READ_PAGE           *   0x00000000  ; y[Wǂݍ
MEM3DOP_N_WRITE_PAGE          *   0x10000000  ; y[W
MEM3DOP_N_INPUT_SERIAL        *   0x80000000  ; VAf[^
MEM3DOP_N_READ_STAT           *   0x70000000  ; Xe[^Xǂݍ

MEM3DOP_N_READ_ID_PAD_L       *   0xffffffff
MEM3DOP_N_READ_ID_PAD_H       *   0x00ffffff
MEM3DOP_N_READ_PAGE_PAD_L     *   0x00000000
MEM3DOP_N_READ_PAGE_PAD_H     *   0x00ffffff
MEM3DOP_N_WRITE_PAGE_PAD_L    *   0xffffffff
MEM3DOP_N_WRITE_PAGE_PAD_H    *   0x00ffffff
MEM3DOP_N_INPUT_SERIAL_PAD_L  *   0x00000000
MEM3DOP_N_INPUT_SERIAL_PAD_H  *   0x00ffffff
MEM3DOP_N_READ_STAT_PAD_L     *   0xffffffff
MEM3DOP_N_READ_STAT_PAD_H     *   0x00ffffff



    ENDIF  ; _IRIS_CARD_DEFINE_H

	END

