//====================================================================
//          IrisSpiDefine.h
//            IRIS SPI萔
//
//          Copyright (C) 2004 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_SPI_DEFINE_H
#define _IRIS_SPI_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <IrisSubpMacro.h>



//----------------------------------------------------------------------
//                      SPI̓rW[H
//----------------------------------------------------------------------

#define IsSpiBusy()                                         \
                                                            \
    (*(vu32 *)REG_SPICNT & SPI_BUSY)

//ESPIrW[ǂԂ܂B

//----------------------------------------------------------------------
//                      SPII҂
//----------------------------------------------------------------------

#define WaitSpi()                                           \
{                                                           \
    while (IsSpiBusy())   ;                                 \
}

//ESPȈI҂܂B


//----------------------------------------------------------------------
//                      tbVETCY
//----------------------------------------------------------------------

#define FLH_SIZE                    0x20000     // tbV

#define FLH_PAGE_SIZE               256         // tbVEy[W

//----------------------------------------------------------------------
//                      tbVER}h
//----------------------------------------------------------------------

#define FLHOP_STAT                  0x05        // Xe[^X
#define FLHOP_READ                  0x03        // ʏǂݍ
#define FLHOP_FAST_READ             0x0b        // ǂݍ
#define FLHOP_WRITE_ENABLE          0x06        // ݃Cl[u
#define FLHOP_WRITE_DISABLE         0x04        // ݃fBZ[u
#define FLHOP_WRITE_PAGE            0x0A        // y[W
#define FLHOP_PROGRAM_PAGE          0x02        // y[WEvO
#define FLHOP_ERASE_PAGE            0xdb        // y[W
#define FLHOP_ERASE_SECTOR          0xd8        // ZN^[
#define FLHOP_POWER_DOWN            0xb9        // p[_E
#define FLHOP_RELEASE_POWER_DOWN    0xab        // p[_EA

//----------------------------------------------------------------------
//                      tbVEXe[^X
//----------------------------------------------------------------------

#define FLHSTAT_WRITING             0x01        // Cg
#define FLHSTAT_WRITE_ENABLE_LATCH  0x02        // CgECl[ub`



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SPI_DEFINE_H
