//====================================================================
//          Iris2D.h
//            2DAtBϊCu
//
//          Copyright (C) 2003 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_2D_H
#define _IRIS_2D_H


#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisTypes.h>



//----------------------------------------------------------------------
//          afAtBϊ Zbg
//
//EBG̃AtBp[^ZoAZbg܂B
//
//EF
//  BgAffineSrcData  *srcp      \[XAhX
//  BgAffineDestData *destp     fXeBl[VAhX
//              s32   num       vZ
//
//EBgAffineSrcData\
//    s32 srcCenterX            f[^SWi_ȉ8bitj
//    s32 srcCenterY
//    s16 dispCenterX           \SW
//    s16 dispCenterY
//    s16 ratioX                gkit^_ȉ8bitj
//    s16 ratioY
//    s16 theta                 ]pi_ȉ8bitj
//
//EBgAffineDestData\
//    s16 h_diffX               CwW
//    s16 v_diffX                 wW
//    s16 h_diffY               CxW
//    s16 v_diffY                 xW
//    s32 startX                X^[gwW
//    s32 startY                X^[gxW
//
//E߂lFȂ
//----------------------------------------------------------------------

void BG_SetAffine(const BgAffineSrcData *srcp, BgAffineDestData *destp, s32 num);


//----------------------------------------------------------------------
//          naiAtBϊ Zbg
//
//EOBJ̃AtBp[^ZoAZbg܂B
//
//EF
//  ObjAffineSrcData *srcp      \[XAhX
//              void *destp     fXeBl[VAhX
//              s32   num       vZ
//              s32   offset    p[^AhX̃ItZbgEoCgiʏ 2|8j
//                              OAMɒڃZbgꍇ"8"w
//
//EObjAffineSrcData\
//    s16 ratioX                gkit^_ȉ8bitj
//    s16 ratioY
//    s16 theta                 ]pi_ȉ8bitj
//
//EObjAffineDestData\
//    s16 h_diffX               CwW
//    s16 v_diffX                 wW
//    s16 h_diffY               CxW
//    s16 v_diffY                 xW
//
//E߂lFȂ
//----------------------------------------------------------------------

void OBJ_SetAffine(const ObjAffineSrcData *srcp, void *destp, s32 num, s32 offset);



#ifdef __cplusplus
}
#endif

#endif  // _IRIS_2D_H

