;=======================================================================
;          IrisDefineArm.s
;            IRIS W萔iARMASMpj
;
;          Copyright (C) 2002-2004 NINTENDO Co.,Ltd.
;=======================================================================
    IF :DEF: _IRIS_DEFINE_H
    ELSE
_IRIS_DEFINE_H  *  1


    INCLUDE     IrisTargetArm.s


;-----------------------------------------------------------------------
;                       eŒ菬_ʒu
;-----------------------------------------------------------------------

G_SFT                   *   12              ; WIgGWiύXsj
GS_SFT                  *   6               ;      VertexShortpi   V   j

; V_SFTASIN_SFTAACOS_SFT  12`14 ͈̔͂ŕύX\ 
;iAASIN_SFT >= V_SFTj

V_SFT                   *   12              ; WxNg̕ϐ
M_SFT                   *   V_SFT           ; s

N_SFT                   *   9               ; @xNg  iύXsj
L_SFT                   *   9               ; CgxNgi   V   j

T_SFT                   *   4               ; eNX`WiύXsj
TEXMTX_SFT              *   (T_SFT + M_SFT) ; eNX`s

SIN_SFT                 *   12              ; Sine[uiV_SFT ȏɐݒj
ACOS_SFT                *   15              ; ArcCose[u


VG_SFT_DF               *   (V_SFT - G_SFT) ; xNg_ʒu | WIgGW_ʒu
MG_SFT_DF               *   (M_SFT - G_SFT) ; s񏬐_ʒu     | WIgGW_ʒu

GN_SFT_DF               *   (G_SFT - N_SFT) ; WIgGW_ʒu | @xNg_ʒu
GL_SFT_DF               *   (G_SFT - L_SFT) ; WIgGW_ʒu | CgxNg_ʒu

SIN_SFT_CT              *   (SIN_SFT_MAX  - SIN_SFT) ; Sine[u_ʒu␳
ACOS_SFT_CT             *   (ACOS_SFT_MAX - ACOS_SFT); ArcCose[u_ʒu␳


V_SFT_MAX               *   14              ; V_SFT őliύXsj
V_SFT_MIN               *   12              ;       ŏli   V   j

SIN_SFT_MAX             *   14              ; SIN_SFT  őliύXsj
SIN_SFT_MIN             *   12              ;          ŏli   V   j
ACOS_SFT_MAX            *   15              ; ACOS_SFT őli   V   j
ACOS_SFT_MIN            *   12              ;          ŏli   V   j


;  1

G_ONE                   *   (1 :SHL: G_SFT)
GS_ONE                  *   (1 :SHL: GS_SFT)
V_ONE                   *   (1 :SHL: V_SFT)
M_ONE                   *   (1 :SHL: M_SFT)

N_ONE                   *   (1 :SHL: N_SFT)
L_ONE                   *   (1 :SHL: L_SFT)

SIN_ONE                 *   (1 :SHL: SIN_SFT)
ACOS_ONE                *   (1 :SHL: ACOS_SFT)

T_ONE                   *   (1 :SHL: T_SFT)
TEXMTX_ONE              *   (1 :SHL: TEXMTX_SFT)


; ő召

G_DECI_MAX              *   (G_ONE - 1)
GS_DECI_MAX             *   (GS_ONE - 1)
V_DECI_MAX              *   (V_ONE - 1)
M_DECI_MAX              *   (M_ONE - 1)

N_DECI_MAX              *   (N_ONE - 1)
L_DECI_MAX              *   (L_ONE - 1)

SIN_DECI_MAX            *   (SIN_ONE - 1)
ACOS_DECI_MAX           *   (ACOS_ONE - 1)

T_DECI_MAX              *   (T_ONE - 1)
TEXMTX_DECI_MAX         *   (TEXMTX_ONE - 1)


;-----------------------------------------------------------------------
;                             萔
;-----------------------------------------------------------------------

SYSTEM_CLOCK            *   33513982    ; VXeNbN

MAINP                   *   0           ; CvZbT
SUBP                    *   1           ; TuvZbT


ON                      *   1
OFF                     *   0
ENABLE                  *   1
DISABLE                 *   0
TRUE                    *   1
FALSE                   *   0


LCD_WIDTH               *   256         ; ʕ
LCD_HEIGHT              *   192         ; ʍ


POLYGON_ID_MAX          *   63          ; |Shcől


;-----------------------------------------------------------------------
;                       J[f[^
;-----------------------------------------------------------------------

RED5_MASK               *   0x001f      ; 
GREEN5_MASK             *   0x03e0      ; 
BLUE5_MASK              *   0x7c00      ; 
ALPHA1_MASK             *   0x8000      ; sx
ALPHA5_MASK             *   0x001f0000

RED5_SHIFT              *   0
GREEN5_SHIFT            *   5
BLUE5_SHIFT             *   10
ALPHA1_SHIFT            *   15
ALPHA5_SHIFT            *   16


RED8_MASK               *   0x000000ff  ; 
GREEN8_MASK             *   0x0000ff00  ; 
BLUE8_MASK              *   0x00ff0000  ; 
ALPHA8_MASK             *   0xff000000  ; sx

RED8_SHIFT              *   0
GREEN8_SHIFT            *   8
BLUE8_SHIFT             *   16
ALPHA8_SHIFT            *   24


;-----------------------------------------------------------------------
;                       W
;-----------------------------------------------------------------------

X16_MASK                *   0x0000ffff  ; w
Y16_MASK                *   0xffff0000  ; x
Z16_MASK                *   0x0000ffff  ; y

X16_SHIFT               *   0
Y16_SHIFT               *   16
Z16_SHIFT               *   0


X10_MASK                *   0x000003ff  ; w
Y10_MASK                *   0x000ffc00  ; x
Z10_MASK                *   0x3ff00000  ; y

X10_SHIFT               *   0
Y10_SHIFT               *   10
Z10_SHIFT               *   20

;-----------------------------------------------------------------------
;                       eNX`W
;-----------------------------------------------------------------------

TEX_S_MASK              *   0x0000ffff  ; r
TEX_T_MASK              *   0xffff0000  ; s

TEX_S_SHIFT             *   0
TEX_T_SHIFT             *   16


;-----------------------------------------------------------------------
;                         AtBϊ
;-----------------------------------------------------------------------

AFFINE_REG_SHIFT        *   8


;-----------------------------------------------------------------------
;                     afXN[f[^
;-----------------------------------------------------------------------

BG_SC_CHAR_NO_MASK      *   0x03ff      ; LN^m
BG_SC_FLIP_MASK         *   0x0c00      ; tbv
BG_SC_PLTT_MASK         *   0xf000      ; J[pbgm

BG_SC_CHAR_NO_SHIFT     *   0
BG_SC_FLIP_SHIFT        *   10
BG_SC_PLTT_SHIFT        *   12

BG_SC_H_FLIP            *   0x0400      ; gtbv
BG_SC_V_FLIP            *   0x0800      ; utbv

;-----------------------------------------------------------------------
;                         n`lf[^
;-----------------------------------------------------------------------

OAM_V_POS_MASK          *   0x000000ff  ; nai xW
OAM_H_POS_MASK          *   0x01ff0000  ; nai wW
OAM_SHAPE_MASK          *   0x0000c000  ; nai`
OAM_SIZE_MASK           *   0xc0000000  ; naiTCY
OAM_OBJ_MODE_MASK       *   0x00000c00  ; nai[h
OAM_AFFINE_MODE_MASK    *   0x00000300  ; AtB[h
OAM_AFFINE_NO_MASK      *   0x3e000000  ; AtB p[^m
OAM_FLIP_MASK           *   0x30000000  ; tbv
OAM_CHAR_NO_MASK        *   0x000003ff  ; LN^m
OAM_PRIORITY_MASK       *   0x00000c00  ; afΗD揇
OAM_PLTT_MASK           *   0x0000f000  ; J[pbgm
OAM_ALPHA_MASK          *   0x0000f000  ; naiAt@l
OAM_AFFINE_PARAM_MASK   *   0xffff0000  ; AtB p[^

OAM_V_POS_SHIFT         *   0
OAM_H_POS_SHIFT         *   16
OAM_SHAPE_SHIFT         *   14
OAM_SIZE_SHIFT          *   30
OAM_AFFINE_MODE_SHIFT   *   8
OAM_OBJ_MODE_SHIFT      *   10
OAM_AFFINE_NO_SHIFT     *   25
OAM_FLIP_SHIFT          *   28
OAM_CHAR_NO_SHIFT       *   0
OAM_PRIORITY_SHIFT      *   10
OAM_PLTT_SHIFT          *   12
OAM_ALPHA_SHIFT         *   12
OAM_AFFINE_PARAM_SHIFT  *   16

OAM_OBJ_ON              *   0x00000000  ; nai nm
OAM_OBJ_OFF             *   0x00000200  ; nai nee
OAM_OBJ_NORMAL          *   0x00000000  ; naim[}[h
OAM_OBJ_BLEND           *   0x00000400  ; nai[h
OAM_OBJ_WINDOW          *   0x00000800  ; naiEChE[h
OAM_OBJ_BMP             *   0x00000c00  ; nairbg}bv[h
OAM_AFFINE_NONE         *   0x00000000  ; AtB[h
OAM_AFFINE_NORMAL       *   0x00000100  ; AtBm[}[h
OAM_AFFINE_TWICE        *   0x00000300  ; AtBQ{p[h
OAM_AFFINE_ERASE        *   0x00000200  ; AtB\[h
OAM_MOS_ON              *   0x00001000  ; UCN nm
OAM_MOS_OFF             *   0x00000000  ; UCN nee
OAM_COLOR_16            *   0x00000000  ; PU     I
OAM_COLOR_256           *   0x00002000  ; QTUF I
OAM_H_FLIP              *   0x10000000  ; gtbv
OAM_V_FLIP              *   0x20000000  ; utbv
OAM_SQUARE              *   0x00000000  ; `nai
OAM_H_RECTANGLE         *   0x00004000  ; `nai
OAM_V_RECTANGLE         *   0x00008000  ; c`nai
OAM_SIZE_NO_0           *   0x00000000  ; nai TCYm O
OAM_SIZE_NO_1           *   0x40000000  ; nai TCYm P
OAM_SIZE_NO_2           *   0x80000000  ; nai TCYm Q
OAM_SIZE_NO_3           *   0xc0000000  ; nai TCYm R
OAM_SIZE_8x8            *   0x00000000  ; nai   W  Whbg
OAM_SIZE_16x16          *   0x40000000  ; nai PUPUhbg
OAM_SIZE_32x32          *   0x80000000  ; nai RQRQhbg
OAM_SIZE_64x64          *   0xc0000000  ; nai USUShbg
OAM_SIZE_16x8           *   0x00004000  ; nai PU  Whbg
OAM_SIZE_32x8           *   0x40004000  ; nai RQ  Whbg
OAM_SIZE_32x16          *   0x80004000  ; nai RQPUhbg
OAM_SIZE_64x32          *   0xc0004000  ; nai USRQhbg
OAM_SIZE_8x16           *   0x00008000  ; nai   WPUhbg
OAM_SIZE_8x32           *   0x40008000  ; nai   WRQhbg
OAM_SIZE_16x32          *   0x80008000  ; nai PURQhbg
OAM_SIZE_32x64          *   0xc0008000  ; nai RQUShbg

; \̃op萔

ST_OAM_OBJ_NORMAL       *   0           ; naim[}[h
ST_OAM_OBJ_BLEND        *   1           ; nai[h
ST_OAM_OBJ_WINDOW       *   2           ; naiEChE[h
ST_OAM_AFFINE_NONE      *   0           ; AtB[h
ST_OAM_AFFINE_NORMAL    *   1           ; AtBm[}[h
ST_OAM_AFFINE_TWICE     *   3           ; AtBQ{p[h
ST_OAM_AFFINE_ERASE     *   2           ; AtB\[h
ST_OAM_COLOR_16         *   0           ; PU     I
ST_OAM_COLOR_256        *   1           ; QTUF I
ST_OAM_SQUARE           *   0           ; `nai
ST_OAM_H_RECTANGLE      *   1           ; `nai
ST_OAM_V_RECTANGLE      *   2           ; c`nai



;***********************************************************************
;               hqhrWX^ERg[rbg
;***********************************************************************

;-----------------------------------------------------------------------
;                   vOXe[^XWX^
;-----------------------------------------------------------------------

PSR_CPU_MODE_MASK       *   0x1f        ; bot[h

PSR_USER_MODE           *   0x10        ; [U
PSR_FIQ_MODE            *   0x11        ; ehp
PSR_IRQ_MODE            *   0x12        ; hqp
PSR_SVC_MODE            *   0x13        ; X[poCU
PSR_ABORT_MODE          *   0x17        ; A{[givtFb`^f[^j
PSR_UNDEF_MODE          *   0x1b        ; `
PSR_SYS_MODE            *   0x1f        ; VXe

PSR_THUMB_STATE         *   0x20        ; sgtlaXe[g
PSR_FIQ_DISABLE         *   0x40        ; ehps
PSR_IRQ_DISABLE         *   0x80        ; hqps
PSR_IRQ_FIQ_DISABLE     *   0xc0        ; hqpehps

PSR_Q_FLAG              *   0x08000000  ; XeBbL[I[o[t[
PSR_V_FLAG              *   0x10000000  ; I[o[t[
PSR_C_FLAG              *   0x20000000  ; L[^{[^g
PSR_Z_FLAG              *   0x40000000  ; [
PSR_N_FLAG              *   0x80000000  ; ^

; \̃op萔

ST_PSR_USER_MODE        *   0x10        ; [U
ST_PSR_FIQ_MODE         *   0x11        ; ehp
ST_PSR_IRQ_MODE         *   0x12        ; hqp
ST_PSR_SVC_MODE         *   0x13        ; X[poCU
ST_PSR_ABORT_MODE       *   0x17        ; A{[givtFb`^f[^j
ST_PSR_UNDEF_MODE       *   0x1b        ; `
ST_PSR_SYS_MODE         *   0x1f        ; VXe


;-----------------------------------------------------------------------
;                   VXeRg[RvZbT
;-----------------------------------------------------------------------

; WX^Pi}X^Rg[j

C1_SB1_BITSET           *   0x00000078  ; WX^PpPŒrbg

C1_ITCM_LOAD_MODE       *   0x00080000  ;   ߂sbl [h[h
C1_DTCM_LOAD_MODE       *   0x00020000  ; f[^sbl [h[h
C1_ITCM_ENABLE          *   0x00040000  ;   ߂sbl Cl[u
C1_DTCM_ENABLE          *   0x00010000  ; f[^sbl Cl[u
C1_LD_INTERWORK_DISABLE *   0x00008000  ; [h߂ɂC^[[LO fBZ[u
C1_CACHE_ROUND_ROBIN    *   0x00004000  ; LbVuASY Ehriň̃qbgj
C1_CACHE_PSEUDO_RANDOM  *   0x00000000  ;                            [_
C1_EXCEPT_VEC_UPPER     *   0x00002000  ; OxN^ ʃAhXiɐݒ肵ĉj
C1_EXCEPT_VEC_LOWER     *   0x00000000  ;            ʃAhX
C1_ICACHE_ENABLE        *   0x00001000  ;   ߃LbV Cl[u
C1_DCACHE_ENABLE        *   0x00000004  ; f[^LbV Cl[u
C1_LITTLE_ENDIAN        *   0x00000000  ; gGfBA
C1_BIG_ENDIAN           *   0x00000080  ; rbOGfBA
C1_PROTECT_UNIT_ENABLE  *   0x00000001  ; veNVjbg Cl[u


; WX^QiveNV[WELbVݒj

C2_PR0_SFT              *   0           ; veNV[WO
C2_PR1_SFT              *   1           ;                         P
C2_PR2_SFT              *   2           ;                         Q
C2_PR3_SFT              *   3           ;                         R
C2_PR4_SFT              *   4           ;                         S
C2_PR5_SFT              *   5           ;                         T
C2_PR6_SFT              *   6           ;                         U
C2_PR7_SFT              *   7           ;                         V


; WX^RiveNV[WECgobt@ݒj

C3_PR0_SFT              *   0           ; veNV[WO
C3_PR1_SFT              *   1           ;                         P
C3_PR2_SFT              *   2           ;                         Q
C3_PR3_SFT              *   3           ;                         R
C3_PR4_SFT              *   4           ;                         S
C3_PR5_SFT              *   5           ;                         T
C3_PR6_SFT              *   6           ;                         U
C3_PR7_SFT              *   7           ;                         V


; WX^TiveNV[WEANZXj

C5_PERMIT_MASK          *   0xf         ; veNV[W ANZX}XN

C5_PERMIT_NA            *   0           ;                          ANZXs
C5_PERMIT_RW            *   1           ;                          [hCg
C5_PERMIT_RO            *   5           ;                          [hI[

C5_PR0_SFT              *   0           ; veNV[WO
C5_PR1_SFT              *   4           ;                         P
C5_PR2_SFT              *   8           ;                         Q
C5_PR3_SFT              *   12          ;                         R
C5_PR4_SFT              *   16          ;                         S
C5_PR5_SFT              *   20          ;                         T
C5_PR6_SFT              *   24          ;                         U
C5_PR7_SFT              *   28          ;                         V


; WX^UiveNV[WEx[XAhX^TCYj

C6_PR_SIZE_MASK         *   0x0000003e  ; veNV[W TCY
C6_PR_BASE_MASK         *   0xfffff000  ;                          x[XAhX

C6_PR_SIZE_SHIFT        *   1
C6_PR_BASE_SHIFT        *   12

C6_PR_ENABLE            *   1           ; veNV[W Cl[u
C6_PR_DISABLE           *   0           ;                          fBZ[u

C6_PR_4KB               *   0x16        ; [WTCY Sja
C6_PR_8KB               *   0x18        ;                  Wja
C6_PR_16KB              *   0x1a        ;                PUja
C6_PR_32KB              *   0x1c        ;                RQja
C6_PR_64KB              *   0x1e        ;                USja
C6_PR_128KB             *   0x20        ;              PQWja
C6_PR_256KB             *   0x22        ;              QTUja
C6_PR_512KB             *   0x24        ;              TPQja
C6_PR_1MB               *   0x26        ;                  Pla
C6_PR_2MB               *   0x28        ;                  Qla
C6_PR_4MB               *   0x2a        ;                  Sla
C6_PR_8MB               *   0x2c        ;                  Wla
C6_PR_16MB              *   0x2e        ;                PUla
C6_PR_32MB              *   0x30        ;                RQla
C6_PR_64MB              *   0x32        ;                USla
C6_PR_128MB             *   0x34        ;              PQWla
C6_PR_256MB             *   0x36        ;              QTUla
C6_PR_512MB             *   0x38        ;              TPQla
C6_PR_1GB               *   0x3a        ;                  Pfa
C6_PR_2GB               *   0x3c        ;                  Qfa
C6_PR_4GB               *   0x3e        ;                  Sfa


; WX^V.PRi߃LbVEvtFb`j

C7_ICACHE_PREFCHP_MASK  *   0xffffffe0  ;   ߃LbV vtFb`AhX


; WX^V.POAV.PSiLbVCfbNXj

C7_ICACHE_INDEX_MASK    *   0x00000fe0  ;   ߃LbV CfbNX
C7_DCACHE_INDEX_MASK    *   0x000003e0  ; f[^LbV CfbNX
C7_CACHE_SET_NO_MASK    *   0xc0000000  ;       LbV ZOg

C7_CACHE_INDEX_SHIFT    *   5
C7_CACHE_SET_NO_SHIFT   *   30


; WX^X.OiLbVbN_Ej

C9_LOCKDOWN_SET_NO_MASK *   0x00000003  ; LbVbN_E ZOg

C9_LOCKDOWN_SET_NO_SHIFT *  0

C9_LOCKDOWN_LOAD_MODE   *   0x80000000  ; LbVbN_E [h[h


; WX^X.Pisblx[XAhX^TCYj

C9_TCMR_SIZE_MASK       *   0x0000003e  ; sbl[W TCY
C9_TCMR_BASE_MASK       *   0xfffff000  ;                  x[XAhX

C9_TCMR_SIZE_SHIFT      *   1
C9_TCMR_BASE_SHIFT      *   12

C9_TCMR_4KB             *   0x06        ; [WTCY Sja
C9_TCMR_8KB             *   0x08        ;                  Wja
C9_TCMR_16KB            *   0x0a        ;                PUja
C9_TCMR_32KB            *   0x0c        ;                RQja
C9_TCMR_64KB            *   0x0e        ;                USja
C9_TCMR_128KB           *   0x10        ;              PQWja
C9_TCMR_256KB           *   0x12        ;              QTUja
C9_TCMR_512KB           *   0x14        ;              TPQja
C9_TCMR_1MB             *   0x16        ;                  Pla
C9_TCMR_2MB             *   0x18        ;                  Qla
C9_TCMR_4MB             *   0x1a        ;                  Sla
C9_TCMR_8MB             *   0x1c        ;                  Wla
C9_TCMR_16MB            *   0x1e        ;                PUla
C9_TCMR_32MB            *   0x20        ;                RQla
C9_TCMR_64MB            *   0x22        ;                USla
C9_TCMR_128MB           *   0x24        ;              PQWla
C9_TCMR_256MB           *   0x26        ;              QTUla
C9_TCMR_512MB           *   0x28        ;              TPQla
C9_TCMR_1GB             *   0x2a        ;                  Pfa
C9_TCMR_2GB             *   0x2c        ;                  Qfa
C9_TCMR_4GB             *   0x2e        ;                  Sfa



;-----------------------------------------------------------------------
;                   荞ݗv^tO
;-----------------------------------------------------------------------

V_BLANK_INTR_FLAG       *   0x00000001  ; uuN荞
H_BLANK_INTR_FLAG       *   0x00000002  ; guN荞
V_COUNT_INTR_FLAG       *   0x00000004  ; uJE^v荞
TIMER0_INTR_FLAG        *   0x00000008  ; ^C}[O荞
TIMER1_INTR_FLAG        *   0x00000010  ; ^C}[P荞
TIMER2_INTR_FLAG        *   0x00000020  ; ^C}[Q荞
TIMER3_INTR_FLAG        *   0x00000040  ; ^C}[R荞
SIO_INTR_FLAG           *   0x00000080  ; VAʐM荞
DMA0_INTR_FLAG          *   0x00000100  ; cl`O荞
DMA1_INTR_FLAG          *   0x00000200  ; cl`P荞
DMA2_INTR_FLAG          *   0x00000400  ; cl`Q荞
DMA3_INTR_FLAG          *   0x00000800  ; cl`R荞
KEY_INTR_FLAG           *   0x00001000  ; L[荞
CARTRIDGE_INTR_FLAG     *   0x00002000  ; J[gbW荞

SUBP_INTR_FLAG          *   0x00010000  ; TuvZbT荞
SPFIFO_SEND_INTR_FLAG   *   0x00020000  ; TuvZbTԑMehenGveB荞
SPFIFO_RECV_INTR_FLAG   *   0x00040000  ; TuvZbTԎMehenmbgGveB荞
CARD_DATA_INTR_FLAG     *   0x00080000  ; J[hf[^]I荞
CARD_IREQ_INTR_FLAG     *   0x00100000  ; J[hhqdp荞
GXFIFO_INTR_FLAG        *   0x00200000  ; WIgR}hehen荞


;-----------------------------------------------------------------------
;                   TuvZbT C^tF[X
;-----------------------------------------------------------------------

SUBP_RECV_STATUS_MASK   *   0x000f      ; MXe[^X
SUBP_SEND_STATUS_MASK   *   0x0f00      ; MXe[^X

SUBP_RECV_STATUS_SHIFT  *   0
SUBP_SEND_STATUS_SHIFT  *   8

SUBP_SEND_IF            *   0x2000      ; 荞ݗvM
SUBP_RECV_IF_ENABLE     *   0x4000      ; 荞ݗvM 
SUBP_ENABLE             *   0x8000      ; TuvZbT Cl[ui폜\j

;-----------------------------------------------------------------------
;                   TuvZbTʐMehen Rg[
;-----------------------------------------------------------------------

SPFIFO_SEND_EMPTY       *   0x0001      ; Mehen GveB
SPFIFO_SEND_FULL        *   0x0002      ;              t
SPFIFO_SEND_IF_ENABLE   *   0x0004      ;              荞ݗv 
SPFIFO_SEND_CLEAR       *   0x0008      ;              NA
SPFIFO_RECV_EMPTY       *   0x0100      ; Mehen GveB
SPFIFO_RECV_FULL        *   0x0200      ;              t
SPFIFO_RECV_IF_ENABLE   *   0x0400      ;              荞ݗv 
SPFIFO_ENABLE           *   0x8000      ; ehenCl[u



;-----------------------------------------------------------------------
;                       p[Rg[
;-----------------------------------------------------------------------

POW_LCDC_ON             *   0x0001      ; kbcRg[ nm
    IF :DEF: IRIS_TS
POW_2D_ON               *   0x0202      ; QcGW`a nm
POW_2D_A_ON             *   0x0002      ; QcGW` nm
POW_2D_B_ON             *   0x0200      ; QcGWa nm
POW_EXCHANGE_LCD        *   0x8000      ; \ť
    ELSE
POW_2D_ON               *   0x0002      ; QcGW nm
    ENDIF
POW_RENDER_ON           *   0x0004      ; _OGW nm
POW_GEOMETRY_ON         *   0x0008      ; WIgGW nm
POW_ALL_ON              *   0x000f      ; S nm


;-----------------------------------------------------------------------
;                       Z
;-----------------------------------------------------------------------

DIV_MODE_MASK           *   0x0003      ; Z[h

DIV_MODE_SHIFT          *   0

DIV_32_32BIT_MODE       *   0x0000      ; RQ^RQ [h
DIV_64_32BIT_MODE       *   0x0001      ; US^RQ [h
DIV_64_64BIT_MODE       *   0x0002      ; US^US [h
DIV_ERROR               *   0x4000      ; OG[
DIV_BUSY                *   0x8000      ; rW[

;-----------------------------------------------------------------------
;                       
;-----------------------------------------------------------------------

SQRT_32BIT_MODE         *   0x0000      ; RQ [h
SQRT_64BIT_MODE         *   0x0001      ; US [h
SQRT_BUSY               *   0x8000      ; rW[



;-----------------------------------------------------------------------
;                       uq`l[Nq`l Rg[
;-----------------------------------------------------------------------

VRAM_MODE_MASK          *   0x07        ; uq`l[h
VRAM_OFFSET_MASK        *   0x18        ;         ItZbg

VRAM_MODE_SHIFT         *   0
VRAM_OFFSET_SHIFT       *   3

VRAM_LCDC_MODE          *   0x00        ;           kbcb [h
VRAM_BG_MODE            *   0x01        ;               af [h
VRAM_OBJ_MODE           *   0x02        ;             nai [hi`CaCd`f̂݉j
VRAM_SUBP_MODE          *   0x02        ;     TuvZbT [hibCĉ݉j
VRAM_TEX_MODE           *   0x03        ;         eNX` [hi``ĉ݉j
VRAM_TEXPLTT_MODE       *   0x03        ; eNX`pbg [hid`f̂݉j
VRAM_BGPLTT_MODE        *   0x04        ;       afpbg [hid`f̂݉j
VRAM_OBJPLTT_MODE       *   0x05        ;     naipbg [hieCf̂݉j

VRAM_TEX_SLOT_0         *   0x00        ;         eNX` XbgO
VRAM_TEX_SLOT_1         *   0x08        ;                            P
VRAM_TEX_SLOT_2         *   0x10        ;                            Q
VRAM_TEX_SLOT_3         *   0x18        ;                            R
VRAM_TEXPLTT_SLOT_0_3   *   0x00        ; eNX`pbg XbgO|R
VRAM_TEXPLTT_SLOT_0     *   0x00        ;                            O
VRAM_TEXPLTT_SLOT_1     *   0x08        ;                            P
VRAM_TEXPLTT_SLOT_4     *   0x10        ;                            S
VRAM_TEXPLTT_SLOT_5     *   0x18        ;                            T
VRAM_BGPLTT_SLOT_0_3    *   0x00        ;       afpbg XbgO|R
VRAM_BGPLTT_SLOT_0_1    *   0x00        ;                            O|P
VRAM_BGPLTT_SLOT_2_3    *   0x08        ;                            Q|R

VRAM_DISABLE            *   0x00        ; uq`lfBZ[u
VRAM_ENABLE             *   0x80        ;         Cl[u


WRAM_MAINP_ALL          *   0x00        ; L[Nq`lubNOEP  CvZbT
WRAM_MAINP_B1_SUBP_B0   *   0x01        ;                     ubNP  CvZbT
                                        ;                     ubNO  TuvZbT
WRAM_MAINP_B0_SUBP_B1   *   0x02        ;                     ubNO  CvZbT
                                        ;                     ubNP  TuvZbT
WRAM_SUBP_ALL           *   0x03        ;                     ubNOEP  TuvZbT


VRAM_A_CNT_SHIFT        *   0           ; uq`l ` Rg[
VRAM_B_CNT_SHIFT        *   8           ;          a
VRAM_C_CNT_SHIFT        *   16          ;          b
VRAM_D_CNT_SHIFT        *   24          ;          c
VRAM_E_CNT_SHIFT        *   0           ;          d
VRAM_F_CNT_SHIFT        *   8           ;          e
VRAM_G_CNT_SHIFT        *   16          ;          f
VRAM_H_CNT_SHIFT        *   0           ;          g
VRAM_I_CNT_SHIFT        *   8           ;          h
WRAM_CNT_SHIFT          *   24          ; [Nq`l
VRAM_AB_CNT_SHIFT       *   0           ; uq`l `a
VRAM_CD_CNT_SHIFT       *   16          ;          bc
VRAM_EF_CNT_SHIFT       *   0           ;          de
VRAM_G_W_CNT_SHIFT      *   16          ;          f { [Nq`l
VRAM_HI_CNT_SHIFT       *   0           ;          gh


; \̃op萔

ST_VRAM_LCDC_MODE         *   0         ;           kbcb [h
ST_VRAM_BG_MODE           *   1         ;               af [h
ST_VRAM_OBJ_MODE          *   2         ;             nai [hi`CaCd`f̂݉j
ST_VRAM_SUBP_MODE         *   2         ;     TuvZbT [hibCĉ݉j
ST_VRAM_TEX_MODE          *   3         ;         eNX` [hi``ĉ݉j
ST_VRAM_TEXPLTT_MODE      *   3         ; eNX`pbg [hid`f̂݉j
ST_VRAM_BGPLTT_MODE       *   4         ;       afpbg [hid`f̂݉j
ST_VRAM_OBJPLTT_MODE      *   5         ;     naipbg [hieCf̂݉j

ST_VRAM_TEX_SLOT_0        *   0         ;         eNX` XbgO
ST_VRAM_TEX_SLOT_1        *   1         ;                            P
ST_VRAM_TEX_SLOT_2        *   2         ;                            Q
ST_VRAM_TEX_SLOT_3        *   3         ;                            R
ST_VRAM_TEXPLTT_SLOT_0_3  *   0         ; eNX`pbg XbgO|R
ST_VRAM_TEXPLTT_SLOT_0    *   0         ;                            O
ST_VRAM_TEXPLTT_SLOT_1    *   1         ;                            P
ST_VRAM_TEXPLTT_SLOT_4    *   2         ;                            S
ST_VRAM_TEXPLTT_SLOT_5    *   3         ;                            T
ST_VRAM_BGPLTT_SLOT_0_3   *   0         ;       afpbg XbgO|R
ST_VRAM_BGPLTT_SLOT_0_1   *   0         ;                            O|P
ST_VRAM_BGPLTT_SLOT_2_3   *   1         ;                            Q|R


ST_WRAM_MAINP_ALL         *   0         ; L[Nq`lubNOEP  CvZbT
ST_WRAM_MAINP_B1_SUBP_B0  *   1         ;                     ubNP  CvZbT
                                        ;                     ubNO  TuvZbT
ST_WRAM_MAINP_B0_SUBP_B1  *   2         ;                     ubNO  CvZbT
                                        ;                     ubNP  TuvZbT
ST_WRAM_SUBP_ALL          *   3         ;                     ubNOEP  TuvZbT


;-----------------------------------------------------------------------
;                       \Rg[
;-----------------------------------------------------------------------

DISP_BG_MODE_MASK       *   0x00000007  ; af[h
DISP_ON_MASK            *   0x00001f00  ; naiEaf nm
DISP_WIN_MASK           *   0x00006000  ; EChE nm
DISP_OBJ_BMP_MAP_MASK   *   0x00000060  ; nairbg}bvf[^ }bsO^Cv
DISP_MODE_MASK          *   0x00030000  ; \[h
DISP_VRAM_MASK          *   0x000c0000  ; \uq`lI
DISP_OBJ_VRAM_SIZE_MASK *   0x00700000  ; naipuq`lTCY
DISP_BGCHBASE_OFS_MASK  *   0x07000000  ; afLN^f[^x[XAhXEItZbg
DISP_BGSCBASE_OFS_MASK  *   0x38000000  ; afXN[f[^x[XAhXEItZbg

DISP_BG_MODE_SHIFT        *   0
DISP_ON_SHIFT             *   8
DISP_WIN_SHIFT            *   13
DISP_MODE_SHIFT           *   16
DISP_OBJ_BMP_MAP_SHIFT    *   5
DISP_VRAM_SHIFT           *   18
DISP_OBJ_VRAM_SIZE_SHIFT  *   20
DISP_BGCHBASE_OFS_SHIFT   *   24
DISP_BGSCBASE_OFS_SHIFT   *   27

DISP_BG_MODE_0          *   0x00000000  ; af[hOim[}Sj
DISP_BG_MODE_N4         *   0x00000000
DISP_BG_MODE_1          *   0x00000001  ; af[hPim[}RAAtBPj
DISP_BG_MODE_N3A1       *   0x00000001
DISP_BG_MODE_2          *   0x00000002  ; af[hQim[}QAAtBQj
DISP_BG_MODE_N2A2       *   0x00000002
DISP_BG_MODE_3          *   0x00000003  ; af[hRim[}RAAtBgPj
DISP_BG_MODE_N3E1       *   0x00000003
DISP_BG_MODE_4          *   0x00000004  ; af[hSim[}QAAtBPAAtBgPj
DISP_BG_MODE_N2A1E1     *   0x00000004
DISP_BG_MODE_5          *   0x00000005  ; af[hTim[}QAAtBgQj
DISP_BG_MODE_N2E2       *   0x00000005
DISP_BG_MODE_6          *   0x00000006  ; af[hUiRcŒ肘PAʃrbg}bvPj
DISP_BG_MODE_3D1W1      *   0x00000006
DISP_BG0_3D_ON          *   0x00000008  ; afOւRc\
DISP_OBJ_CHAR_2D_MAP    *   0x00000000  ; naiLN^f[^ Qc}bsO
DISP_OBJ_CHAR_1D_MAP    *   0x00000010  ; naiLN^f[^ Pc}bsO
DISP_OBJ_BMP_H128_MAP   *   0x00000000  ; nairbg}bvf[^ PQWhbgQc}bsO
DISP_OBJ_BMP_H256_MAP   *   0x00000020  ; nairbg}bvf[^ QTUhbgQc}bsO
DISP_OBJ_BMP_1D_MAP     *   0x00000040  ; nairbg}bvf[^ Pc}bsO
DISP_OBJ_BMP_VRAM_128KB *   0x00000000  ; nairbg}bvf[^uq`lPQWja
DISP_OBJ_BMP_VRAM_256KB *   0x00400000  ;                                 QTUja
DISP_OBJ_HOFF           *   0x00800000  ; guNnai nee
DISP_LCDC_OFF           *   0x00000080  ; kbcb nee
DISP_BG0_ON             *   0x00000100  ; afO nm
DISP_BG1_ON             *   0x00000200  ; afP nm
DISP_BG2_ON             *   0x00000400  ; afQ nm
DISP_BG3_ON             *   0x00000800  ; afR nm
DISP_BG_ALL_ON          *   0x00000f00  ; afS nm
DISP_OBJ_ON             *   0x00001000  ; nai nm
DISP_OBJ_BG_ALL_ON      *   0x00001f00  ; naiEafS nm
DISP_WIN0_ON            *   0x00002000  ; EChEO nm
DISP_WIN1_ON            *   0x00004000  ; EChEP nm
DISP_WIN01_ON           *   0x00006000  ; EChEOEP nm
DISP_OBJWIN_ON          *   0x00008000  ; naiEChE nm
DISP_WIN_ALL_ON         *   0x0000e000  ; EChES nm
DISP_ALL_ON             *   0x00007f00  ; S nm

DISP_OFF_MODE           *   0x00000000  ; \nee
DISP_GFX_MODE           *   0x00010000  ; OtBbNX\[h
DISP_VRAM_MODE          *   0x00020000  ; uq`l\[h
DISP_MMEM_MODE          *   0x00030000  ; C\[h
DISP_VRAM_A             *   0x00000000  ; uq`l|`\
DISP_VRAM_B             *   0x00040000  ; uq`l|a\
DISP_VRAM_C             *   0x00080000  ; uq`l|b\
DISP_VRAM_D             *   0x000c0000  ; uq`l|c\
DISP_OBJ_CHAR_VRAM_32KB  *   0x00000000 ; naipuq`lRQja
DISP_OBJ_CHAR_VRAM_64KB  *   0x00100000 ;                 USja
DISP_OBJ_CHAR_VRAM_128KB *   0x00200000 ;               PQWja
DISP_OBJ_CHAR_VRAM_256KB *   0x00300000 ;               QTUja
DISP_BGPLTT_EX          *   0x40000000  ;   afpbgg
DISP_OBJPLTT_EX         *   0x80000000  ; naipbgg

; \̃op萔

ST_DISP_OBJ_CHAR_2D_MAP   *   0         ; naiLN^f[^ Qc}bsO
ST_DISP_OBJ_CHAR_1D_MAP   *   1         ; naiLN^f[^ Pc}bsO
ST_DISP_OBJ_BMP_H128_MAP  *   0         ; nairbg}bvf[^ PQWhbgQc}bsO
ST_DISP_OBJ_BMP_H256_MAP  *   1         ; nairbg}bvf[^ QTUhbgQc}bsO
ST_DISP_OBJ_BMP_1D_MAP    *   2         ; nairbg}bvf[^ Pc}bsO

ST_DISP_OFF_MODE          *   0         ; \nee
ST_DISP_GFX_MODE          *   1         ; OtBbNX\[h
ST_DISP_VRAM_MODE         *   2         ; uq`l\[h
ST_DISP_MMEM_MODE         *   3         ; C\[h

ST_DISP_VRAM_A            *   0         ; uq`l|`\
ST_DISP_VRAM_B            *   1         ; uq`l|a\
ST_DISP_VRAM_C            *   2         ; uq`l|b\
ST_DISP_VRAM_D            *   3         ; uq`l|c\


;-----------------------------------------------------------------------
;                       \Xe[^X
;-----------------------------------------------------------------------

DPSTAT_V_SET_LO_MASK     *   0xff00     ; uJE^rlݒ
DPSTAT_V_SET_D8          *   0x0080     ; uJE^rlݒWrbg

DPSTAT_V_SET_LO_SHIFT    *   8

DPSTAT_V_BLANK           *   0x0001     ; uuNԒ
DPSTAT_H_BLANK           *   0x0002     ; guNԒ
DPSTAT_V_COUNT           *   0x0004     ; uJE^v
DPSTAT_V_BLANK_IF_ENABLE *   0x0008     ; uuN荞ݗv 
DPSTAT_H_BLANK_IF_ENABLE *   0x0010     ; guN荞ݗv 
DPSTAT_V_COUNT_IF_ENABLE *   0x0020     ; uJE^v荞ݗv 


;-----------------------------------------------------------------------
;                       Rc\Rg[
;-----------------------------------------------------------------------

DISP3D_FOG_INDEX_MASK   *   0x00000f00  ; tHO CfbNX͈

DISP3D_FOG_INDEX_SHIFT  *   8

DISP3D_TEX_MASTER_ON    *   0x00000001  ; eNX`}X^ nm
DISP3D_SHADING_EX       *   0x00000002  ; gVF[fBO[hݒ
DISP3D_TOON_MODE        *   0x00000000  ; gD[VF[fBO[h
DISP3D_HIGHLIGHT_MODE   *   0x00000002  ; nCCgVF[fBO[h
DISP3D_ALPHA_TEST_ON    *   0x00000004  ; At@eXg nm
DISP3D_ALPHA_BLEND_ON   *   0x00000008  ; At@uh nm
DISP3D_ANTI_ALIASING_ON *   0x00000010  ; A`GAVO nm
DISP3D_EDGE_MARKING_ON  *   0x00000020  ; GbW}[LO nm
DISP3D_FOG_MODE         *   0x00000040  ; tHO[h
DISP3D_RGBA_FOG_MODE    *   0x00000000  ; qfa`tHO[h
DISP3D_ALPHA_FOG_MODE   *   0x00000040  ; tHO[h
DISP3D_FOG_MASTER_ON    *   0x00000080  ; tHO}X^ nm
DISP3D_CLEAR_IMAGE_ON   *   0x00004000  ; NAC[W nm

DISP3D_RENDER_OVER      *   0x00001000  ; _O I[o[t[
DISP3D_GEOMETRY_OVER    *   0x00002000  ; WIg I[o[t[

; \̃op萔

ST_DISP3D_TOON_MODE       *   0         ; gD[VF[fBO[h
ST_DISP3D_HIGHLIGHT_MODE  *   1         ; nCCgVF[fBO[h

ST_DISP3D_RGBA_FOG_MODE   *   0         ; qfa`tHO[h
ST_DISP3D_ALPHA_FOG_MODE  *   1         ; tHO[h


;-----------------------------------------------------------------------
;                       \Lv`
;-----------------------------------------------------------------------

DPCAP_GFX_WEIGHT_MASK   *   0x0000001f  ; OtBbNX̃uhW
DPCAP_RAM_WEIGHT_MASK   *   0x00001f00  ; q`l̃uhW
DPCAP_DEST_OFFSET_MASK  *   0x000c0000  ; ݂uq`lAhXEItZbg
DPCAP_SIZE_MASK         *   0x00300000  ; Lv`TCY
DPCAP_SRC_OFFSET_MASK   *   0x0c000000  ; ǂݍ݂uq`lAhXEItZbg
DPCAP_BLEND_MODE_MASK   *   0x60000000  ; uh[h

DPCAP_GFX_WEIGHT_SHIFT    *   0
DPCAP_RAM_WEIGHT_SHIFT    *   8
DPCAP_DEST_OFFSET_SHIFT   *   18
DPCAP_SIZE_SHIFT          *   20
DPCAP_SRC_OFFSET_SHIFT    *   26
DPCAP_BLEND_MODE_SHIFT    *   29

DPCAP_DEST_VRAM_MASK    *   0x00030000  ; Lv`f[^݂uq`lI

DPCAP_DEST_VRAM_SHIFT     *   16

DPCAP_DEST_VRAM_A       *   0x00000000  ; uq`l|`
DPCAP_DEST_VRAM_B       *   0x00010000  ; uq`l|a
DPCAP_DEST_VRAM_C       *   0x00020000  ; uq`l|b
DPCAP_DEST_VRAM_D       *   0x00030000  ; uq`l|c
DPCAP_SIZE_128x128      *   0x00000000  ; PQWPQWhbg
DPCAP_SIZE_256x64       *   0x00100000  ; QTU  UShbg
DPCAP_SIZE_256x128      *   0x00200000  ; QTUPQWhbg
DPCAP_SIZE_256x192      *   0x00300000  ; QTUQTUhbg
DPCAP_GFXSRC_FULL       *   0x00000000  ; QcRcOtBbNXǂݍ
DPCAP_GFXSRC_3D         *   0x01000000  ; RcOtBbNX̂ݓǂݍ
DPCAP_RAMSRC_VRAM       *   0x00000000  ; uq`lǂݍ
DPCAP_RAMSRC_MMEM       *   0x02000000  ; Cǂݍ
DPCAP_BLEND_GFX         *   0x00000000  ; OtBbNX̂݃Lv`
DPCAP_BLEND_RAM         *   0x20000000  ; q`l̂݃Lv`
DPCAP_BLEND_GFX_RAM     *   0x40000000  ; OtBbNXƂq`lufBOăLv`
DPCAP_ENABLE            *   0x80000000  ; \Lv` Cl[u


;-----------------------------------------------------------------------
;                       }X^[Px Rg[
;-----------------------------------------------------------------------

MSBRT_VALUE_MASK        *   0x001f      ; PxW
MSBRT_MODE_MASK         *   0xc000      ; Px[h

MSBRT_VALUE_SHIFT       *   0
MSBRT_MODE_SHIFT        *   14

MSBRT_NORMAL_MODE       *   0x0000      ; m[}[h
MSBRT_UP_MODE           *   0x4000      ; Pxto[h
MSBRT_DOWN_MODE         *   0x8000      ; Pxcnvm[h


;-----------------------------------------------------------------------
;                       uh Rg[
;-----------------------------------------------------------------------

BLD_PIXEL_MASK          *   0x003f      ; sNZI
BLD_1ST_PIXEL_MASK      *   0x003f      ; PsNZI
BLD_MODE_MASK           *   0x00c0      ; uh[h
BLD_2ND_PIXEL_MASK      *   0x3f00      ; QsNZI

BLD_1ST_PIXEL_SHIFT     *   0
BLD_MODE_SHIFT          *   6
BLD_2ND_PIXEL_SHIFT     *   8

BLD_BG0                 *   0x0001      ; afO sNZI
BLD_BG1                 *   0x0002      ; afP sNZI
BLD_BG2                 *   0x0004      ; afQ sNZI
BLD_BG3                 *   0x0008      ; afR sNZI
BLD_OBJ                 *   0x0010      ; nai sNZI
BLD_BD                  *   0x0020      ; wiF sNZI
BLD_ALL                 *   0x003f      ;        sNZSI
BLD_BG0_1ST             *   0x0001      ; afO PsNZI
BLD_BG1_1ST             *   0x0002      ; afP PsNZI
BLD_BG2_1ST             *   0x0004      ; afQ PsNZI
BLD_BG3_1ST             *   0x0008      ; afR PsNZI
BLD_OBJ_1ST             *   0x0010      ; nai PsNZI
BLD_BD_1ST              *   0x0020      ; wiF PsNZI
BLD_1ST_ALL             *   0x003f      ;        PsNZSI
BLD_NORMAL_MODE         *   0x0000      ; m[}[h
BLD_A_BLEND_MODE        *   0x0040      ; [h
BLD_UP_MODE             *   0x0080      ; Pxto[h
BLD_DOWN_MODE           *   0x00c0      ; Pxcnvm[h
BLD_BG0_2ND             *   0x0100      ; afO QsNZI
BLD_BG1_2ND             *   0x0200      ; afP QsNZI
BLD_BG2_2ND             *   0x0400      ; afQ QsNZI
BLD_BG3_2ND             *   0x0800      ; afR QsNZI
BLD_OBJ_2ND             *   0x1000      ; nai QsNZI
BLD_BD_2ND              *   0x2000      ; wiF QsNZI
BLD_2ND_ALL             *   0x3f00      ;        QsNZSI


BLD_A_MASK              *   0x001f      ; uhW `
BLD_B_MASK              *   0x1f00      ; uhW a
BLD_Y_MASK              *   0x001f      ; uhW x

BLD_A_SHIFT             *   16
BLD_B_SHIFT             *   24
BLD_Y_SHIFT             *   0

; \̃op萔

ST_BLD_NORMAL_MODE      *   0           ; m[}[h
ST_BLD_A_BLEND_MODE     *   1           ; [h
ST_BLD_UP_MODE          *   2           ; Pxto[h
ST_BLD_DOWN_MODE        *   3           ; Pxcnvm[h


;-----------------------------------------------------------------------
;                       EChE Rg[
;-----------------------------------------------------------------------

WIN_END_POS_MASK        *   0x00ff      ; EChEI_
WIN_START_POS_MASK      *   0xff00      ; EChEJn_

WIN_END_POS_SHIFT       *   0
WIN_START_POS_SHIFT     *   8

WIN_BG0_ON              *   0x0001      ; afO nm
WIN_BG1_ON              *   0x0002      ; afP nm
WIN_BG2_ON              *   0x0004      ; afQ nm
WIN_BG3_ON              *   0x0008      ; afR nm
WIN_OBJ_ON              *   0x0010      ; nai nm
WIN_BLEND_ON            *   0x0020      ; uh nm
WIN_ALL_ON              *   0x003f      ; S nm

;-----------------------------------------------------------------------
;                       UCN Rg[
;-----------------------------------------------------------------------

MOS_H_SIZE_MASK         *   0x000f      ;       UCN
MOS_V_SIZE_MASK         *   0x00f0      ;       UCN
MOS_BG_H_SIZE_MASK      *   0x000f      ;   afUCN
MOS_BG_V_SIZE_MASK      *   0x00f0      ;   afUCN
MOS_OBJ_H_SIZE_MASK     *   0x000f      ; naiUCN
MOS_OBJ_V_SIZE_MASK     *   0x00f0      ; naiUCN

MOS_H_SIZE_SHIFT        *   0
MOS_V_SIZE_SHIFT        *   4
MOS_BG_H_SIZE_SHIFT     *   0
MOS_BG_V_SIZE_SHIFT     *   4
MOS_OBJ_H_SIZE_SHIFT    *   8
MOS_OBJ_V_SIZE_SHIFT    *   12



;-----------------------------------------------------------------------
;                       afRg[
;-----------------------------------------------------------------------

BG_PRIORITY_MASK        *   0x0003      ; afԗD揇
BG_CHAR_BASE_MASK       *   0x003c      ; LN^ x[XAhX
BG_SCREEN_BASE_MASK     *   0x1f00      ; XN[ x[XAhX
BG_SCREEN_SIZE_MASK     *   0xc000      ; XN[TCYiQTU^TPQj

BG_PRIORITY_SHIFT       *   0
BG_CHAR_BASE_SHIFT      *   2
BG_SCREEN_BASE_SHIFT    *   8
BG_SCREEN_SIZE_SHIFT    *   14

BG_PRIORITY_0           *   0x0000      ; afOD
BG_PRIORITY_1           *   0x0001      ; afPD
BG_PRIORITY_2           *   0x0002      ; afQD
BG_PRIORITY_3           *   0x0003      ; afRD
BG_MOS_ON               *   0x0040      ; UCN nm
BG_MOS_OFF              *   0x0000      ; UCN nee
BG_COLOR_16             *   0x0000      ; PUF   I
BG_COLOR_256            *   0x0080      ; QTUF I
BG_CHAR_16              *   0x0000      ; PUFLN^af
BG_CHAR_256             *   0x0080      ; QTUFLN^af
BGE_CHAR_256x16         *   0x0000      ; QTUFPUpbgLN^af
BGE_BMP_256             *   0x0080      ; QTUFrbg}bvaf
BGE_BMP_DIRECT          *   0x0084      ; _CNgJ[rbg}bvaf
BG_LOOP_ON              *   0x2000      ; [v nm
BG_LOOP_OFF             *   0x0000      ; [v nee
BG_EXPLTT_SLOT_0        *   0x0000      ; gpbgXbgO֊蓖
BG_EXPLTT_SLOT_1        *   0x0000      ;             XbgP
BG_EXPLTT_SLOT_2        *   0x2000      ;             XbgQ
BG_EXPLTT_SLOT_3        *   0x2000      ;             XbgR
BG_SCREEN_SIZE_0        *   0x0000      ; XN[TCYiQTUQTUj
BG_SCREEN_SIZE_1        *   0x4000      ; XN[TCYiTPQQTUj
BG_SCREEN_SIZE_2        *   0x8000      ; XN[TCYiQTUTPQj
BG_SCREEN_SIZE_3        *   0xc000      ; XN[TCYiTPQTPQj

; \̃op萔

ST_BG_COLOR_16          *   0           ; PUF   I
ST_BG_COLOR_256         *   1           ; QTUF I



;-----------------------------------------------------------------------
;                       r[|[g
;-----------------------------------------------------------------------

VIEWPORT_START_X_MASK   *   0x000000ff  ; X^[g wW
VIEWPORT_START_Y_MASK   *   0x0000ff00  ;          xW
VIEWPORT_END_X_MASK     *   0x00ff0000  ; Gh   wW
VIEWPORT_END_Y_MASK     *   0xff000000  ;          xW

VIEWPORT_START_X_SHIFT  *   0
VIEWPORT_START_Y_SHIFT  *   8
VIEWPORT_END_X_SHIFT    *   16
VIEWPORT_END_Y_SHIFT    *   24


;-----------------------------------------------------------------------
;                       Cobt@ NA
;-----------------------------------------------------------------------

CLR_ID_MASK             *   0x3f000000  ; hc

CLR_ID_SHIFT            *   24

CLR_FOG_ON              *   0x00008000  ; tHOtO nm
CLR_FOG_OFF             *   0x00000000  ; tHOtO nee


;-----------------------------------------------------------------------
;                       WIgR}h
;-----------------------------------------------------------------------

GXOP_NOP                *   0x00        ; mno

GXOP_MTX_MODE           *   0x10        ; s񃂁[h
GXOP_MTX_PUSH           *   0x11        ; svbV
GXOP_MTX_POP            *   0x12        ; s|bv
GXOP_MTX_STORE          *   0x13        ; sXgA
GXOP_MTX_RESTORE        *   0x14        ; s񃊃XgA
GXOP_MTX_IDENTITY       *   0x15        ; Pʍs 
GXOP_MTX_LOAD_4x4       *   0x16        ; s񃍁[hiSSj
GXOP_MTX_LOAD_4x3       *   0x17        ;           iSRj
GXOP_MTX_MULT_4x4       *   0x18        ; sZ    iSSj
GXOP_MTX_MULT_4x3       *   0x19        ;             iSRj
GXOP_MTX_MULT_3x3       *   0x1a        ;             iRRj
GXOP_MTX_SCALE          *   0x1b        ; XP[sZiPRj
GXOP_MTX_TRANS          *   0x1c        ; ړsZiPRj

GXOP_POLYGON_ATTR       *   0x29        ; |S

GXOP_COLOR              *   0x20        ; _J[
GXOP_NORMAL             *   0x21        ; _@
GXOP_TEXCOORD           *   0x22        ; _eNX`W
GXOP_VTX_16             *   0x23        ; _16bitW
GXOP_VTX_10             *   0x24        ; _10bitW
GXOP_VTX_XY             *   0x25        ; _16bitXYW
GXOP_VTX_XZ             *   0x26        ; _16bitXZW
GXOP_VTX_YZ             *   0x27        ; _16bitYZW
GXOP_VTX_DIFF           *   0x28        ; _16bitWl
GXOP_TEX_PARAM          *   0x2a        ; eNX`p[^
GXOP_TEXIMAGE_PARAM     *   0x2a
GXOP_TEXPLTT_BASE       *   0x2b

GXOP_BOX_TEST           *   0x70        ; {bNXeXg
GXOP_POS_TEST           *   0x71        ; ʒueXg
GXOP_VEC_TEST           *   0x72        ; xNgeXg

GXOP_MATERIAL_COLOR_0   *   0x30        ; }eAJ[
GXOP_MATERIAL_COLOR_1   *   0x31
GXOP_DIF_AMB            *   0x30        ; gU  
GXOP_SPE_EMI            *   0x31        ; ˌ  ˌ
GXOP_LIGHT_VECTOR       *   0x32        ; CgxNg
GXOP_LIGHT_COLOR        *   0x33        ; CgJ[
GXOP_SHININESS          *   0x34        ; ʔˋPx

GXOP_BEGIN              *   0x40        ; WIg X^[g
GXOP_END                *   0x41        ; WIg Gh

GXOP_SWAP_BUFFERS       *   0x50        ; _OGWQƃf[^Q̃Xbv

GXOP_VIEWPORT           *   0x60        ; r[|[g


;-----------------------------------------------------------------------
;                   WIgR}h p[^
;-----------------------------------------------------------------------

GXOP_NPARAMS_MAX                *   32  ; ő吔

GXOP_NOP_NPARAMS                *   0   ; mno

GXOP_MTX_MODE_NPARAMS           *   1   ; s񃂁[h
GXOP_MTX_PUSH_NPARAMS           *   0   ; svbV
GXOP_MTX_POP_NPARAMS            *   1   ; s|bv
GXOP_MTX_STORE_NPARAMS          *   1   ; sXgA
GXOP_MTX_RESTORE_NPARAMS        *   1   ; s񃊃XgA
GXOP_MTX_IDENTITY_NPARAMS       *   0   ; Pʍs 
GXOP_MTX_LOAD_4x4_NPARAMS       *   16  ; s񃍁[hiSSj
GXOP_MTX_LOAD_4x3_NPARAMS       *   12  ;           iSRj
GXOP_MTX_MULT_4x4_NPARAMS       *   16  ; sZ    iSSj
GXOP_MTX_MULT_4x3_NPARAMS       *   12  ;             iSRj
GXOP_MTX_MULT_3x3_NPARAMS       *   9   ;             iRRj
GXOP_MTX_SCALE_NPARAMS          *   3   ; XP[sZiPRj
GXOP_MTX_TRANS_NPARAMS          *   3   ; ړsZiPRj

GXOP_POLYGON_ATTR_NPARAMS       *   1   ; |S

GXOP_COLOR_NPARAMS              *   1   ; _J[
GXOP_NORMAL_NPARAMS             *   1   ; _@
GXOP_TEXCOORD_NPARAMS           *   1   ; _eNX`W
GXOP_VTX_16_NPARAMS             *   2   ; _16bitW
GXOP_VTX_10_NPARAMS             *   1   ; _10bitW
GXOP_VTX_XY_NPARAMS             *   1   ; _16bitXYW
GXOP_VTX_XZ_NPARAMS             *   1   ; _16bitXZW
GXOP_VTX_YZ_NPARAMS             *   1   ; _16bitYZW
GXOP_VTX_DIFF_NPARAMS           *   1   ; _16bitWl

GXOP_TEX_PARAM_NPARAMS          *   1   ; eNX`p[^
GXOP_TEXIMAGE_PARAM_NPARAMS     *   1
GXOP_TEXPLTT_BASE_NPARAMS       *   1

GXOP_BOX_TEST_NPARAMS           *   3   ; {bNXeXg
GXOP_POS_TEST_NPARAMS           *   2   ; ʒueXg
GXOP_VEC_TEST_NPARAMS           *   1   ; xNgeXg

GXOP_MATERIAL_COLOR_0_NPARAMS   *   1   ; }eAJ[
GXOP_MATERIAL_COLOR_1_NPARAMS   *   1
GXOP_DIF_AMB_NPARAMS            *   1   ; gU  
GXOP_SPE_EMI_NPARAMS            *   1   ; ˌ  ˌ
GXOP_LIGHT_VECTOR_NPARAMS       *   1   ; CgxNg
GXOP_LIGHT_COLOR_NPARAMS        *   1   ; CgJ[
GXOP_SHININESS_NPARAMS          *   32  ; ʔˋPx

GXOP_BEGIN_NPARAMS              *   1   ; WIg X^[g
GXOP_END_NPARAMS                *   0   ; WIg Gh

GXOP_SWAP_BUFFERS_NPARAMS       *   1   ; _OGWQƃf[^Q̃Xbv

GXOP_VIEWPORT_NPARAMS           *   1   ; r[|[g


;-----------------------------------------------------------------------
;                       WIgXe[^X Rg[
;-----------------------------------------------------------------------

GXSTAT_POSVEC_STACK_MASK *   0x00001f00 ; ʒuxNg}gbNX X^bNx
GXSTAT_FIFO_COUNT_MASK   *   0x00ff0000 ; R}hehen c
GXSTAT_FIFO_INTR_MASK    *   0xc0000000 ;                  荞݃^Cv

GXSTAT_POSVEC_STACK_SHIFT  *   8
GXSTAT_FIFO_COUNT_SHIFT    *   16
GXSTAT_FIFO_INTR_SHIFT     *   30

GXSTAT_TEST_BUSY        *   0x00000001  ; anw^_^xN^eXg rW[
GXSTAT_BOX_IN_VIEW      *   0x00000002  ; anẅꕔ̐ϓ
GXSTAT_PROJ_STACK_LEVEL *   0x00002000  ; vWFNV}gbNX X^bNx
GXSTAT_MTX_STACK_BUSY   *   0x00004000  ; }gbNXX^bN rW[
GXSTAT_MTX_STACK_ERROR  *   0x00008000  ; }gbNXX^bN G[

GXSTAT_GEOMETRY_BUSY    *   0x08000000  ; WIgGW rW[
GXSTAT_FIFO_FULL        *   0x01000000  ; R}hehen t
GXSTAT_FIFO_UNDER_HALF  *   0x02000000  ;                  n[tȉ
GXSTAT_FIFO_EMPTY       *   0x04000000  ;                  GveB
GXSTAT_FIFO_FULL_INTR   *   0x00000000  ;                  tŊ荞
GXSTAT_FIFO_HALF_INTR   *   0x40000000  ;                  n[tȉŊ荞
GXSTAT_FIFO_EMPTY_INTR  *   0x80000000  ;                  GveBŊ荞


;-----------------------------------------------------------------------
;                       WIgq`lXbv Rg[
;-----------------------------------------------------------------------

SWPBF_XLU_AUTO_YSORT    *   0x00000000  ; |S I[gx\[g
SWPBF_XLU_MANUAL_SORT   *   0x00000001  ;                }jA\[g
SWPBF_Z_BUFFERING       *   0x00000000  ; yobt@O
SWPBF_W_BUFFERING       *   0x00000002  ; vobt@O


;-----------------------------------------------------------------------
;                       s񃂁[h Rg[
;-----------------------------------------------------------------------

MTX_MODE_MASK            *   0x00000003 ; s񃂁[h

MTX_MODE_SHIFT           *   0

MTX_PROJECTION_MODE      *   0x00000000 ; vWFNVs
MTX_POSITION_MODE        *   0x00000001 ; ʒuWs
MTX_POSITION_VECTOR_MODE *   0x00000002 ; ʒuWxNgs ݒ
MTX_TEXTURE_MODE         *   0x00000003 ; eNX`s

; \̃op萔

ST_MTX_PROJECTION_MODE       *   0      ; vWFNVs
ST_MTX_POSITION_MODE         *   1      ; ʒuWs
ST_MTX_POSITION_VECTOR_MODE  *   2      ; ʒuWxNgs ݒ
ST_MTX_TEXTURE_MODE          *   3      ; eNX`s


;-----------------------------------------------------------------------
;                       Cg
;-----------------------------------------------------------------------

LIGHT_ID_MASK           *   0xc0000000  ; hc

LIGHT_ID_SHIFT          *   30

;-----------------------------------------------------------------------
;                       }eAJ[
;-----------------------------------------------------------------------

DIFFUSE_SET_COLOR_OFF   *   0x0000      ; fBt[YJ[̒_J[ւ̃Zbg nee
DIFFUSE_SET_COLOR_ON    *   0x8000      ;                                          nm

DIFFUSE_SET_COLOR_SHIFT *   15

SHININESS_TABLE_OFF     *   0x0000      ; ʔˋPxe[u nee
SHININESS_TABLE_ON      *   0x8000      ;                      nm

SHININESS_TABLE_SHIFT   *   15


;-----------------------------------------------------------------------
;                       |S
;-----------------------------------------------------------------------

POLYATTR_LIGHT_ON_MASK  *   0x0000000f  ; Cgnm
POLYATTR_RD_MODE_MASK   *   0x00000030  ; _O[h
POLYATTR_ALPHA_MASK     *   0x001f0000  ; l
POLYATTR_ID_MASK        *   0x3f000000  ; hc

POLYATTR_LIGHT_ON_SHIFT *   0
POLYATTR_RD_MODE_SHIFT  *   4
POLYATTR_ALPHA_SHIFT    *   16
POLYATTR_ID_SHIFT       *   24

POLYATTR_LIGHT0_ON      *   0x00000001  ; CgO nm
POLYATTR_LIGHT1_ON      *   0x00000002  ; CgP nm
POLYATTR_LIGHT2_ON      *   0x00000004  ; CgQ nm
POLYATTR_LIGHT3_ON      *   0x00000008  ; CgR nm
POLYATTR_LIGHT_ALL_ON   *   0x0000000f  ; SCg nm

POLYATTR_MODULATE       *   0x00000000  ; W[V[h
POLYATTR_DECAL          *   0x00000010  ; fJ[[h
POLYATTR_TOON           *   0x00000020  ; gD[^nCCgVF[fBO[h
POLYATTR_HIGHLIGHT      *   0x00000020
POLYATTR_SHADOW         *   0x00000030  ; VhE|S[h

POLYATTR_BACK_OFF       *   0x00000000  ;  nee
POLYATTR_BACK_ON        *   0x00000040  ;      nm
POLYATTR_FRONT_OFF      *   0x00000000  ; \ nee
POLYATTR_FRONT_ON       *   0x00000080  ;      nm
POLYATTR_XLU_DEPTH_OFF  *   0x00000000  ; |S̃fvXobt@XV nee
POLYATTR_XLU_DEPTH_ON   *   0x00000800  ;                                nm
POLYATTR_FAR_REJECT     *   0x00000000  ; e`qWFNg
POLYATTR_FAR_CLIPPING   *   0x00001000  ; e`qNbsO
POLYATTR_DISP_1DOT      *   0x00002000  ; Phbg\
POLYATTR_DEPTH_LESS     *   0x00000000  ; fvXobt@l菬`
POLYATTR_DEPTH_EQUAL    *   0x00004000  ; fvXobt@lƓ`
POLYATTR_FOG_OFF        *   0x00000000  ; tHO nee
POLYATTR_FOG_ON         *   0x00008000  ;        nm

; \̃op萔

ST_POLYATTR_MODULATE    *   0           ; W[V[h
ST_POLYATTR_DECAL       *   1           ; fJ[[h
ST_POLYATTR_TOON        *   2           ; gD[^nCCg[h
ST_POLYATTR_HIGHLIGHT   *   2
ST_POLYATTR_SHADOW      *   3           ; VhE|S[h

ST_POLYATTR_DEPTH_LESS  *   0           ; fvXobt@l菬`
ST_POLYATTR_DEPTH_EQUAL *   1           ; fvXobt@lƓ`


;-----------------------------------------------------------------------
;                       adfhm Rg[
;-----------------------------------------------------------------------

BEGIN_PRIM_TYPE_MASK    *   0x00000003  ; v~eBu^Cv

BEGIN_PRIM_TYPE_SHIFT   *   0

BEGIN_TRIANGLES         *   0x00000000  ; Op`|S
BEGIN_QUADS             *   0x00000001  ; lp`|S
BEGIN_TRIANGLE_STRIP    *   0x00000002  ; AOp`|S
BEGIN_QUAD_STRIP        *   0x00000003  ; Alp`|S

; \̃op萔

ST_BEGIN_TRIANGLES      *   0           ; Op`|S
ST_BEGIN_QUADS          *   1           ; lp`|S
ST_BEGIN_TRIANGLE_STRIP *   2           ; AOp`|S
ST_BEGIN_QUAD_STRIP     *   3           ; Alp`|S


;-----------------------------------------------------------------------
;                       eNX` p[^
;-----------------------------------------------------------------------

TEX_IMAGE_BASE_MASK     *   0x0000ffff  ; C[Wx[XAhX
TEX_S_SIZE_MASK         *   0x00700000  ; rTCY
TEX_T_SIZE_MASK         *   0x03800000  ; sTCY
TEX_FORMAT_MASK         *   0x1c000000  ; tH[}bg
TEX_GEN_MODE_MASK       *   0xc0000000  ; eNX`Wϊ[h

TEX_ADDR_SHIFT          *   0
TEX_S_SIZE_SHIFT        *   20
TEX_T_SIZE_SHIFT        *   23
TEX_FORMAT_SHIFT        *   26
TEX_GEN_MODE_SHIFT      *   30

TEX_IMAGE_BASE_SHIFT    *   3

TEX_ST_REPEAT_ON        *   0x00030000  ; rss[g nm
TEX_ST_REPEAT_OFF       *   0x00000000  ;              nee
TEX_S_REPEAT_ON         *   0x00010000  ; rs[g   nm
TEX_S_REPEAT_OFF        *   0x00000000  ;              nee
TEX_T_REPEAT_ON         *   0x00020000  ; ss[g   nm
TEX_T_REPEAT_OFF        *   0x00000000  ;              nee
TEX_ST_FLIP_ON          *   0x000c0000  ; rstbv nm
TEX_ST_FLIP_OFF         *   0x00000000  ;              nee
TEX_S_FLIP_ON           *   0x00040000  ; rtbv   nm
TEX_S_FLIP_OFF          *   0x00000000  ;              nee
TEX_T_FLIP_ON           *   0x00080000  ; stbv   nm
TEX_T_FLIP_OFF          *   0x00000000  ;              nee
TEX_S_SIZE_8            *   0x00000000  ; rTCY   WeNZ
TEX_S_SIZE_16           *   0x00100000  ;          PUeNZ
TEX_S_SIZE_32           *   0x00200000  ;          RQeNZ
TEX_S_SIZE_64           *   0x00300000  ;          USeNZ
TEX_S_SIZE_128          *   0x00400000  ;        PQWeNZ
TEX_S_SIZE_256          *   0x00500000  ;        QTUeNZ
TEX_S_SIZE_512          *   0x00600000  ;        TPQeNZ
TEX_S_SIZE_1024         *   0x00700000  ;      POQSeNZ
TEX_T_SIZE_8            *   0x00000000  ; sTCY   WeNZ
TEX_T_SIZE_16           *   0x00800000  ;          PUeNZ
TEX_T_SIZE_32           *   0x01000000  ;          RQeNZ
TEX_T_SIZE_64           *   0x01800000  ;          USeNZ
TEX_T_SIZE_128          *   0x02000000  ;        PQWeNZ
TEX_T_SIZE_256          *   0x02800000  ;        QTUeNZ
TEX_T_SIZE_512          *   0x03000000  ;        TPQeNZ
TEX_T_SIZE_1024         *   0x03800000  ;      POQSeNZ

TEX_FORMAT_NONE         *   0x00000000  ; eNX`
TEX_FORMAT_4PLTT        *   0x08000000  ;     SFpbgeNX`
TEX_FORMAT_16PLTT       *   0x0c000000  ;   PUFpbgeNX`
TEX_FORMAT_256PLTT      *   0x10000000  ; QTUFpbgeNX`
TEX_FORMAT_4x4COMP      *   0x14000000  ; SSkeNX`
    IF :DEF: IRIS_TS
TEX_FORMAT_ALPHA3       *   0x04000000  ; ReNX`
    ENDIF
TEX_FORMAT_ALPHA5       *   0x18000000  ; TeNX`
TEX_FORMAT_DIRECT       *   0x1c000000  ; J[_CNgeNX`

TEX_PLTT0_OFF           *   0x20000000  ; J[pbgO nee
TEX_PLTT0_ON            *   0x00000000  ;                  nm
TEX_PLTT0_XLU           *   0x20000000  ;                  iOj

TEX_GEN_DIRECT          *   0x00000000  ; Wϊ
TEX_GENSRC_TEXCOORD     *   0x40000000  ; Wϊ\[X sb
TEX_GENSRC_NORMAL       *   0x80000000  ;                m
TEX_GENSRC_VERTEX       *   0xc0000000  ;                u


; \̃op萔

ST_TEX_SIZE_8           *   0           ; eNX`TCY WeNZ
ST_TEX_SIZE_16          *   1           ;                PUeNZ
ST_TEX_SIZE_32          *   2           ;                RQeNZ
ST_TEX_SIZE_64          *   3           ;                USeNZ
ST_TEX_SIZE_128         *   4           ;              PQWeNZ
ST_TEX_SIZE_256         *   5           ;              QTUeNZ
ST_TEX_SIZE_512         *   6           ;              TPQeNZ
ST_TEX_SIZE_1024        *   7           ;            POQSeNZ

ST_TEX_FORMAT_NONE      *   0           ; eNX`
ST_TEX_FORMAT_4PLTT     *   2           ;     SFpbgeNX`
ST_TEX_FORMAT_16PLTT    *   3           ;   PUFpbgeNX`
ST_TEX_FORMAT_256PLTT   *   4           ; QTUFpbgeNX`
ST_TEX_FORMAT_4x4COMP   *   5           ; SSkeNX`
    IF :DEF: IRIS_TS
ST_TEX_FORMAT_ALPHA3    *   1           ; ReNX`
    ENDIF
ST_TEX_FORMAT_ALPHA5    *   6           ; TeNX`
ST_TEX_FORMAT_DIRECT    *   7           ; J[_CNgeNX`

ST_TEX_GEN_DIRECT       *   0           ; Wϊ
ST_TEX_GENSRC_TEXCOORD  *   1           ; Wϊ\[X sb
ST_TEX_GENSRC_NORMAL    *   2           ;                m
ST_TEX_GENSRC_VERTEX    *   3           ;                u


;-----------------------------------------------------------------------
;                       eNX`pbgx[X
;-----------------------------------------------------------------------

TEX_PLTT_BASE_MASK      *   0x00001fff  ; pbgx[XAhX
TEXPLT_BASE_MASK        *   TEX_PLTT_BASE_MASK

TEXPLT_FORMAT_NONE          *   0       ; eNX`pbg
TEXPLT_FORMAT_4PLTT         *   2       ;     SFpbgeNX`
TEXPLT_FORMAT_16PLTT        *   3       ;   PUFpbgeNX`
TEXPLT_FORMAT_256PLTT       *   4       ; QTUFpbgeNX`
TEXPLT_FORMAT_4x4COMP       *   5       ; SSkeNX`
    IF :DEF: IRIS_TS
TEXPLT_FORMAT_ALPHA3        *   1       ; ReNX`
    ENDIF
TEXPLT_FORMAT_ALPHA5        *   6       ; TeNX`

TEXPLT_FORMAT_NONE_SHIFT    *   0
TEXPLT_FORMAT_4PLTT_SHIFT   *   3
TEXPLT_FORMAT_16PLTT_SHIFT  *   4
TEXPLT_FORMAT_256PLTT_SHIFT *   4
TEXPLT_FORMAT_4x4COMP_SHIFT *   4
    IF :DEF: IRIS_TS
TEXPLT_FORMAT_ALPHA3_SHIFT  *   4
    ENDIF
TEXPLT_FORMAT_ALPHA5_SHIFT  *   4

;-----------------------------------------------------------------------
;                       keNX` pbgCfbNX
;-----------------------------------------------------------------------

TEX4X4_PLTT_INDEX_MASK  *   0x00003fff  ; pbgCfbNX

TEX4X4_PLTT_INDEX_SHIFT *   0

TEX4X4_DIRECT_PLTT      *   0x00000000  ; Spbg
TEX4X4_LINER_PLTT       *   0x00008000  ; QpbgSԃpbg
TEX4X4_INDEX_3          *   0x00000000  ; RCfbNX{
TEX4X4_INDEX_4          *   0x00004000  ; SCfbNX



;-----------------------------------------------------------------------
;                       cl`Rg[
;-----------------------------------------------------------------------

DMA_ENABLE              *   0x80000000  ; cl`
DMA_IF_ENABLE           *   0x40000000  ; 荞ݗv 

DMA_TIMMING_MASK        *   0x38000000  ; Jn^C~O
DMA_COUNT_MASK          *   0x001fffff  ; ]

DMA_TIMMING_SHIFT       *   27
DMA_COUNT_SHIFT         *   0

DMA_TIMMING_IMM         *   0x00000000  ; ɋN
DMA_TIMMING_V_BLANK     *   0x08000000  ; uuNN
DMA_TIMMING_H_BLANK     *   0x10000000  ; guNN
DMA_TIMMING_DISP        *   0x18000000  ; \
DMA_TIMMING_DISP_MMEM   *   0x20000000  ; C\
DMA_TIMMING_CARD        *   0x28000000  ; J[h
DMA_TIMMING_CARTRIDGE   *   0x30000000  ; J[gbW
DMA_TIMMING_GXFIFO      *   0x38000000  ; WIgehen
DMA_16BIT_BUS           *   0x00000000  ; oXTCYPUaI
DMA_32BIT_BUS           *   0x04000000  ; oXTCYRQaI
DMA_CONTINUOUS_ON       *   0x02000000  ; ReBjAX[h nm
DMA_SRC_INC             *   0x00000000  ; ] CNg I
DMA_SRC_DEC             *   0x00800000  ; ] fNg   I
DMA_SRC_FIX             *   0x01000000  ; ] Œ I
DMA_DEST_INC            *   0x00000000  ; ] CNg I
DMA_DEST_DEC            *   0x00200000  ; ] fNg   I
DMA_DEST_FIX            *   0x00400000  ; ] Œ I
DMA_DEST_RELOAD         *   0x00600000  ; ] CNg/[h I

; \̃op萔

ST_DMA_TIMMING_IMM        *   0         ; ɋN
ST_DMA_TIMMING_V_BLANK    *   1         ; uuNN
ST_DMA_TIMMING_H_BLANK    *   2         ; guNN
ST_DMA_TIMMING_DISP       *   3         ; \N
ST_DMA_TIMMING_DISP_MMEM  *   4         ; C\
ST_DMA_TIMMING_CARD       *   5         ; J[h
ST_DMA_TIMMING_CARTRIDGE  *   6         ; J[gbW
ST_DMA_TIMMING_GXFIFO     *   7         ; WIgehen
ST_DMA_16BIT_BUS          *   0         ; oXTCYPUaI
ST_DMA_32BIT_BUS          *   1         ; oXTCYRQaI
ST_DMA_INC                *   0         ; AhXECNg I
ST_DMA_DEC                *   1         ; AhXEfNg   I
ST_DMA_FIX                *   2         ; AhXŒ I
ST_DMA_RELOAD             *   3         ; AhXECNg/[h I


;-----------------------------------------------------------------------
;                       ^C}[ Rg[
;-----------------------------------------------------------------------

TMR_PRESCALER_MASK      *   0x00030000  ; vXP[ NbN

TMR_PRESCALER_SHIFT     *   16

TMR_PRESCALER_1CK       *   0x00000000  ; vXP[ P
TMR_PRESCALER_64CK      *   0x00010000  ;            US
TMR_PRESCALER_256CK     *   0x00020000  ;          QTU
TMR_PRESCALER_1024CK    *   0x00030000  ;        POQS
TMR_CONNECT             *   0x00040000  ; ʃ^C}[ڑ
TMR_IF_ENABLE           *   0x00400000  ; 荞ݗv 
TMR_ENABLE              *   0x00800000  ; ^C}[N

; \̃op萔

ST_TMR_PRESCALER_1CK    *   0           ; vXP[ P
ST_TMR_PRESCALER_64CK   *   1           ;            US
ST_TMR_PRESCALER_256CK  *   2           ;          QTU
ST_TMR_PRESCALER_1024CK *   3           ;        POQS


;-----------------------------------------------------------------------
;                           L[
;-----------------------------------------------------------------------

BUTTON_MASK             *   0x030f      ; {^
PLUS_KEY_MASK           *   0x00f0      ; \L[
ALL_KEY_MASK            *   0x03ff      ; SẴL[

A_BUTTON                *   0x0001      ; `{^
B_BUTTON                *   0x0002      ; a{^
SELECT_BUTTON           *   0x0004      ; ZNg{^
START_BUTTON            *   0x0008      ; X^[g{^
R_KEY                   *   0x0010      ; E{^
L_KEY                   *   0x0020      ; {^
U_KEY                   *   0x0040      ; {^
D_KEY                   *   0x0080      ; {^
R_BUTTON                *   0x0100      ; q{^
L_BUTTON                *   0x0200      ; k{^
KEY_IF_ENABLE           *   0x4000      ; 荞ݗv 
KEY_OR_INTR             *   0x0000      ;   ʏL[荞
KEY_AND_INTR            *   0x8000      ; `mcL[荞

; \̃op萔

ST_KEY_OR_INTR          *   0           ;   ʏL[荞
ST_KEY_AND_INTR         *   1           ; `mcL[荞


;-----------------------------------------------------------------------
;                       O Rg[
;-----------------------------------------------------------------------

CTRDG_DT8_10CYC         *   0x0000      ; J[gbW Wf[^oX  POTCN
CTRDG_DT8_8CYC          *   0x0001      ;                                    WTCN
CTRDG_DT8_6CYC          *   0x0002      ;                                    UTCN
CTRDG_DT8_18CYC         *   0x0003      ;                                  PWTCN
CTRDG_AD16_1ST_10CYC    *   0x0000      ; J[gbW `cPUoX P POTCN
CTRDG_AD16_1ST_8CYC     *   0x0004      ;                                    WTCN
CTRDG_AD16_1ST_6CYC     *   0x0008      ;                                    UTCN
CTRDG_AD16_1ST_18CYC    *   0x000c      ;                                  PWTCN
CTRDG_AD16_2ND_6CYC     *   0x0000      ;                           Q   UTCN
CTRDG_AD16_2ND_4CYC     *   0x0010      ;                                    STCN

CTRDG_PHI_OUT_NONE      *   0x0000      ; Ӓ[qo̓NbN kŒ
CTRDG_PHI_OUT_4MCK      *   0x0020      ;                    Slg
CTRDG_PHI_OUT_8MCK      *   0x0040      ;                    Wlg
CTRDG_PHI_OUT_16MCK     *   0x0060      ;                  PUlg

CTRDG_ACCESS            *   0x0080      ; J[gbWANZXI
CTRDG_ACCESS_MAINP      *   0x0000      ;           CvZbT
CTRDG_ACCESS_SUBP       *   0x0080      ;           TuvZbT

CARD_ACCESS             *   0x0800      ; J[hANZXI
CARD_ACCESS_MAINP       *   0x0000      ;           CvZbT
CARD_ACCESS_SUBP        *   0x0800      ;           TuvZbT

MMEM_CE2_OUT            *   0x2000      ;             bdQMo

MMEM_INTF               *   0x4000      ; CC^tF[Xisdfł͏ɃZbgē[hɂj
MMEM_INTF_ASYNC         *   0x0000      ;                           񓯊[h
MMEM_INTF_SYNC          *   0x4000      ;                             [h

MMEM_PRIORITY           *   0x8000      ; CD挠I
MMEM_PRIORITY_MAINP     *   0x0000      ;           CvZbT
MMEM_PRIORITY_SUBP      *   0x8000      ;           TuvZbT

; \̃op萔

ST_CTRDG_DT8_10CYC      *   0           ; J[gbW Wf[^oX  POTCN
ST_CTRDG_DT8_8CYC       *   1           ;                                    WTCN
ST_CTRDG_DT8_6CYC       *   2           ;                                    UTCN
ST_CTRDG_DT8_18CYC      *   3           ;                                  PWTCN
ST_CTRDG_AD16_1ST_10CYC *   0           ; J[gbW `cPUoX P POTCN
ST_CTRDG_AD16_1ST_8CYC  *   1           ;                                    WTCN
ST_CTRDG_AD16_1ST_6CYC  *   2           ;                                    UTCN
ST_CTRDG_AD16_1ST_18CYC *   3           ;                                  PWTCN
ST_CTRDG_AD16_2ND_6CYC  *   0           ;                           Q   UTCN
ST_CTRDG_AD16_2ND_4CYC  *   1           ;                                    STCN

ST_CTRDG_PHI_OUT_NONE   *   0           ; Ӓ[qo̓NbN kŒ
ST_CTRDG_PHI_OUT_4MCK   *   1           ;                    Slg
ST_CTRDG_PHI_OUT_8MCK   *   2           ;                    Wlg
ST_CTRDG_PHI_OUT_16MCK  *   3           ;                  PUlg



    ENDIF  ; _IRIS_DEFINE_H

	END

