//====================================================================
//          IrisOS.h
//            OSCu
//
//          Copyright (C) 2003-2004 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_OS_H
#define _IRIS_OS_H


#ifdef __cplusplus
extern "C" {
#endif


#include <stdlib.h>
#include <IrisTarget.h>
#include <IrisTypes.h>



//======================================================================
//                      bNϐ
//
//EJ[h^J[gbW^botԋL[Nq`l^uq`l|b^c
//  Ȃǂ̂botԂł̋LX[XAbotԑMehen ̐L\[X
//  ̔r䂽߂ɂ̊֐gpB
//======================================================================

// bNhc

#define OS_UNLOCK_ID            0       // bNϐbNĂȂꍇ̂hc
#define OS_MAINP_LOCKED_FLAG    0x40    // CvZbTɂ郍bNmFtO
#define OS_MAINP_LOCK_ID_START  0x40    // CvZbTpbNhc̊蓖ĊJnԍ
#define OS_MAINP_LOCK_ID_END    0x6f    //                               蓖ďIԍ
#define OS_MAINP_DBG_LOCK_ID    0x70    //                               fobK\ԍ
#define OS_MAINP_SYSTEM_LOCK_ID 0x7f    //                               VXe\ԍ
#define OS_SUBP_LOCKED_FLAG     0x80    //   TuvZbTɂ郍bNmFtO
#define OS_SUBP_LOCK_ID_START   0x80    //   TuvZbTpbNhc̊蓖ĊJnԍ
#define OS_SUBP_LOCK_ID_END     0xaf    //                               蓖ďIԍ
#define OS_SUBP_DBG_LOCK_ID     0xb0    //                               fobK\ԍ
#define OS_SUBP_SYSTEM_LOCK_ID  0xbf    //                               VXe\ԍ

#define OS_LOCK_SUCCESS         0       // bN
#define OS_LOCK_ERROR           -1      // bNG[

#define OS_UNLOCK_SUCCESS       0       // bN
#define OS_UNLOCK_ERROR         -2      // bNG[

#define OS_LOCK_FREE            0       // bN

#define OS_LOCK_ID_ERROR        -3      // bNhcG[


// bNϐ\

typedef struct {
    u32 lockFlag;               // bNtOisW[IDi[j
    u16 ownerID;                // 擾W[ID
    u16 extension;              // g
} LockWord;
typedef  vl LockWord    vLockWord;

typedef struct {
    u8  lockFlag;               // bNtOisW[IDi[j
    u8  ownerID;                // 擾W[ID
} LockByte;
typedef  vl LockByte    vLockByte;


//----------------------------------------------------------------------
//          VXebNϐƋL\[XEANZX̏
//
//EVXebNϐAL\[X̃ftHg̃ANZX
//  TuvZbTɓn܂B
//
//EF  Ȃ
//
//E߂lFȂ
//
//J[gbWr̈̓fobKgp邽߃NA܂B
//----------------------------------------------------------------------

void OS_InitLock(void);

//----------------------------------------------------------------------
//          bNID̊l
//
//EbNϐ֐ݒ肷IDl܂B
//
//EF              Ȃ
//
//E߂lF
//  0x40 ` 0x6f        bNID
//  OS_LOCK_ID_ERROR    bNIDls
//
//ID48ނ܂ł蓖Ă邱Ƃł܂B
//  W[ɂĕ̃bNϐ𐧌䂷ꍇ
//  ł邾1IDgp悤ɂĉB
//----------------------------------------------------------------------

s32 OS_GetLockID(void);


//----------------------------------------------------------------------
//          XsbNi[h^oCgj
//
//EvZbTԂ⃂W[ԂŋL\[Xr䂷邽߂
//  bNϐ̃XsbNs܂B
//EbN܂Ŏs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//  OS_LOCK_SUCCESS     bN
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_LockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_LockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_LockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_LockCard(u32 lockID);            // J[h
s32 OS_LockCartridge(u32 lockID);       // J[gbW
s32 OS_LockWramBlock0(u32 lockID);      // bot[Nq`lEubNO
s32 OS_LockWramBlock1(u32 lockID);      // bot[Nq`lEubNP
s32 OS_LockVramC(u32 lockID);           // uq`l|b
s32 OS_LockVramD(u32 lockID);           // uq`l|c

s32 OS_LockSendFifo(u32 lockID);        // botԑMehen
s32 OS_LockDma0(u32 lockID);            // cl`O
s32 OS_LockDma1(u32 lockID);            // cl`P
s32 OS_LockDma2(u32 lockID);            // cl`Q
s32 OS_LockDma3(u32 lockID);            // cl`R
s32 OS_LockTimer0(u32 lockID);          // ^C}[O
s32 OS_LockTimer1(u32 lockID);          // ^C}[P
s32 OS_LockTimer2(u32 lockID);          // ^C}[Q
s32 OS_LockTimer3(u32 lockID);          // ^C}[R


//----------------------------------------------------------------------
//          bN̉i[h^oCgj
//
//EbNAL\[X̃ANZXTuvZbTɓn܂B
//EbNĂȂW[sꍇɂ͉ꂸA
//  OS_UNLOCK_ERROR Ԃ܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//                    bNiOɊi[ĂIDj
//  OS_UNLOCK_ERROR     bNG[
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_UnLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_UnLockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_UnLockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_UnLockCard(u32 lockID);          // J[h
s32 OS_UnLockCartridge(u32 lockID);     // J[gbW
s32 OS_UnLockWramBlock0(u32 lockID);    // bot[Nq`lEubNO
s32 OS_UnLockWramBlock1(u32 lockID);    // bot[Nq`lEubNP
s32 OS_UnLockVramC(u32 lockID);         // uq`l|b
s32 OS_UnLockVramD(u32 lockID);         // uq`l|c

s32 OS_UnLockSendFifo(u32 lockID);      // botԑMehen
s32 OS_UnLockDma0(u32 lockID);          // cl`O
s32 OS_UnLockDma1(u32 lockID);          // cl`P
s32 OS_UnLockDma2(u32 lockID);          // cl`Q
s32 OS_UnLockDma3(u32 lockID);          // cl`R
s32 OS_UnLockTimer0(u32 lockID);        // ^C}[O
s32 OS_UnLockTimer1(u32 lockID);        // ^C}[P
s32 OS_UnLockTimer2(u32 lockID);        // ^C}[Q
s32 OS_UnLockTimer3(u32 lockID);        // ^C}[R


//----------------------------------------------------------------------
//          bN̎si[h^oCgj
//
//EP񂾂XsbNs܂B
//EvZbTԂ̋L\[X͕KbNɎgpĉB
//EvZbTL̃\[X̓^C~OIɒł̂ł
//  bNȂĂ\܂B
//  L\[X̓fobOɌ肵ăbN邱Ƃł܂B
//
//EF
//  lockID              bNID
//  lockp               bNϐ̃|C^
//  CtrlFuncp           \[X֐̃|C^
//
//E߂lF
//                    bNiOɊi[ĂIDj
//  OS_LOCK_SUCCESS     bN
//  OS_LOCK_ID_ERROR    bNIDG[
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_TryLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_TryLockWord(u32 lockID, volatile LockWord *lockp, void (*CtrlFuncp)(void));
s32 OS_TryLockByte(u32 lockID, volatile LockByte *lockp, void (*CtrlFuncp)(void));


s32 OS_TryLockCard(u32 lockID);         // J[h
s32 OS_TryLockCartridge(u32 lockID);    // J[gbW
s32 OS_TryLockWramBlock0(u32 lockID);   // bot[Nq`lEubNO
s32 OS_TryLockWramBlock1(u32 lockID);   // bot[Nq`lEubNP
s32 OS_TryLockVramC(u32 lockID);        // uq`l|b
s32 OS_TryLockVramD(u32 lockID);        // uq`l|c

s32 OS_TryLockSendFifo(u32 lockID);     // botԑMehen
s32 OS_TryLockDma0(u32 lockID);         // cl`O
s32 OS_TryLockDma1(u32 lockID);         // cl`P
s32 OS_TryLockDma2(u32 lockID);         // cl`Q
s32 OS_TryLockDma3(u32 lockID);         // cl`R
s32 OS_TryLockTimer0(u32 lockID);       // ^C}[O
s32 OS_TryLockTimer1(u32 lockID);       // ^C}[P
s32 OS_TryLockTimer2(u32 lockID);       // ^C}[Q
s32 OS_TryLockTimer3(u32 lockID);       // ^C}[R


//----------------------------------------------------------------------
//          bNtO̓ǂݍ݁i[h^oCgj
//
//EbNtOǂݍ݂܂B
//EbNϐĂ邩ǂmF邱Ƃł܂B
//
//EF
//  lockp           bNϐ̃|C^
//
//E߂lF
//  0             bNiOɊi[ĂIDj
//  OS_LOCK_FREE    bN
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_ReadLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_ReadLockWord(volatile LockWord *lockp);
s32 OS_ReadLockByte(volatile LockByte *lockp);


// J[h
#ifdef IRIS_TS
#define OS_ReadLockCard()           OS_ReadLockWord((LockWord *)(CARD_LOCK_BUF))
#else
#define OS_ReadLockCard()           OS_ReadLockCartridge()      // J[gbWőp
#endif

// J[gbW
#define OS_ReadLockCartridge()      OS_ReadLockWord((LockWord *)(CARTRIDGE_LOCK_BUF))

// bot[Nq`lEubNO
#define OS_ReadLockWramBlock0()     OS_ReadLockWord((LockWord *)(WRAM_BLOCK0_LOCK_BUF))

// bot[Nq`lEubNP
#define OS_ReadLockWramBlock1()     OS_ReadLockWord((LockWord *)(WRAM_BLOCK1_LOCK_BUF))

// uq`l|b
#define OS_ReadLockVramC()          OS_ReadLockWord((LockWord *)(VRAM_C_LOCK_BUF))

// uq`l|c
#define OS_ReadLockVramD()          OS_ReadLockWord((LockWord *)(VRAM_D_LOCK_BUF))


// botԑMehen
#define OS_ReadLockSendFifo()       OS_ReadLockByte((LockByte *)(SEND_FIFO_LOCK_BUF))

// cl`O
#define OS_ReadLockDma0()           OS_ReadLockByte((LockByte *)(DMA0_LOCK_BUF))

// cl`P
#define OS_ReadLockDma1()           OS_ReadLockByte((LockByte *)(DMA1_LOCK_BUF))

// cl`Q
#define OS_ReadLockDma2()           OS_ReadLockByte((LockByte *)(DMA2_LOCK_BUF))

// cl`R
#define OS_ReadLockDma3()           OS_ReadLockByte((LockByte *)(DMA3_LOCK_BUF))

// ^C}[O
#define OS_ReadLockTimer0()         OS_ReadLockByte((LockByte *)(TIMER0_LOCK_BUF))

// ^C}[P
#define OS_ReadLockTimer1()         OS_ReadLockByte((LockByte *)(TIMER1_LOCK_BUF))

// ^C}[Q
#define OS_ReadLockTimer2()         OS_ReadLockByte((LockByte *)(TIMER2_LOCK_BUF))

// ^C}[R
#define OS_ReadLockTimer3()         OS_ReadLockByte((LockByte *)(TIMER3_LOCK_BUF))


//----------------------------------------------------------------------
//          bNϐ̏LW[ID̓ǂݍ݁i[h^oCgj
//
//EbNϐ̏LW[ID ǂݍ݂܂B
//EW[ID 0 ̏ꍇ͂̎_łǂ̃vZbT
//  LĂ̂mFł܂B
//EL\[X̏ꍇ́uCvZbTLĂԁv
//  ݂̂荞݂֎~邱ƂɂĈێ邱Ƃł܂B
//  ̑̏Ԃ̓TuvZbTωĂ܂\܂B
//ELW[ID  0 łĂbNϐĂƂ͌܂B
//
//EF
//  lockp       bNϐ̃|C^
//
//E߂lF    LW[ID
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I OS_ReadOwnerOfLockWord() gpĉB
//----------------------------------------------------------------------

s32 OS_ReadOwnerOfLockWord(volatile LockWord *lockp);
s32 OS_ReadOwnerOfLockByte(volatile LockByte *lockp);


// J[h
#ifdef IRIS_TS
#define OS_ReadOwnerOfLockCard()            OS_ReadOwnerOfLockWord((LockWord *)(CARD_LOCK_BUF))
#else
#define OS_ReadOwnerOfLockCard()            OS_ReadOwnerOfLockCartridge()   // J[gbWőp
#endif

// J[gbW
#define OS_ReadOwnerOfLockCartridge()       OS_ReadOwnerOfLockWord((LockWord *)(CARTRIDGE_LOCK_BUF))

// bot[Nq`lEubNO
#define OS_ReadOwnerOfLockWramBlock0()      OS_ReadOwnerOfLockWord((LockWord *)(WRAM_BLOCK0_LOCK_BUF))

// bot[Nq`lEubNP
#define OS_ReadOwnerOfLockWramBlock1()      OS_ReadOwnerOfLockWord((LockWord *)(WRAM_BLOCK1_LOCK_BUF))

// uq`l|b
#define OS_ReadOwnerOfLockVramC()           OS_ReadOwnerOfLockWord((LockWord *)(VRAM_C_LOCK_BUF))

// uq`l|c
#define OS_ReadOwnerOfLockVramD()           OS_ReadOwnerOfLockWord((LockWord *)(VRAM_D_LOCK_BUF))


// botԑMehen
#define OS_ReadOwnerOfLockSendFifo()        OS_ReadOwnerOfLockByte((LockByte *)(SEND_FIFO_LOCK_BUF))

// cl`O
#define OS_ReadOwnerOfLockDma0()            OS_ReadOwnerOfLockByte((LockByte *)(DMA0_LOCK_BUF))

// cl`P
#define OS_ReadOwnerOfLockDma1()            OS_ReadOwnerOfLockByte((LockByte *)(DMA1_LOCK_BUF))

// cl`Q
#define OS_ReadOwnerOfLockDma2()            OS_ReadOwnerOfLockByte((LockByte *)(DMA2_LOCK_BUF))

// cl`R
#define OS_ReadOwnerOfLockDma3()            OS_ReadOwnerOfLockByte((LockByte *)(DMA3_LOCK_BUF))

// ^C}[O
#define OS_ReadOwnerOfLockTimer0()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER0_LOCK_BUF))

// ^C}[P
#define OS_ReadOwnerOfLockTimer1()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER1_LOCK_BUF))

// ^C}[Q
#define OS_ReadOwnerOfLockTimer2()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER2_LOCK_BUF))

// ^C}[R
#define OS_ReadOwnerOfLockTimer3()          OS_ReadOwnerOfLockByte((LockByte *)(TIMER3_LOCK_BUF))


//----------------------------------------------------------------------
//          z[g
//
//EARM946E-SRÂݒ~܂B
//EY銄荞݂iIEɃZbgjĂ
//  荞ݗviIFZbgjɂĕA܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_Halt()	 ((void) 0)
#else
void OS_Halt(void);
#endif


//======================================================================
//          vOXe[^XWX^
//======================================================================

//----------------------------------------------------------------------
//          JgEvOXe[^XWX^ Zbg
//
//EJgEvOXe[^XWX^ɒlZbg܂B
//
//EF  ZbgJgEvOXe[^XWX^̒l
//
//E߂lFȂ
//----------------------------------------------------------------------

void OS_SetCpsr(u32 param);

//----------------------------------------------------------------------
//          JgEvOXe[^XWX^l l
//
//EJgEvOXe[^XWX^̒ll܂B
//
//EF  Ȃ
//
//E߂lFJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_GetCpsr(void);

//----------------------------------------------------------------------
//          hqp Cl[u^fBZ[u
//
//EJgEvOXe[^XWX^̂hqp
//  Cl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFύXÕJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_EnableCpsrIRQ(void);
u32 OS_DisableCpsrIRQ(void);

//----------------------------------------------------------------------
//          ehphqp Cl[u^fBZ[u
//
//EJgEvOXe[^XWX^̂ehphqp
//  Cl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFύXÕJgEvOXe[^XWX^̒l
//----------------------------------------------------------------------

u32 OS_EnableCpsrFIQ_IRQ(void);
u32 OS_DisableCpsrFIQ_IRQ(void);

//======================================================================
//          OxN^
//======================================================================

//----------------------------------------------------------------------
//          OxN^ʁ^ʃAhXֈړ
//
//EOxN^ʃAhX܂͉ʃAhXֈړ܂B
//EʃAhẌɂ̓VXeROMAʃAhẌɂ͖TCM
//  }bsOĂ܂B
//EftHgł̓VXeROMɐݒ肳Ă܂ATCMֈړ
//  ƂɂāADMAƂ̏Փ˂邱Ƃł܂B
//ETCMֈړꍇ͂炩ߓK؂ȃvO]Ă
//  Kv܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_UpperExceptionVector()		((void) 0)
#define OS_LowerExceptionVector()		((void) 0)
#else
void OS_UpperExceptionVector(void);
void OS_LowerExceptionVector(void);
#endif

//======================================================================
//          veNVjbg
//======================================================================

//----------------------------------------------------------------------
//          veNVjbg Cl[u^fBZ[u
//
//EveNVjbgCl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableProtectUnit()		((void) 0)
#define OS_DisableProtectUnit()		((void) 0)
#else
void OS_EnableProtectUnit(void);
void OS_DisableProtectUnit(void);
#endif

//======================================================================
//          ߃LbV
//======================================================================

//----------------------------------------------------------------------
//          ߃LbV Cl[u^fBZ[u
//
//E߃LbVCl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableICache()		((void) 0)
#define OS_DisableICache()		((void) 0)
#else
void OS_EnableICache(void);
void OS_DisableICache(void);
#endif

//----------------------------------------------------------------------
//          ߃LbV 
//
//E߃LbV𖳌܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_InvalidateICache()		((void) 0)
#else
void OS_InvalidateICache(void);
#endif

//----------------------------------------------------------------------
//          ߃LbVC̃AhXɂ閳
//
//EwAhX͈͂߃LbVɑ݂ꍇ
//  ̃C𖳌܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_InvalidateICacheAddr(addr)				((void) 0)
#define OS_InvalidateICacheAddrs(startp, size)		((void) 0)
#else
void OS_InvalidateICacheAddr(void *addr);
void OS_InvalidateICacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          ߃LbVC̃AhXɂvtFb`
//
//EwAhX͈͂߃LbVɑ݂Ȃꍇ
//  ̃C̃vtFb`s܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_PrefetchICacheAddr(addr)					((void) 0)
#define OS_PrefetchICacheAddrs(startp, size)		((void) 0)
#else
void OS_PrefetchICacheAddr(void *addr);
void OS_PrefetchICacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          ߃LbV bN_E
//
//EwAhX͈͂𖽗߃LbVɃbN_E܂B
//
//EF
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_LockdownICache(addr)		((void) 0)
#else
void OS_LockdownICache(void *startp, u32 size);
#endif


//======================================================================
//          f[^LbV
//======================================================================

//----------------------------------------------------------------------
//          f[^LbV Cl[u^fBZ[u
//
//Ef[^LbVCl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------


#ifdef IRIS_BB
#define OS_EnableDCache()		((void) 0)
#define OS_DisableDCache()		((void) 0)
#else
void OS_EnableDCache(void);
void OS_DisableDCache(void);
#endif

//----------------------------------------------------------------------
//          f[^LbV 
//
//Ef[^LbV𖳌܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_InvalidateDCache()		((void) 0)
#else
void OS_InvalidateDCache(void);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃AhXɂ閳
//
//EwAhX͈͂f[^LbVɑ݂ꍇ
//  ̃C𖳌܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_InvalidateDCacheAddr(addr)				((void) 0)
#define OS_InvalidateDCacheAddrs(startp, size)		((void) 0)
#else
void OS_InvalidateDCacheAddr(void *addr);
void OS_InvalidateDCacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbV N[
//
//Ef[^LbṼf[^֏o͂ăN[ɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_CleanDCache()		((void) 0)
#else
void OS_CleanDCache(void);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃AhXɂN[
//
//EwAhX͈͂̃f[^LbṼf[^֏o͂
//  ̃CN[ɂ܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_CleanDCacheAddr(addr)				((void) 0)
#define OS_CleanDCacheAddrs(startp, size)		((void) 0)
#else
void OS_CleanDCacheAddr(void *addr);
void OS_CleanDCacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃CfbNXɂN[
//
//EwCfbNX͈͂̃f[^LbṼf[^֏o͂
//  ̃CN[ɂ܂B
//
//EF
//  param   p[^
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_CleanDCacheIndex(param)				((void) 0)
#define OS_CleanDCacheIndices(param, size)		((void) 0)
#else
void OS_CleanDCacheIndex(u32 param);
void OS_CleanDCacheIndices(u32 param, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbV N[
//
//Ef[^LbṼf[^֏o͂ăN[
//  ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_Clean2InvalidateDCache()		((void) 0)
#else
void OS_Clean2InvalidateDCache(void);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃AhXɂN[
//
//EwAhX͈͂̃f[^LbṼf[^֏o͂
//  ̃CN[ɂɖ܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_Clean2InvalidateDCacheAddr(addr)					((void) 0)
#define OS_Clean2InvalidateDCacheAddrs(startp, size)		((void) 0)
#else
void OS_Clean2InvalidateDCacheAddr(void *addr);
void OS_Clean2InvalidateDCacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃CfbNXɂN[
//
//EwCfbNX͈͂̃f[^LbṼf[^֏o͂
//  ̃CN[ɂɖ܂B
//
//EF
//  param   p[^
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_Clean2InvalidateDCacheIndex(param)				((void) 0)
#define OS_Clean2InvalidateDCacheIndices(param, size)		((void) 0)
#else
void OS_Clean2InvalidateDCacheIndex(u32 param);
void OS_Clean2InvalidateDCacheIndices(u32 param, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbVC̃AhXɂv[h
//
//EwAhX͈͂f[^LbVɑ݂Ȃꍇ
//  ̃C̃v[hs܂B
//
//EF
//  addr    wAhX
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_PreloadDCacheAddr(addr)				((void) 0)
#define OS_PreloadDCacheAddrs(startp, size)		((void) 0)
#else
void OS_PreloadDCacheAddr(void *addr);
void OS_PreloadDCacheAddrs(void *startp, u32 size);
#endif

//----------------------------------------------------------------------
//          f[^LbV bN_E
//
//EwAhX͈͂f[^LbVɃbN_E܂B
//
//EF
//  startp  X^[gAhX
//  size    TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_LockdownDCache(startp, size)		((void) 0)
#else
void OS_LockdownDCache(void *startp, u32 size);
#endif


//======================================================================
//          Cgobt@
//======================================================================

//----------------------------------------------------------------------
//          Cgobt@ GveB҂
//
//ECgobt@GveBɂȂ܂ő҂܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_WaitWriteBufferEmpty()		((void) 0)
#else
void OS_WaitWriteBufferEmpty(void);
#endif


//======================================================================
//          ߂sbl
//======================================================================

//----------------------------------------------------------------------
//          ߂sbl Cl[u^fBZ[u
//
//E߂sblCl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableITCM()			((void) 0)
#define OS_DisableITCM()		((void) 0)
#else
void OS_EnableITCM(void);
void OS_DisableITCM(void);
#endif

//----------------------------------------------------------------------
//          ߂sblp[^ Zbg
//
//E߂sbl̗LGATCYZbg܂B
//
//EF
//  param   LGATCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_SetParamITCM(param)		((void) 0)
#else
void OS_SetParamITCM(u32 param);
#endif

//----------------------------------------------------------------------
//          ߂sblp[^ l
//
//E߂sbl̗LGATCYl܂B
//
//EF  Ȃ
//
//E߂lFLGATCY
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u32 OS_GetParamITCM(void);
#endif


//======================================================================
//          f[^sbl
//======================================================================

//----------------------------------------------------------------------
//          f[^sbl Cl[u^fBZ[u
//
//Ef[^sblCl[u^fBZ[uɂ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableDTCM()			((void) 0)
#define OS_DisableDTCM()		((void) 0)
#else
void OS_EnableDTCM(void);
void OS_DisableDTCM(void);
#endif

//----------------------------------------------------------------------
//          f[^sblp[^ Zbg
//
//Ef[^sbl̃x[XAhXƗLGATCYZbg܂B
//
//EF
//  param   x[XAhXLGATCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_SetParamDTCM()		((void) 0)
#else
void OS_SetParamDTCM(u32 param);
#endif

//----------------------------------------------------------------------
//          f[^sblp[^ l
//
//Ef[^sbl̃x[XAhXƗLGATCYl܂B
//
//EF  Ȃ
//
//E߂lFx[XAhXLGATCY
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u32 OS_GetParamDTCM(void);
#endif


//======================================================================
//          veNV[W
//======================================================================

//----------------------------------------------------------------------
//          veNV[W̖߃LbV Cl[u^fBZ[u
//
//EveNV[Wɖ߃LbVCl[u^fBZ[uɂ܂B
//
//EF
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableICache4PR()		((void) 0)
#define OS_DisableICache4PR()		((void) 0)
#else
void OS_EnableICache4PR(u32 flags);
void OS_DisableICache4PR(u32 flags);
#endif

//----------------------------------------------------------------------
//          veNV[W̃f[^LbV Cl[u^fBZ[u
//
//EveNV[WɃf[^LbVCl[u^fBZ[uɂ܂B
//
//EF
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableDCache4PR()		((void) 0)
#define OS_DisableDCache4PR()		((void) 0)
#else
void OS_EnableDCache4PR(u32 flags);
void OS_DisableDCache4PR(u32 flags);
#endif

//----------------------------------------------------------------------
//          veNV[W̃Cgobt@ Cl[u^fBZ[u
//
//EveNV[WɃCgobt@Cl[u^fBZ[uɂ܂B
//
//EF
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_EnableWriteBuffer4PR(flags)		((void) 0)
#define OS_DisableWriteBuffer4PR(flags)		((void) 0)
#else
void OS_EnableWriteBuffer4PR(u32 flags);
void OS_DisableWriteBuffer4PR(u32 flags);
#endif

//----------------------------------------------------------------------
//          veNV[W̖߃LbV Cl[utOl
//
//EveNV[Wɖ߃LbVCl[uǂԂ܂B
//
//EF  Ȃ
//
//E߂lFieveNV[WɑΉrbgɑ΂āj
//  1       Cl[u
//  0       fBZ[u
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u8 OS_GetICacheEnableFlags4PR(void);
#endif

//----------------------------------------------------------------------
//          veNV[W̃f[^LbV Cl[utOl
//
//EveNV[WɃf[^LbVCl[uǂԂ܂B
//
//EF  Ȃ
//
//E߂lFieveNV[WɑΉrbgɑ΂āj
//  1       Cl[u
//  0       fBZ[u
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u8 OS_GetDCacheEnableFlags4PR(void);
#endif

//----------------------------------------------------------------------
//          veNV[W̃Cgobt@ECl[utO l
//
//EveNV[WɃCgobt@Cl[uǂԂ܂B
//
//EF  Ȃ
//
//E߂lFieveNV[WɑΉrbgɑ΂āj
//  1       Cl[u
//  0       fBZ[u
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u8 OS_GetWriteBufferEnableFlags4PR(void);
#endif

//----------------------------------------------------------------------
//          veNV[W̖߃ANZX Zbg
//
//EveNV[W̖߃ANZXZbg܂B
//
//EF
//  setMask Zbg}XN
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_SetIPermissions4PR(setMask, flags)		((void) 0)
#else
void OS_SetIPermissions4PR(u32 setMask, u32 flags);
#endif

//----------------------------------------------------------------------
//          veNV[W̃f[^ANZX Zbg
//
//EveNV[W̃f[^ANZXZbg܂B
//
//EF
//  setMask Zbg}XN
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_SetDPermissions4PR(setMask, flags)		((void) 0)
#else
void OS_SetDPermissions4PR(u32 setMask, u32 flags);
#endif

//----------------------------------------------------------------------
//          veNV[W̖߃ANZX l
//
//EveNV[W̖߃ANZXl܂B
//
//EF  Ȃ
//
//E߂lFieveNV[WɑΉrbgɑ΂āj
//  C5_PERMIT_NA    ANZXs
//  C5_PERMIT_RW    [hCg
//  C5_PERMIT_RO    [hI[
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u32 OS_GetIPermissions4PR(void);
#endif

//----------------------------------------------------------------------
//          veNV[W̃f[^ANZX l
//
//EveNV[W̃f[^ANZXl܂B
//
//EF  Ȃ
//
//E߂lFieveNV[WɑΉrbgɑ΂āj
//  C5_PERMIT_NA    ANZXs
//  C5_PERMIT_RW    [hCg
//  C5_PERMIT_RO    [hI[
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
u32 OS_GetDPermissions4PR(void);
#endif


//----------------------------------------------------------------------
//          eveNV[W̃p[^ Zbg
//
//EveNV[W̃x[XAhXƃTCYZbg܂B
//
//EF
//  regionNo    [Wm
//  param       x[XAhXTCY
//
//E߂lFȂ
//----------------------------------------------------------------------

#ifdef IRIS_BB
#define OS_SetProtectRegion(regionNo, param)		((void) 0)
#else
#define OS_SetProtectRegion(regionNo, param)		OS_SetProtectRegionPriv(regionNo, param)

void OS_SetProtectRegion0(u32 param);
void OS_SetProtectRegion1(u32 param);
void OS_SetProtectRegion2(u32 param);
void OS_SetProtectRegion3(u32 param);
void OS_SetProtectRegion4(u32 param);
void OS_SetProtectRegion5(u32 param);
void OS_SetProtectRegion6(u32 param);
void OS_SetProtectRegion7(u32 param);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define OS_SetProtectRegionPriv(regionNo, param)	OS_SetProtectRegion##regionNo##(param)
#endif

//----------------------------------------------------------------------
//          eveNV[W̃p[^ l
//
//EveNV[W̃x[XAhXƃTCYl܂B
//
//EF
//  regionNo    [Wm
//
//E߂lFeveNV[W̃x[XAhXTCY
//----------------------------------------------------------------------

#ifdef IRIS_BB
#else
#define OS_GetProtectRegion(regionNo)				OS_GetProtectRegionPriv(regionNo)

u32 OS_GetProtectRegion0(void);
u32 OS_GetProtectRegion1(void);
u32 OS_GetProtectRegion2(void);
u32 OS_GetProtectRegion3(void);
u32 OS_GetProtectRegion4(void);
u32 OS_GetProtectRegion5(void);
u32 OS_GetProtectRegion6(void);
u32 OS_GetProtectRegion7(void);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define OS_GetProtectRegionPriv(regionNo, param)	OS_GetProtectRegion##regionNo##()
#endif



#ifdef __cplusplus
}
#endif

#endif  // _IRIS_OS_H

