;=======================================================================
;          IrisSubpMemoryMapArm.s
;            IRISTuvZbT }bv萔iARMASMpj
;
;          Copyright (C) 2002-2004 NINTENDO Co.,Ltd.
;=======================================================================
	IF :DEF: _IRIS_SUBP_MEMORY_MAP_H
	ELSE
_IRIS_SUBP_MEMORY_MAP_H  *  1


    INCLUDE     IrisSubpTargetArm.s


;-----------------------------------------------------------------------
;                       E}bv
;-----------------------------------------------------------------------

SHARE_WORK              *   0x027ff000          ; botԋL[N̈
SHARE_WORK_END          *   0x02800000

    IF :DEF: NDEBUG
SUBP_PRV                *   0x02380000          ; TuvZbTL̈i[Xo[Wj
    ELSE
    IF :DEF: MMEM_4M
SUBP_PRV                *   0x02300000          ;                       ifobOo[WCSl{́j
    ELSE
SUBP_PRV                *   0x02600000          ;                       ifobOo[WCWl{́j
    ENDIF
    ENDIF
SUBP_PRV_END            *   SHARED_WORK


MAIN_MEM                *   0x02000000          ; C
MAIN_MEM_END            *   (MAIN_MEM + 0x400000)
MAIN_MEM_EX_END         *   (MAIN_MEM + 0x800000) ;ig̍ŏIAhXj

MAIN_MEM_CMD_AREA       *   (MAIN_MEM_EX_END - 0x2)  ; CR}hsGAigp֎~GAj

SHARED_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x40) ; L\[XEbNobt@
SHARED_LOCK_BUF_END     *   (MAIN_MEM_EX_END - 0x10)

INIT_LOCK_BUF           *   (MAIN_MEM_EX_END - 0x10) ; bNobt@
CARTRIDGE_LOCK_BUF      *   (MAIN_MEM_EX_END - 0x18) ; J[gbWEbNobt@
CARD_LOCK_BUF           *   (MAIN_MEM_EX_END - 0x20) ; J[hEbNobt@
WRAM_BLOCK1_LOCK_BUF    *   (MAIN_MEM_EX_END - 0x28) ; bot[Nq`lEubNPEbNobt@
WRAM_BLOCK0_LOCK_BUF    *   (MAIN_MEM_EX_END - 0x30) ;                         ubNOEbNobt@
VRAM_D_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x38) ; uq`l|cEbNobt@
VRAM_C_LOCK_BUF         *   (MAIN_MEM_EX_END - 0x40) ;           bEbNobt@

TO_MAINP_IF_BUF         *   (MAIN_MEM_EX_END - 0x50) ; TuCvZbT荞ݗvtOiQa~Wj
WM_TO_MAINP_IF_BUF      *   (MAIN_MEM_EX_END - 0x50) ;     CX}l[W\
FROM_MAINP_IF_BUF       *   (MAIN_MEM_EX_END - 0x60) ; CTuvZbT荞ݗvtOiQa~Wj
WM_FROM_MAINP_IF_BUF    *   (MAIN_MEM_EX_END - 0x60) ;     CX}l[W\

ROM_HEADER_BUF          *   (MAIN_MEM_EX_END - 0x200); qnlo^GAf[^Eobt@


    IF :DEF: IRIS_TS
PRV_WRAM_DF_SIZE        *   0x8000              ; botL[Nq`l sr|sdfTCY
    ELSE
PRV_WRAM_DF_SIZE        *   0
    ENDIF

CPU_WRAM                *   0x037f8000          ; bot[Nq`l RubN\iftHgj
CPU_WRAM_END            *   (CPU_WRAM + PRV_WRAM_DF_SIZE + 0x10000)
CPU_WRAM_2B             *   0x037fc000          ;                        QubN\
CPU_WRAM_2B_END         *   (CPU_WRAM_2B + PRV_WRAM_DF_SIZE + 0xc000)
CPU_WRAM_BLOCK0         *   0x037f8000          ;                        ubNO
CPU_WRAM_BLOCK0_END     *   (CPU_WRAM_BLOCK0 + 0x4000)
CPU_WRAM_BLOCK1         *   0x037fc000          ;                        ubNP
CPU_WRAM_BLOCK1_END     *   (CPU_WRAM_BLOCK1 + 0x4000)
PRV_WRAM                *   0x03800000          ; botL[Nq`l
PRV_WRAM_END            *   (PRV_WRAM + PRV_WRAM_DF_SIZE + 0x8000)
CPU_XWRAM               *   0x06000000          ; botg[Nq`l
CPU_XWRAM_END           *   (CPU_XWRAM +0x40000)

INTR_VECTOR_BUF         *   (CPU_WRAM_END - 0x4); 荞ݕAhX
INTR_CHECK_BUF          *   (CPU_WRAM_END - 0x8); 荞݃`FbN

SEND_FIFO_LOCK_BUF      *   (CPU_WRAM_END - 0x10); botԑMehenEbNobt@
TIMER3_LOCK_BUF         *   (CPU_WRAM_END - 0x12); ^C}[REbNobt@
TIMER2_LOCK_BUF         *   (CPU_WRAM_END - 0x14); ^C}[Q
TIMER1_LOCK_BUF         *   (CPU_WRAM_END - 0x16); ^C}[P
TIMER0_LOCK_BUF         *   (CPU_WRAM_END - 0x18); ^C}[O
DMA3_LOCK_BUF           *   (CPU_WRAM_END - 0x1a); cl`REbNobt@
DMA2_LOCK_BUF           *   (CPU_WRAM_END - 0x1c); cl`Q
DMA1_LOCK_BUF           *   (CPU_WRAM_END - 0x1e); cl`P
DMA0_LOCK_BUF           *   (CPU_WRAM_END - 0x20); cl`O


REG_BASE                *   0x04000000          ; WX^Q
WIRELESS_INTF           *   0x04800000          ; ʐMC^tF[X
WIRELESS_INTF0          *   0x04800000          ;         C^tF[XO
WIRELESS_INTF1          *   0x04808000          ;         C^tF[XP
WIRELESS_INTF0_END      *   (WIRELESS_INTF0 + 0x8000)
WIRELESS_INTF1_END      *   (WIRELESS_INTF1 + 0x8000)
WIRELESS_INTF_END       *   (WIRELESS_INTF + 0x10000)

CARTRIDGE               *   0x08000000          ; J[gbW
CTRDG_AD16_BANK0        *   0x08000000          ; J[gbW `cPUoX oNO
CTRDG_AD16_BANK0_END    *   0x0a000000
CTRDG_AD16_BANK1        *   0x0a000000          ;                           oNP
CTRDG_AD16_BANK1_END    *   0x0c000000
CTRDG_AD16_BANK2        *   0x0c000000          ;                           oNQ
CTRDG_AD16_BANK2_END    *   0x0e000000
CTRDG_DT8               *   0x0e000000          ; J[gbW Wf[^oX
CTRDG_DT8_END           *   0x10000000


;-----------------------------------------------------------------------
;                       ETCY
;-----------------------------------------------------------------------

SHARED_WORK_SIZE        *   (SHARED_WORK_END - SHARED_WORK) ; botԋL[N̈iSjaȏAQׂ̂TCYj
SUBP_PRV_SIZE           *   (SUBP_PRV_END - SUBP_PRV)       ; TuvZbTL̈iRQjaȏAQׂ̂TCYj

SHARED_LOCK_BUF_SIZE    *   (SHARED_LOCK_BUF_END - SHARED_LOCK_BUF) ; L\[XEbNobt@


MAIN_MEM_SIZE           *   0x400000                        ; C
MAIN_MEM_EX_SIZE        *   0x800000                        ; igj

CPU_WRAM_SIZE           *   (0x10000 + PRV_WRAM_DF_SIZE)    ; bot[Nq`l RubN\iftHgj
CPU_WRAM_2B_SIZE        *   (0xc000  + PRV_WRAM_DF_SIZE)    ;                        QubN\
CPU_WRAM_BLOCK0_SIZE    *    0x4000                         ;                        ubNO
CPU_WRAM_BLOCK1_SIZE    *    0x4000                         ;                        ubNP
PRV_WRAM_SIZE           *   (0x8000  + PRV_WRAM_DF_SIZE)    ; botL[Nq`l
CPU_XWRAM_SIZE          *    0x40000                        ; botg[Nq`l

MROM_PAGE_SIZE          *   512                 ; }XNqnlEy[W

CARTRIDGE_SIZE          *   0x02000000          ; J[gbW
CTRDG_AD16_BANK_SIZE    *   0x02000000          ; J[gbW `cPUoX oN
CTRDG_AD16_BANK0_SIZE   *   0x02000000          ;                           oNO
CTRDG_AD16_BANK1_SIZE   *   0x02000000          ;                           oNP
CTRDG_AD16_BANK2_SIZE   *   0x02000000          ;                           oNQ
CTRDG_DT8_SIZE          *   0x02000000          ; J[gbW Wf[^oX


;-----------------------------------------------------------------------
;                       WX^EAhX
;-----------------------------------------------------------------------

REG_IME             *   (REG_BASE + 0x208)  ; 荞݃}X^Cl[u
REG_IE              *   (REG_BASE + 0x210)  ; 荞݋
REG_IF              *   (REG_BASE + 0x214)  ; 荞ݗv

REG_MAINPINTF       *   (REG_BASE + 0x180)  ; CvZbTC^tF[X
REG_MAINP_FIFO_CNT  *   (REG_BASE + 0x184)  ; botԂehenRg[
REG_SEND_FIFO       *   (REG_BASE + 0x188)      ; Mehen
REG_RECV_FIFO       *   (REG_BASE + 0x100000)   ; Mehen


REG_POWCNT          *   (REG_BASE + 0x304)  ; p[Rg[

REG_EXMEMCNT        *   (REG_BASE + 0x204)  ; ORg[

REG_VRAMSTAT        *   (REG_BASE + 0x240)  ; uq`lXe[^X
REG_WRAMSTAT        *   (REG_BASE + 0x241)  ; [Nq`lXe[^X
REG_WVRAMSTAT       *   (REG_BASE + 0x240)  ; uq`l bEc { [Nq`l Xe[^X


REG_DISPSTAT        *   (REG_BASE + 0x4)    ; \Xe[^X
REG_VCOUNT          *   (REG_BASE + 0x6)    ; uJE^


REG_SPICNT          *   (REG_BASE + 0x1c0)  ; SPIRg[
REG_SPIDATA         *   (REG_BASE + 0x1c2)  ; SPIf[^

REG_RCNT            *   (REG_BASE + 0x134)  ; ėpo̓Rg[

REG_KEYINPUT        *   (REG_BASE + 0x130)  ; L[
REG_KEYCNT          *   (REG_BASE + 0x132)  ; L[Rg[


REG_DMA0            *   (REG_BASE + 0xb0)   ; cl`O
REG_DMA0SAD         *   (REG_BASE + 0xb0)
REG_DMA0DAD         *   (REG_BASE + 0xb4)
REG_DMA0CNT         *   (REG_BASE + 0xb8)
REG_DMA0CNT_L       *   (REG_BASE + 0xb8)
REG_DMA0CNT_H       *   (REG_BASE + 0xba)
REG_DMA1            *   (REG_BASE + 0xbc)   ; cl`P
REG_DMA1SAD         *   (REG_BASE + 0xbc)
REG_DMA1DAD         *   (REG_BASE + 0xc0)
REG_DMA1CNT         *   (REG_BASE + 0xc4)
REG_DMA1CNT_L       *   (REG_BASE + 0xc4)
REG_DMA1CNT_H       *   (REG_BASE + 0xc6)
REG_DMA2            *   (REG_BASE + 0xc8)   ; cl`Q
REG_DMA2SAD         *   (REG_BASE + 0xc8)
REG_DMA2DAD         *   (REG_BASE + 0xcc)
REG_DMA2CNT         *   (REG_BASE + 0xd0)
REG_DMA2CNT_L       *   (REG_BASE + 0xd0)
REG_DMA2CNT_H       *   (REG_BASE + 0xd2)
REG_DMA3            *   (REG_BASE + 0xd4)   ; cl`R
REG_DMA3SAD         *   (REG_BASE + 0xd4)
REG_DMA3DAD         *   (REG_BASE + 0xd8)
REG_DMA3CNT         *   (REG_BASE + 0xdc)
REG_DMA3CNT_L       *   (REG_BASE + 0xdc)
REG_DMA3CNT_H       *   (REG_BASE + 0xde)


REG_TM0CNT          *   (REG_BASE + 0x100)  ; ^C}[O
REG_TM0CNT_L        *   (REG_BASE + 0x100)
REG_TM0CNT_H        *   (REG_BASE + 0x102)
REG_TM1CNT          *   (REG_BASE + 0x104)  ; ^C}[P
REG_TM1CNT_L        *   (REG_BASE + 0x104)
REG_TM1CNT_H        *   (REG_BASE + 0x106)
REG_TM2CNT          *   (REG_BASE + 0x108)  ; ^C}[Q
REG_TM2CNT_L        *   (REG_BASE + 0x108)
REG_TM2CNT_H        *   (REG_BASE + 0x10a)
REG_TM3CNT          *   (REG_BASE + 0x10c)  ; ^C}[R
REG_TM3CNT_L        *   (REG_BASE + 0x10c)
REG_TM3CNT_H        *   (REG_BASE + 0x10e)


REG_SOUNDCNT        *   (REG_BASE + 0x500)  ; TEhE}X^Rg[

REG_SOUNDBIAS       *   (REG_BASE + 0x504)  ; TEhah`r

REG_SNDCAPCNT       *   (REG_BASE + 0x508)  ; TEhLv`Rg[
REG_SNDCAP0DAD      *   (REG_BASE + 0x510)  ; TEhLv`Op[^
REG_SNDCAP0LEN      *   (REG_BASE + 0x514)
REG_SNDCAP1DAD      *   (REG_BASE + 0x518)  ; TEhLv`Pp[^
REG_SNDCAP1LEN      *   (REG_BASE + 0x51c)

REG_SOUND0CNT       *   (REG_BASE + 0x400)  ; TEhORg[
REG_SOUND0CNT_L     *   (REG_BASE + 0x400)
REG_SOUND0CNT_H     *   (REG_BASE + 0x402)
REG_SOUND0SAD       *   (REG_BASE + 0x404)
REG_SOUND0TMR       *   (REG_BASE + 0x408)
REG_SOUND0RPT_PT    *   (REG_BASE + 0x40a)
REG_SOUND0RPT_LEN   *   (REG_BASE + 0x40c)
REG_SOUND1CNT       *   (REG_BASE + 0x410)  ; TEhPRg[
REG_SOUND1CNT_L     *   (REG_BASE + 0x410)
REG_SOUND1CNT_H     *   (REG_BASE + 0x412)
REG_SOUND1SAD       *   (REG_BASE + 0x414)
REG_SOUND1TMR       *   (REG_BASE + 0x418)
REG_SOUND1RPT_PT    *   (REG_BASE + 0x41a)
REG_SOUND1RPT_LEN   *   (REG_BASE + 0x41c)
REG_SOUND2CNT       *   (REG_BASE + 0x420)  ; TEhQRg[
REG_SOUND2CNT_L     *   (REG_BASE + 0x420)
REG_SOUND2CNT_H     *   (REG_BASE + 0x422)
REG_SOUND2SAD       *   (REG_BASE + 0x424)
REG_SOUND2TMR       *   (REG_BASE + 0x428)
REG_SOUND2RPT_PT    *   (REG_BASE + 0x42a)
REG_SOUND2RPT_LEN   *   (REG_BASE + 0x42c)
REG_SOUND3CNT       *   (REG_BASE + 0x430)  ; TEhRRg[
REG_SOUND3CNT_L     *   (REG_BASE + 0x430)
REG_SOUND3CNT_H     *   (REG_BASE + 0x432)
REG_SOUND3SAD       *   (REG_BASE + 0x434)
REG_SOUND3TMR       *   (REG_BASE + 0x438)
REG_SOUND3RPT_PT    *   (REG_BASE + 0x43a)
REG_SOUND3RPT_LEN   *   (REG_BASE + 0x43c)
REG_SOUND4CNT       *   (REG_BASE + 0x440)  ; TEhSRg[
REG_SOUND4CNT_L     *   (REG_BASE + 0x440)
REG_SOUND4CNT_H     *   (REG_BASE + 0x442)
REG_SOUND4SAD       *   (REG_BASE + 0x444)
REG_SOUND4TMR       *   (REG_BASE + 0x448)
REG_SOUND4RPT_PT    *   (REG_BASE + 0x44a)
REG_SOUND4RPT_LEN   *   (REG_BASE + 0x44c)
REG_SOUND5CNT       *   (REG_BASE + 0x450)  ; TEhTRg[
REG_SOUND5CNT_L     *   (REG_BASE + 0x450)
REG_SOUND5CNT_H     *   (REG_BASE + 0x452)
REG_SOUND5SAD       *   (REG_BASE + 0x454)
REG_SOUND5TMR       *   (REG_BASE + 0x458)
REG_SOUND5RPT_PT    *   (REG_BASE + 0x45a)
REG_SOUND5RPT_LEN   *   (REG_BASE + 0x45c)
REG_SOUND6CNT       *   (REG_BASE + 0x460)  ; TEhURg[
REG_SOUND6CNT_L     *   (REG_BASE + 0x460)
REG_SOUND6CNT_H     *   (REG_BASE + 0x462)
REG_SOUND6SAD       *   (REG_BASE + 0x464)
REG_SOUND6TMR       *   (REG_BASE + 0x468)
REG_SOUND6RPT_PT    *   (REG_BASE + 0x46a)
REG_SOUND6RPT_LEN   *   (REG_BASE + 0x46c)
REG_SOUND7CNT       *   (REG_BASE + 0x470)  ; TEhVRg[
REG_SOUND7CNT_L     *   (REG_BASE + 0x470)
REG_SOUND7CNT_H     *   (REG_BASE + 0x472)
REG_SOUND7SAD       *   (REG_BASE + 0x474)
REG_SOUND7TMR       *   (REG_BASE + 0x478)
REG_SOUND7RPT_PT    *   (REG_BASE + 0x47a)
REG_SOUND7RPT_LEN   *   (REG_BASE + 0x47c)
REG_SOUND8CNT       *   (REG_BASE + 0x480)  ; TEhWRg[
REG_SOUND8CNT_L     *   (REG_BASE + 0x480)
REG_SOUND8CNT_H     *   (REG_BASE + 0x482)
REG_SOUND8SAD       *   (REG_BASE + 0x484)
REG_SOUND8TMR       *   (REG_BASE + 0x488)
REG_SOUND8RPT_PT    *   (REG_BASE + 0x48a)
REG_SOUND8RPT_LEN   *   (REG_BASE + 0x48c)
REG_SOUND9CNT       *   (REG_BASE + 0x490)  ; TEhXRg[
REG_SOUND9CNT_L     *   (REG_BASE + 0x490)
REG_SOUND9CNT_H     *   (REG_BASE + 0x492)
REG_SOUND9SAD       *   (REG_BASE + 0x494)
REG_SOUND9TMR       *   (REG_BASE + 0x498)
REG_SOUND9RPT_PT    *   (REG_BASE + 0x49a)
REG_SOUND9RPT_LEN   *   (REG_BASE + 0x49c)
REG_SOUND10CNT      *   (REG_BASE + 0x4a0)  ; TEhPORg[
REG_SOUND10CNT_L    *   (REG_BASE + 0x4a0)
REG_SOUND10CNT_H    *   (REG_BASE + 0x4a2)
REG_SOUND10SAD      *   (REG_BASE + 0x4a4)
REG_SOUND10TMR      *   (REG_BASE + 0x4a8)
REG_SOUND10RPT_PT   *   (REG_BASE + 0x4aa)
REG_SOUND10RPT_LEN  *   (REG_BASE + 0x4ac)
REG_SOUND11CNT      *   (REG_BASE + 0x4b0)  ; TEhPPRg[
REG_SOUND11CNT_L    *   (REG_BASE + 0x4b0)
REG_SOUND11CNT_H    *   (REG_BASE + 0x4b2)
REG_SOUND11SAD      *   (REG_BASE + 0x4b4)
REG_SOUND11TMR      *   (REG_BASE + 0x4b8)
REG_SOUND11RPT_PT   *   (REG_BASE + 0x4ba)
REG_SOUND11RPT_LEN  *   (REG_BASE + 0x4bc)
REG_SOUND12CNT      *   (REG_BASE + 0x4c0)  ; TEhPQRg[
REG_SOUND12CNT_L    *   (REG_BASE + 0x4c0)
REG_SOUND12CNT_H    *   (REG_BASE + 0x4c2)
REG_SOUND12SAD      *   (REG_BASE + 0x4c4)
REG_SOUND12TMR      *   (REG_BASE + 0x4c8)
REG_SOUND12RPT_PT   *   (REG_BASE + 0x4ca)
REG_SOUND12RPT_LEN  *   (REG_BASE + 0x4cc)
REG_SOUND13CNT      *   (REG_BASE + 0x4d0)  ; TEhPRRg[
REG_SOUND13CNT_L    *   (REG_BASE + 0x4d0)
REG_SOUND13CNT_H    *   (REG_BASE + 0x4d2)
REG_SOUND13SAD      *   (REG_BASE + 0x4d4)
REG_SOUND13TMR      *   (REG_BASE + 0x4d8)
REG_SOUND13RPT_PT   *   (REG_BASE + 0x4da)
REG_SOUND13RPT_LEN  *   (REG_BASE + 0x4dc)
REG_SOUND14CNT      *   (REG_BASE + 0x4e0)  ; TEhPSRg[
REG_SOUND14CNT_L    *   (REG_BASE + 0x4e0)
REG_SOUND14CNT_H    *   (REG_BASE + 0x4e2)
REG_SOUND14SAD      *   (REG_BASE + 0x4e4)
REG_SOUND14TMR      *   (REG_BASE + 0x4e8)
REG_SOUND14RPT_PT   *   (REG_BASE + 0x4ea)
REG_SOUND14RPT_LEN  *   (REG_BASE + 0x4ec)
REG_SOUND15CNT      *   (REG_BASE + 0x4f0)  ; TEhPTRg[
REG_SOUND15CNT_L    *   (REG_BASE + 0x4f0)
REG_SOUND15CNT_H    *   (REG_BASE + 0x4f2)
REG_SOUND15SAD      *   (REG_BASE + 0x4f4)
REG_SOUND15TMR      *   (REG_BASE + 0x4f8)
REG_SOUND15RPT_PT   *   (REG_BASE + 0x4fa)
REG_SOUND15RPT_LEN  *   (REG_BASE + 0x4fc)


;-----------------------------------------------------------------------
;                       WX^EItZbg
;-----------------------------------------------------------------------

OFFSET_REG_IME              *   0x208       ; 荞݃}X^Cl[u
OFFSET_REG_IE               *   0x210       ; 荞݋
OFFSET_REG_IF               *   0x214       ; 荞ݗv

OFFSET_REG_MAINPINTF        *   0x180       ; CvZbTC^tF[X
OFFSET_REG_MAINP_FIFO_CNT   *   0x184       ; botԂehenRg[
OFFSET_REG_SEND_FIFO        *   0x188       ;     Mehen
OFFSET_REG_RECV_FIFO        *   0x100000    ;     Mehen


OFFSET_REG_POWCNT           *   0x304       ; p[Rg[

OFFSET_REG_EXMEMCNT         *   0x204       ; ORg[

OFFSET_REG_VRAMSTAT         *   0x240       ; uq`lXe[^X
OFFSET_REG_WRAMSTAT         *   0x241       ; [Nq`lXe[^X
OFFSET_REG_WVRAMSTAT        *   0x240       ; uq`l bEc { [Nq`l Xe[^X


OFFSET_REG_DISPSTAT         *   0x4         ; Xe[^X
OFFSET_REG_VCOUNT           *   0x6         ; uJE^


OFFSET_REG_SPICNT           *   0x1c0       ; SPIRg[
OFFSET_REG_SPIDATA          *   0x1c2       ; SPIf[^

OFFSET_REG_RCNT             *   0x134       ; ėpo̓Rg[

OFFSET_REG_KEYINPUT         *   0x130       ; L[
OFFSET_REG_KEYCNT           *   0x132       ; L[Rg[


OFFSET_REG_DMA0             *   0xb0        ; cl`O
OFFSET_REG_DMA0SAD          *   0xb0
OFFSET_REG_DMA0DAD          *   0xb4
OFFSET_REG_DMA0CNT          *   0xb8
OFFSET_REG_DMA0CNT_L        *   0xb8
OFFSET_REG_DMA0CNT_H        *   0xba
OFFSET_REG_DMA1             *   0xbc        ; cl`P
OFFSET_REG_DMA1SAD          *   0xbc
OFFSET_REG_DMA1DAD          *   0xc0
OFFSET_REG_DMA1CNT          *   0xc4
OFFSET_REG_DMA1CNT_L        *   0xc4
OFFSET_REG_DMA1CNT_H        *   0xc6
OFFSET_REG_DMA2             *   0xc8        ; cl`Q
OFFSET_REG_DMA2SAD          *   0xc8
OFFSET_REG_DMA2DAD          *   0xcc
OFFSET_REG_DMA2CNT          *   0xd0
OFFSET_REG_DMA2CNT_L        *   0xd0
OFFSET_REG_DMA2CNT_H        *   0xd2
OFFSET_REG_DMA3             *   0xd4        ; cl`R
OFFSET_REG_DMA3SAD          *   0xd4
OFFSET_REG_DMA3DAD          *   0xd8
OFFSET_REG_DMA3CNT          *   0xdc
OFFSET_REG_DMA3CNT_L        *   0xdc
OFFSET_REG_DMA3CNT_H        *   0xde


OFFSET_REG_TM0CNT           *   0x100       ; ^C}[O
OFFSET_REG_TM0CNT_L         *   0x100
OFFSET_REG_TM0CNT_H         *   0x102
OFFSET_REG_TM1CNT           *   0x104       ; ^C}[P
OFFSET_REG_TM1CNT_L         *   0x104
OFFSET_REG_TM1CNT_H         *   0x106
OFFSET_REG_TM2CNT           *   0x108       ; ^C}[Q
OFFSET_REG_TM2CNT_L         *   0x108
OFFSET_REG_TM2CNT_H         *   0x10a
OFFSET_REG_TM3CNT           *   0x10c       ; ^C}[R
OFFSET_REG_TM3CNT_L         *   0x10c
OFFSET_REG_TM3CNT_H         *   0x10e


OFFSET_REG_SOUNDCNT         *   0x500       ; TEh}X^Rg[

OFFSET_REG_SOUNDBIAS        *   0x504       ; TEhah`r

OFFSET_REG_SNDCAPCNT        *   0x508       ; TEhLv`Rg[
OFFSET_REG_SNDCAP0DAD       *   0x510       ; TEhLv`Op[^
OFFSET_REG_SNDCAP0LEN       *   0x514
OFFSET_REG_SNDCAP1DAD       *   0x518       ; TEhLv`Pp[^
OFFSET_REG_SNDCAP1LEN       *   0x51c

OFFSET_REG_SOUND0CNT        *   0x400       ; TEhORg[
OFFSET_REG_SOUND0CNT_L      *   0x400
OFFSET_REG_SOUND0CNT_H      *   0x402
OFFSET_REG_SOUND0SAD        *   0x404
OFFSET_REG_SOUND0TMR        *   0x408
OFFSET_REG_SOUND0REPLEN     *   0x40c
OFFSET_REG_SOUND1CNT        *   0x410       ; TEhPRg[
OFFSET_REG_SOUND1CNT_L      *   0x410
OFFSET_REG_SOUND1CNT_H      *   0x412
OFFSET_REG_SOUND1SAD        *   0x414
OFFSET_REG_SOUND1TMR        *   0x418
OFFSET_REG_SOUND1REPLEN     *   0x41c
OFFSET_REG_SOUND2CNT        *   0x420       ; TEhQRg[
OFFSET_REG_SOUND2CNT_L      *   0x420
OFFSET_REG_SOUND2CNT_H      *   0x422
OFFSET_REG_SOUND2SAD        *   0x424
OFFSET_REG_SOUND2TMR        *   0x428
OFFSET_REG_SOUND2REPLEN     *   0x42c
OFFSET_REG_SOUND3CNT        *   0x430       ; TEhRRg[
OFFSET_REG_SOUND3CNT_L      *   0x430
OFFSET_REG_SOUND3CNT_H      *   0x432
OFFSET_REG_SOUND3SAD        *   0x434
OFFSET_REG_SOUND3TMR        *   0x438
OFFSET_REG_SOUND3REPLEN     *   0x43c
OFFSET_REG_SOUND4CNT        *   0x440       ; TEhSRg[
OFFSET_REG_SOUND4CNT_L      *   0x440
OFFSET_REG_SOUND4CNT_H      *   0x442
OFFSET_REG_SOUND4SAD        *   0x444
OFFSET_REG_SOUND4TMR        *   0x448
OFFSET_REG_SOUND4REPLEN     *   0x44c
OFFSET_REG_SOUND5CNT        *   0x450       ; TEhTRg[
OFFSET_REG_SOUND5CNT_L      *   0x450
OFFSET_REG_SOUND5CNT_H      *   0x452
OFFSET_REG_SOUND5SAD        *   0x454
OFFSET_REG_SOUND5TMR        *   0x458
OFFSET_REG_SOUND5REPLEN     *   0x45c
OFFSET_REG_SOUND6CNT        *   0x460       ; TEhURg[
OFFSET_REG_SOUND6CNT_L      *   0x460
OFFSET_REG_SOUND6CNT_H      *   0x462
OFFSET_REG_SOUND6SAD        *   0x464
OFFSET_REG_SOUND6TMR        *   0x468
OFFSET_REG_SOUND6REPLEN     *   0x46c
OFFSET_REG_SOUND7CNT        *   0x470       ; TEhVRg[
OFFSET_REG_SOUND7CNT_L      *   0x470
OFFSET_REG_SOUND7CNT_H      *   0x472
OFFSET_REG_SOUND7SAD        *   0x474
OFFSET_REG_SOUND7TMR        *   0x478
OFFSET_REG_SOUND7REPLEN     *   0x47c
OFFSET_REG_SOUND8CNT        *   0x480       ; TEhWRg[
OFFSET_REG_SOUND8CNT_L      *   0x480
OFFSET_REG_SOUND8CNT_H      *   0x482
OFFSET_REG_SOUND8SAD        *   0x484
OFFSET_REG_SOUND8TMR        *   0x488
OFFSET_REG_SOUND8REPLEN     *   0x48c
OFFSET_REG_SOUND9CNT        *   0x490       ; TEhXRg[
OFFSET_REG_SOUND9CNT_L      *   0x490
OFFSET_REG_SOUND9CNT_H      *   0x492
OFFSET_REG_SOUND9SAD        *   0x494
OFFSET_REG_SOUND9TMR        *   0x498
OFFSET_REG_SOUND9REPLEN     *   0x49c
OFFSET_REG_SOUND10CNT       *   0x4a0       ; TEhPORg[
OFFSET_REG_SOUND10CNT_L     *   0x4a0
OFFSET_REG_SOUND10CNT_H     *   0x4a2
OFFSET_REG_SOUND10SAD       *   0x4a4
OFFSET_REG_SOUND10TMR       *   0x4a8
OFFSET_REG_SOUND10REPLEN    *   0x4ac
OFFSET_REG_SOUND11CNT       *   0x4b0       ; TEhPPRg[
OFFSET_REG_SOUND11CNT_L     *   0x4b0
OFFSET_REG_SOUND11CNT_H     *   0x4b2
OFFSET_REG_SOUND11SAD       *   0x4b4
OFFSET_REG_SOUND11TMR       *   0x4b8
OFFSET_REG_SOUND11REPLEN    *   0x4bc
OFFSET_REG_SOUND12CNT       *   0x4c0       ; TEhPQRg[
OFFSET_REG_SOUND12CNT_L     *   0x4c0
OFFSET_REG_SOUND12CNT_H     *   0x4c2
OFFSET_REG_SOUND12SAD       *   0x4c4
OFFSET_REG_SOUND12TMR       *   0x4c8
OFFSET_REG_SOUND12REPLEN    *   0x4cc
OFFSET_REG_SOUND13CNT       *   0x4d0       ; TEhPRRg[
OFFSET_REG_SOUND13CNT_L     *   0x4d0
OFFSET_REG_SOUND13CNT_H     *   0x4d2
OFFSET_REG_SOUND13SAD       *   0x4d4
OFFSET_REG_SOUND13TMR       *   0x4d8
OFFSET_REG_SOUND13REPLEN    *   0x4dc
OFFSET_REG_SOUND14CNT       *   0x4e0       ; TEhPSRg[
OFFSET_REG_SOUND14CNT_L     *   0x4e0
OFFSET_REG_SOUND14CNT_H     *   0x4e2
OFFSET_REG_SOUND14SAD       *   0x4e4
OFFSET_REG_SOUND14TMR       *   0x4e8
OFFSET_REG_SOUND14REPLEN    *   0x4ec
OFFSET_REG_SOUND15CNT       *   0x4f0       ; TEhPTRg[
OFFSET_REG_SOUND15CNT_L     *   0x4f0
OFFSET_REG_SOUND15CNT_H     *   0x4f2
OFFSET_REG_SOUND15SAD       *   0x4f4
OFFSET_REG_SOUND15TMR       *   0x4f8
OFFSET_REG_SOUND15REPLEN    *   0x4fc



    ENDIF  ; _IRIS_SUBP_MEMORY_MAP_H

	END

