;=====================================================================
;           IrisSubpOS_Mw.s
;             OSCuiMWASMARMpj
;
;           Copyright (C) 2003-2004 NINTENDO Co.,Ltd.
;=====================================================================
#ifndef _IRIS_SUBP_OS_H
#define _IRIS_SUBP_OS_H


    .INCLUDE    IrisSubpTarget.h
    .INCLUDE    IrisSubpDefine.h



;=======================================================================
;                       bNϐ
;=======================================================================

// bNhc

#define OS_UNLOCK_ID            0       // bNϐbNĂȂꍇ̂hc
#define OS_MAINP_LOCKED_FLAG    0x40    // CvZbTɂ郍bNmFtO
#define OS_MAINP_LOCK_ID_START  0x40    // CvZbTpbNhc̊蓖ĊJnԍ
#define OS_MAINP_LOCK_ID_END    0x6f    //                               蓖ďIԍ
#define OS_MAINP_DBG_LOCK_ID    0x70    //                               fobK\ԍ
#define OS_MAINP_SYSTEM_LOCK_ID 0x7f    //                               VXe\ԍ
#define OS_SUBP_LOCKED_FLAG     0x80    //   TuvZbTɂ郍bNmFtO
#define OS_SUBP_LOCK_ID_START   0x80    //   TuvZbTpbNhc̊蓖ĊJnԍ
#define OS_SUBP_LOCK_ID_END     0xaf    //                               蓖ďIԍ
#define OS_SUBP_DBG_LOCK_ID     0xb0    //                               fobK\ԍ
#define OS_SUBP_SYSTEM_LOCK_ID  0xbf    //                               VXe\ԍ

#define OS_LOCK_SUCCESS         0       // bN
#define OS_LOCK_ERROR           -1      // bNG[

#define OS_UNLOCK_SUCCESS       0       // bN
#define OS_UNLOCK_ERROR         -2      // bNG[

#define OS_LOCK_FREE            0       // bN

#define OS_LOCK_ID_ERROR        -3      // bNhcG[



;-----------------------------------------------------------------------
;           bN֐̏
;-----------------------------------------------------------------------

    .EXTERN OS_InitLock

;-----------------------------------------------------------------------
;           bNID̊l
;-----------------------------------------------------------------------

    .EXTERN OS_GetLockID


;-----------------------------------------------------------------------
;           XsbNi[h^oCgj
;-----------------------------------------------------------------------

    .EXTERN OS_LockWord
    .EXTERN OS_LockByte

    .EXTERN OS_LockCard
    .EXTERN OS_LockCartridge
    .EXTERN OS_LockWramBlock0
    .EXTERN OS_LockWramBlock1
    .EXTERN OS_LockVramC
    .EXTERN OS_LockVramD

    .EXTERN OS_LockSendFifo


;-----------------------------------------------------------------------
;           bN̉i[h^oCgj
;-----------------------------------------------------------------------

    .EXTERN OS_UnLockWord
    .EXTERN OS_UnLockByte

    .EXTERN OS_UnLockCard
    .EXTERN OS_UnLockCartridge
    .EXTERN OS_UnLockWramBlock0
    .EXTERN OS_UnLockWramBlock1
    .EXTERN OS_UnLockVramC
    .EXTERN OS_UnLockVramD

    .EXTERN OS_UnLockSendFifo


;-----------------------------------------------------------------------
;           bN̎si[h^oCgj
;-----------------------------------------------------------------------

    .EXTERN OS_TryLockWord
    .EXTERN OS_TryLockByte

    .EXTERN OS_TryLockCard
    .EXTERN OS_TryLockCartridge
    .EXTERN OS_TryLockWramBlock0
    .EXTERN OS_TryLockWramBlock1
    .EXTERN OS_TryLockVramC
    .EXTERN OS_TryLockVramD

    .EXTERN OS_TryLockSendFifo


;-----------------------------------------------------------------------
;           bNtO̓ǂݍ݁i[h^oCgj
;-----------------------------------------------------------------------

    .EXTERN OS_ReadLockWord
    .EXTERN OS_ReadLockByte


;-----------------------------------------------------------------------
;           bNϐ̏LW[ID̓ǂݍ݁i[h^oCgj
;-----------------------------------------------------------------------

    .EXTERN OS_ReadOwnerOfLockWord
    .EXTERN OS_ReadOwnerOfLockByte



;=======================================================================
;           vOXe[^XWX^
;=======================================================================

;-----------------------------------------------------------------------
;           vOXe[^XWX^ Zbgir0=p[^j
;-----------------------------------------------------------------------

    .EXTERN OS_SetCpsr

;-----------------------------------------------------------------------
;           JgEvOXe[^XWX^l l
;-----------------------------------------------------------------------

    .EXTERN OS_GetCpsr

;-----------------------------------------------------------------------
;           hqp Cl[u^fBZ[u
;-----------------------------------------------------------------------

    .EXTERN OS_EnableCpsrIRQ
    .EXTERN OS_DisableCpsrIRQ

;-----------------------------------------------------------------------
;           ehphqp Cl[u^fBZ[u
;-----------------------------------------------------------------------

    .EXTERN OS_EnableCpsrFIQ_IRQ
    .EXTERN OS_DisableCpsrFIQ_IRQ



#endif  // _IRIS_SUBP_OS_H
